/**
 * Define the exit command.
 */

package extensions.generic;

import extensions.generic.*;
import java.util.HashMap;
import java.awt.*;
import javax.media.j3d.*;
import javax.vecmath.*;

public class AxisOffCmd implements Command {
	private HashMap axisData;
	private MenuItem AxisOffmi;
	private MenuItem AxisOnmi;
	
	public AxisOffCmd(HashMap axisData, MenuItem AxisOffmi, MenuItem AxisOnmi) {
		this.axisData = axisData;
		this.AxisOffmi = AxisOffmi;
		this.AxisOnmi = AxisOnmi;		
	}
		
    public void Execute(){
    
      AxisOnmi.setEnabled(true);
      AxisOffmi.setEnabled(false);    	
    	
      extensions.generic.AxisObject axis = (extensions.generic.AxisObject)axisData.get("axis");
      Shape3D textx = (Shape3D)axisData.get("X");
      Shape3D texty = (Shape3D)axisData.get("Y");
      Shape3D textz = (Shape3D)axisData.get("Z");

	  if(axis.numGeometries() == 1){ 
	    axisData.put("axisgeom", axis.getGeometry());
	    axisData.put("textxgeom", textx.getGeometry());
	    axisData.put("textygeom", texty.getGeometry());
	    axisData.put("textzgeom", textz.getGeometry());
	  
	    axis.removeGeometry(0);
	    textx.removeGeometry(0);
	    texty.removeGeometry(0);
	    textz.removeGeometry(0);
	  }				
	  else System.out.println("Geometry is NOT existed!!!!");
	  
    }
}

