
/* Defining visual Object: Text2D, Sphere, Cylinder
 * Geometry Utilities: calculation of angles, the middle point, length
 * Representation of the Applearance for each visual objects
*/

package extensions.generic;

import java.awt.*;
import javax.media.j3d.*;
import javax.vecmath.*;
import com.sun.j3d.utils.geometry.Text2D;
import com.sun.j3d.utils.geometry.Sphere;
import com.sun.j3d.utils.geometry.Cylinder;
import java.util.HashMap;

   public class renderingObject3D {

	public HashMap hashShape3d;

    //private extensions.generic.AlphaPanel apanel = null;

	public renderingObject3D() {
	 
           hashShape3d = new HashMap();
		   //apanel = new extensions.generic.AlphaPanel();
	}

	/* Displaying the coordinate axis, X,Y,Z */
	public void setText2DRender(String coord, Vector3f position, TransformGroup sceneTG)
 	{

         Shape3D text2d = new Text2D(coord, 
                                      new Color3f(1.0f, 1.0f, 1.0f), 
                                      "Helvetica", 30, Font.PLAIN);
    	 text2d.setCapability( Shape3D.ALLOW_GEOMETRY_READ );
    	 text2d.setCapability( Shape3D.ALLOW_GEOMETRY_WRITE );

	     hashShape3d.put(coord, text2d);
	     Transform3D textTranslation = new Transform3D();
	     textTranslation.setTranslation(position);
	     TransformGroup textTranslationGroup = new TransformGroup(textTranslation);
         textTranslationGroup.setCapability(TransformGroup.ALLOW_TRANSFORM_WRITE);
         textTranslationGroup.setCapability(TransformGroup.ALLOW_TRANSFORM_READ);
         textTranslationGroup.setCapability(Group.ALLOW_CHILDREN_WRITE);
         textTranslationGroup.setCapability(Group.ALLOW_CHILDREN_READ);
         textTranslationGroup.setCapability(Group.ALLOW_CHILDREN_EXTEND);
         textTranslationGroup.setCapability(Node.ALLOW_LOCAL_TO_VWORLD_READ);

	     textTranslationGroup.addChild(text2d);
         String tgtmp = coord+"TG";
	     hashShape3d.put(tgtmp, textTranslationGroup);

	     sceneTG.addChild(textTranslationGroup);

         Appearance textAppear = text2d.getAppearance();

         // The following 4 lines of code (commented out) make the Text2D object
         // 2-sided.
         // This code depends on the line of code above that sets TextAppear.
         PolygonAttributes polyAttrib = new PolygonAttributes();
         polyAttrib.setCullFace(PolygonAttributes.CULL_NONE);
         polyAttrib.setBackFaceNormalFlip(true);
         textAppear.setPolygonAttributes(polyAttrib);

	}

	/* Render sphere */
	public void setSphereRender(float radius, Color3f appear_index, Vector3d position, 
                                    TransformGroup sceneTG)
	{
	    Sphere sphere = new Sphere(radius); 
        sphere.setCapability(Shape3D.ALLOW_GEOMETRY_WRITE);
        sphere.setCapability(Shape3D.ALLOW_GEOMETRY_READ);
	    
	    Appearance sphereAppear = new Appearance();
	 
	    sphereAppear = createAppearance(appear_index);
	    sphere.setAppearance(sphereAppear);

	    Transform3D sphereTranslation = new Transform3D();
	    sphereTranslation.setTranslation(position);
	    TransformGroup sphereTranslationGroup = new TransformGroup(sphereTranslation);
        sphereTranslationGroup.setCapability(TransformGroup.ALLOW_TRANSFORM_WRITE);
        sphereTranslationGroup.setCapability(TransformGroup.ALLOW_TRANSFORM_READ);
        sphereTranslationGroup.setCapability(Group.ALLOW_CHILDREN_WRITE);
        sphereTranslationGroup.setCapability(Group.ALLOW_CHILDREN_READ);
        sphereTranslationGroup.setCapability(Group.ALLOW_CHILDREN_EXTEND);
        sphereTranslationGroup.setCapability(Node.ALLOW_LOCAL_TO_VWORLD_READ);
        sphereTranslationGroup.setCapability(TransformGroup.ENABLE_PICK_REPORTING);

	    sphereTranslationGroup.addChild(sphere);
	    sceneTG.addChild(sphereTranslationGroup);
	    hashShape3d.put("Sphere", sphereTranslationGroup);    

	}
	
	
	/* Render sphere */
	public void setSphereRenderAnimation(float radius, Color3f appear_index, double[] position, 
                 double[] normalPos, TransformGroup sceneTG, BranchGroup bg)
	{
    
        Transform3D t3d = new Transform3D();
        TransformGroup sphereTranslationGroup = new TransformGroup(t3d);
        sphereTranslationGroup.setCapability(TransformGroup.ALLOW_TRANSFORM_WRITE);
        sphereTranslationGroup.setCapability(TransformGroup.ALLOW_TRANSFORM_READ);
        sphereTranslationGroup.setCapability(Group.ALLOW_CHILDREN_WRITE);
        sphereTranslationGroup.setCapability(Group.ALLOW_CHILDREN_READ);
        sphereTranslationGroup.setCapability(Group.ALLOW_CHILDREN_EXTEND);
        sphereTranslationGroup.setCapability(Node.ALLOW_LOCAL_TO_VWORLD_READ);
        sphereTranslationGroup.setCapability(TransformGroup.ENABLE_PICK_REPORTING);        
        sceneTG.addChild(sphereTranslationGroup);
             	    
        Switch switchGroup = new Switch();
        switchGroup.setCapability(Switch.ALLOW_SWITCH_READ);
        switchGroup.setCapability(Switch.ALLOW_SWITCH_WRITE);
        sphereTranslationGroup.addChild(switchGroup);
                	
	    Vector3d pos = new Vector3d(position[0], position[1], position[2]);
	    Vector3d pos1 = new Vector3d(normalPos[0], normalPos[1], normalPos[2]);
	    
        switchGroup.addChild( createSphere(radius, appear_index, pos) );
        switchGroup.addChild( createSphere(radius, appear_index, pos1) );	            
    	    
        //For animation, set variable
        Alpha alpha = new Alpha(-1, 2000);
        
        SwitchValueInterpolator svani =
               new SwitchValueInterpolator( alpha, switchGroup,0,2);
        svani.setSchedulingBounds(new BoundingSphere(new Point3d(), 100.0));
        bg.addChild(svani);
        	              
	    //sceneTG.addChild(sphereTranslationGroup);
	    hashShape3d.put("Sphere", sphereTranslationGroup);
	    hashShape3d.put("SAnimation", svani);
        svani.setEnable(true);

	}	
	
	
	private TransformGroup createSphere(float radius, Color3f appear_index, Vector3d position) {
  
        Transform3D t3d = new Transform3D();
        t3d.setTranslation(position);
        
        TransformGroup spheretrans = new TransformGroup(t3d);
        spheretrans.setCapability(TransformGroup.ALLOW_TRANSFORM_WRITE);
        spheretrans.setCapability(TransformGroup.ALLOW_TRANSFORM_READ);
        spheretrans.setCapability(Group.ALLOW_CHILDREN_WRITE);
        spheretrans.setCapability(Group.ALLOW_CHILDREN_READ);
        spheretrans.setCapability(Group.ALLOW_CHILDREN_EXTEND);
        spheretrans.setCapability(Node.ALLOW_LOCAL_TO_VWORLD_READ);
        spheretrans.setCapability(TransformGroup.ENABLE_PICK_REPORTING);

		//Appearance setting
	    Appearance sphereAppear = new Appearance();	 
	    sphereAppear = createAppearance(appear_index);

        Sphere sphere = new Sphere(radius);
        sphere.setCapability(Shape3D.ALLOW_GEOMETRY_WRITE);
        sphere.setCapability(Shape3D.ALLOW_GEOMETRY_READ);
	    sphere.setAppearance(sphereAppear);

        spheretrans.addChild(sphere);
        return spheretrans;
    }
  
	/* Render cylinder */
	public void setCylinderRender(float radius, Color3f appear_index,
                      HashMap data, TransformGroup sceneTG)
	{					    
		float height = (float)((Double)data.get("length")).doubleValue();
	 	double thetaz = ((Double)data.get("thetaz")).doubleValue();
	 	double thetay = ((Double)data.get("thetay")).doubleValue();
        Vector3d position = (Vector3d)data.get("position");
		
	    Cylinder cylinder = new Cylinder(radius, height); 
	    Appearance cylinderAppear = new Appearance();
	 
	    cylinderAppear = createAppearance(appear_index);
	    cylinder.setAppearance(cylinderAppear);

	    Transform3D cylinderTranslation = new Transform3D();
	    cylinderTranslation.setTranslation(position);
	    TransformGroup cylinderTranslationGroup = new TransformGroup(cylinderTranslation);
        cylinderTranslationGroup.setCapability(TransformGroup.ALLOW_TRANSFORM_WRITE);
        cylinderTranslationGroup.setCapability(TransformGroup.ALLOW_TRANSFORM_READ);
        cylinderTranslationGroup.setCapability(Group.ALLOW_CHILDREN_WRITE);
        cylinderTranslationGroup.setCapability(Group.ALLOW_CHILDREN_READ);
        cylinderTranslationGroup.setCapability(Group.ALLOW_CHILDREN_EXTEND);
        cylinderTranslationGroup.setCapability(Node.ALLOW_LOCAL_TO_VWORLD_READ);
        cylinderTranslationGroup.setCapability(TransformGroup.ENABLE_PICK_REPORTING);
	    hashShape3d.put("Cylinder", cylinderTranslationGroup);    

        //BoundingSphere bounds1 = new BoundingSphere(new Point3d(0.0,0.0,0.0), 100.0f);
    
	    Transform3D cylinderrot = new Transform3D();
	    cylinderrot.rotX(thetaz);

	    Transform3D cylinderrot1 = new Transform3D();
	    cylinderrot1.rotY(thetay);
	    
	    cylinderrot1.mul(cylinderrot);

	    TransformGroup cylinderGroup = new TransformGroup(cylinderrot1);
	
	    cylinderTranslationGroup.addChild(cylinderGroup);
	    cylinderGroup.addChild(cylinder);
	    sceneTG.addChild(cylinderTranslationGroup);

	}

	/* Rendering bars */
	public void renderingBar(float radius, Color3f appear_index, double[] carbon, double[] hydrogen, TransformGroup sceneTG)
	{
		HashMap org = renderingBarCalc(carbon, hydrogen);
      	setCylinderRender(radius,appear_index,org,sceneTG);	
	}


	/* Render cylinder */
	public void setCylinderRenderAnimation(float radius, Color3f appear_index,
                      HashMap org, HashMap norm, 
                      TransformGroup sceneTG, BranchGroup bg)
	{     
	    Transform3D cylinderTranslation = new Transform3D();
	    TransformGroup cylinderTranslationGroup = new TransformGroup(cylinderTranslation);
        cylinderTranslationGroup.setCapability(TransformGroup.ALLOW_TRANSFORM_WRITE);
        cylinderTranslationGroup.setCapability(TransformGroup.ALLOW_TRANSFORM_READ);
        cylinderTranslationGroup.setCapability(Group.ALLOW_CHILDREN_WRITE);
        cylinderTranslationGroup.setCapability(Group.ALLOW_CHILDREN_READ);
        cylinderTranslationGroup.setCapability(Group.ALLOW_CHILDREN_EXTEND);
        cylinderTranslationGroup.setCapability(Node.ALLOW_LOCAL_TO_VWORLD_READ);
        cylinderTranslationGroup.setCapability(TransformGroup.ENABLE_PICK_REPORTING);
	    sceneTG.addChild(cylinderTranslationGroup);	    
	        
        Switch switchGroup = new Switch();
        switchGroup.setCapability(Switch.ALLOW_SWITCH_READ);
        switchGroup.setCapability(Switch.ALLOW_SWITCH_WRITE);
        cylinderTranslationGroup.addChild(switchGroup);

        switchGroup.addChild( createCylinder(radius, appear_index, org) );
        switchGroup.addChild( createCylinder(radius, appear_index, norm) );	            
    	    
        //For animation, set variable
        Alpha alpha = new Alpha(-1, 2000);
        
        SwitchValueInterpolator svani =
               new SwitchValueInterpolator( alpha, switchGroup,0,2);
        svani.setSchedulingBounds(new BoundingSphere(new Point3d(), 100.0));
        bg.addChild(svani);        	              
        svani.setEnable(true);
        
	    hashShape3d.put("Cylinder", cylinderTranslationGroup);        
        hashShape3d.put("CAnimation", svani);

	}
	
	private TransformGroup createCylinder(float radius, Color3f appear_index,
					HashMap data) {
  
	    Transform3D cylinderTranslation = new Transform3D();
	    Vector3d position = (Vector3d)data.get("position");
	    
	    cylinderTranslation.setTranslation(position);
	    TransformGroup cylinderTranslationGroup = new TransformGroup(cylinderTranslation);
        cylinderTranslationGroup.setCapability(TransformGroup.ALLOW_TRANSFORM_WRITE);
        cylinderTranslationGroup.setCapability(TransformGroup.ALLOW_TRANSFORM_READ);
        cylinderTranslationGroup.setCapability(Group.ALLOW_CHILDREN_WRITE);
        cylinderTranslationGroup.setCapability(Group.ALLOW_CHILDREN_READ);
        cylinderTranslationGroup.setCapability(Group.ALLOW_CHILDREN_EXTEND);
        cylinderTranslationGroup.setCapability(Node.ALLOW_LOCAL_TO_VWORLD_READ);
        cylinderTranslationGroup.setCapability(TransformGroup.ENABLE_PICK_REPORTING);

		//Appearance setting
	    Appearance cylinderAppear = new Appearance();	 
	    cylinderAppear = createAppearance(appear_index);		

		float height = (float)((Double)data.get("length")).doubleValue();
	    Cylinder cylinder = new Cylinder(radius, height); 
        cylinder.setCapability(Shape3D.ALLOW_GEOMETRY_WRITE);
        cylinder.setCapability(Shape3D.ALLOW_GEOMETRY_READ);
	    cylinder.setAppearance(cylinderAppear);
    
	 	double thetaz = ((Double)data.get("thetaz")).doubleValue();
	 	double thetay = ((Double)data.get("thetay")).doubleValue();
	 
	    Transform3D cylinderrot = new Transform3D();
	    cylinderrot.rotX(thetaz);

	    Transform3D cylinderrot1 = new Transform3D();
	    cylinderrot1.rotY(thetay);
	    
	    cylinderrot1.mul(cylinderrot);

	    TransformGroup cylinderGroup = new TransformGroup(cylinderrot1);
	
	    cylinderTranslationGroup.addChild(cylinderGroup);
	    cylinderGroup.addChild(cylinder);
	    
	    return cylinderTranslationGroup;

    }	

	/* Rendering bars */
	public void renderingBarAnimation(float radius, Color3f appear_index, 
	           double[] orgdata, double[] orgdata1, 
	           double[] normdata, double[] normdata1,
	           TransformGroup sceneTG, BranchGroup bg)
	{
		HashMap org = renderingBarCalc(orgdata, orgdata1);
		HashMap norm = renderingBarCalc(normdata, normdata1);		
      	setCylinderRenderAnimation(radius,appear_index,org,norm,sceneTG,bg);	
	}

	/* Rendering bars Calculation*/
	public HashMap renderingBarCalc(double[] coorddata1, double[] coorddata2)
	{
	    double chlength=0.0;
	    double[] chmidpoint=new double[3];
	    double thetaz=0.0;
	    double thetay=0.0;
	    double thetapai=0.0;
	    Vector3d cylinderposition = new Vector3d();
	    HashMap store = new HashMap();

	    chlength = getLength(coorddata1,coorddata2);
	    store.put("length", new Double(chlength));
	    		
	    chmidpoint = getMidPoint(coorddata1,coorddata2);

	    if((chmidpoint[1] == 0.0) || (chmidpoint[2] == 0.0))
	        thetaz = thetaAngle(coorddata1[1], chmidpoint[1], chlength);
	    else if (chmidpoint[2] > coorddata1[2])
	            thetaz = 2.0*Math.PI - thetaAngle(coorddata1[1],chmidpoint[1],chlength);
	    else thetaz = thetaAngle(coorddata1[1],chmidpoint[1],chlength);
	    store.put("thetaz", new Double(thetaz));	   
	    
	    if((coorddata1[0] - chmidpoint[0]) == 0.0 && (coorddata1[2] - chmidpoint[2]) == 0.0)
		  thetapai = 0.0;
	    else
	      thetapai = Math.atan((coorddata1[0] - chmidpoint[0]) / (coorddata1[2] - chmidpoint[2]));

	    thetay = thetapai;
		store.put("thetay", new Double(thetay));
		
      	cylinderposition = new Vector3d(chmidpoint[0],chmidpoint[1],chmidpoint[2]);
      	store.put("position", cylinderposition);
      	
      	return store;
	}

	/* the length between two points */
	public double getLength(double[] point3d1, double[] point3d2)
	{
	    double length;
	    
            length = (point3d1[0] - point3d2[0])*(point3d1[0] - point3d2[0]) +
		       (point3d1[1] - point3d2[1])*(point3d1[1] - point3d2[1]) + 
                       (point3d1[2] - point3d2[2])*(point3d1[2] - point3d2[2]);

	    return Math.sqrt(length);
	}

	/*the center point between two points */
	public double[] getMidPoint(double[] point3d1, double[] point3d2)
 	{
	   double[] midpoint = new double[3];

	
	    midpoint[0] = (point3d1[0] + point3d2[0])/2.0;
	    midpoint[1] = (point3d1[1] + point3d2[1])/2.0;
	    midpoint[2] = (point3d1[2] + point3d2[2])/2.0; 
	
	    return midpoint;
	}

        /* X-axis rotation angle */
	public double thetaAngle(double targetY, double originY, double length)
	{
	    return Math.acos((targetY - originY)/(length/2.0));
	}

        /* Material(ambientColor,emissiveColor, diffuseColor, specularColor, shininess)
        */

	public Appearance createAppearance(Color3f objColor)
	{
	    Appearance app = new Appearance();

	    // Globally used colors
	    Color3f black = new Color3f(0.0f, 0.0f, 0.0f);
	    Color3f white = new Color3f(1.0f, 1.0f, 1.0f);

	    // Set up the material properties
	    //Color3f objColor = new Color3f(0.0f, 1.0f, 0.0f);
	    app.setMaterial(new Material(objColor, black, objColor,
					     white, 80.0f));

	    return app;
	}

/*
        public Appearance createAppearance(int idx) {
	    Appearance app = new Appearance();

	    // Globally used colors
	    Color3f black = new Color3f(0.0f, 0.0f, 0.0f);
	    Color3f white = new Color3f(1.0f, 1.0f, 1.0f);

	    switch (idx) {
	    // Unlit solid
	    case 0:
	    {
		// Set up the coloring properties
		Color3f objColor = new Color3f(1.0f, 0.2f, 0.4f);
		ColoringAttributes ca = new ColoringAttributes();
		ca.setColor(objColor);
		app.setColoringAttributes(ca);
		break;
	    }

	    // Unlit wire frame
	    case 1:
	    {
		// Set up the coloring properties
		Color3f objColor = new Color3f(0.5f, 0.0f, 0.2f);
		ColoringAttributes ca = new ColoringAttributes();
		ca.setColor(objColor);
		app.setColoringAttributes(ca);

		// Set up the polygon attributes
		PolygonAttributes pa = new PolygonAttributes();
		pa.setPolygonMode(pa.POLYGON_LINE);
		pa.setCullFace(pa.CULL_NONE);
		app.setPolygonAttributes(pa);
		break;
	    }

	    // Unlit points
	    case 2:
	    {
		// Set up the coloring properties
		Color3f objColor = new Color3f(0.2f, 0.2f, 1.0f);
		ColoringAttributes ca = new ColoringAttributes();
		ca.setColor(objColor);
		app.setColoringAttributes(ca);

		// Set up the polygon attributes
		PolygonAttributes pa = new PolygonAttributes();
		pa.setPolygonMode(pa.POLYGON_POINT);
		pa.setCullFace(pa.CULL_NONE);
		app.setPolygonAttributes(pa);

		// Set up point attributes
		PointAttributes pta = new PointAttributes();
		pta.setPointSize(5.0f);
		app.setPointAttributes(pta);
		break;
	    }

	    // Lit solid
	    case 3:
	    {
		// Set up the material properties
		Color3f objColor = new Color3f(0.0f, 1.0f, 0.0f);
		app.setMaterial(new Material(objColor, black, objColor,
					     white, 80.0f));
		break;
	    }

	    // Transparent, lit solid
	    case 4:
	    {
		// Set up the transparency properties
		TransparencyAttributes ta = new TransparencyAttributes();
		ta.setTransparencyMode(ta.BLENDED);
		ta.setTransparency(0.6f);
		app.setTransparencyAttributes(ta);

		// Set up the polygon attributes
		PolygonAttributes pa = new PolygonAttributes();
		pa.setCullFace(pa.CULL_NONE);
		app.setPolygonAttributes(pa);

		// Set up the material properties
		Color3f objColor = new Color3f(0.9f, 0.1f, 0.0f);
		app.setMaterial(new Material(objColor, black, objColor,
					     white, 80.0f));
		break;
	    }

	    // Lit solid, specular only
	    case 5:
	    {
		// Set up the material properties
		Color3f objColor = new Color3f(0.9f, 0.1f, 0.0f);
		app.setMaterial(new Material(objColor, black, objColor,
					     white, 80.0f));
		break;
	    }

	    // Another lit solid with a different color
	    case 6:
	    {
		// Set up the material properties
		Color3f objColor = new Color3f(1.0f, 0.0f, 1.0f);
		app.setMaterial(new Material(objColor, black, objColor,
					     white, 80.0f));
		break;
	    }

	    default:
	    {
		ColoringAttributes ca = new ColoringAttributes();
		ca.setColor(new Color3f(0.0f, 1.0f, 0.0f));
		app.setColoringAttributes(ca);
	    }
	}

	return app;
    }
*/

  }