/**
 * Program: moduleServerBean.java
 * 
 * Comments: This is based on the old ServerServlet.java program.  This 
 * creates all of the modules that the user will need 
 * and provides accessor methods for them.
 * 
 * This Bean will usually need at least session scope so that it lives
 * between pages.
 *
 * @author Marlon Pierce
 */

package extensions.generic;

import WebFlow.*;
import WebFlow.event.*;
import WebFlow.hashtable.*;
import WebFlow.ContextManager.*;
import WebFlow.FB.*;
import WebFlow.RemoteFile.*;
import WebFlow.submitJob.*;
import WebFlow.Charon.*;
import WebFlow.SerialHash.*;

import org.omg.CORBA.*;
//import orbasec.corba.Opaque;
import java.io.*;
import java.util.*;
import java.net.*;

public class moduleServerBean {

    org.omg.CORBA.Object o_base;
    public static ORB orb;
    public static BOA boa;
    public static WebFlowContext master,jspClient;
    public static CharonServer charon;
    String[] args;
    String IorUrl;

    private org.omg.CORBA.Object m1,m2,m3,m4,m5,m6,m7,m8,m9;
    private ContextManager cm;
    private ContextData cd;
    private SaveContext sc;
    private RemoteFile rf;
    private submitJob sj;
    private FBServer fb;
    private SerialHash sh;

    //slave Webflow Server
    public static WebFlowContext slaveWFC, slavejspClient;
    private ContextManager slavecm;
    private ContextData slavecd;
    private SaveContext slavesc;
    private RemoteFile slaverf;
    private submitJob slavesj;
    private FBServer slavefb;
    private SerialHash slavesh;

    ////////////////////Added///////////////////////
    //org.omg.SecurityLevel2.SecurityManager security_manager=null;
    ////////////////////Added///////////////////////

    /**
     * Constructor with no argument
     */
    public moduleServerBean(){
	//args is a placebo for orb initialization.
	args=new String[1];
	args[0]="test";
    }
    
    /**
     * Initialize everything
     */

    public void init(String ior) {
	IorUrl=ior;
	//Get the config file.
	String confFile=null;
	String userDir=null;
	String userName=null;

	//slave WebFlow Server variable
	String slaveuserDir=null;
	String masterID=null;
	String slaveID=null;

	java.util.Properties props=new Properties();
	String propFile="/home/scri97/users/cyoun/birch/GATEWAY/apache1.3.12/WWW/GOW/WEB-INF/src/BeanContext_2.2.3/Control/GOW.properties";
	
	try{
	    props.load(new FileInputStream(propFile));
	    //confFile=props.getProperty("ConfigFile");
	    userDir=props.getProperty("descDir");
	    userName=props.getProperty("userName");

	    //slave webflow server
	    slaveuserDir = props.getProperty("slavedescDir");
	    slaveID = props.getProperty("slaveID");

	}
	catch(Exception ex) {
	    ex.printStackTrace();
	}

	//Creates the master server and the jspClient context.
	String masterIOR=WebFlow.ClientUtils.getIORFromURL(IorUrl);	
	orb=WebFlow.ClientUtils.initializeORB(masterIOR,orb);
	master=WebFlow.ClientUtils.getMasterServer(masterIOR,orb);

	try {
	    jspClient=
	      WebFlowContextHelper.narrow(master.addNewContext("JSPClient"));
	}
	catch(Exception e) {
	    System.err.println("Unable to create JSPClient Context");
	    e.printStackTrace();
	}

	//Now attach all of the modules to the jspClient context.
	
	m1 = jspClient.addNewModule("ContextData");
	cd  = ContextDataHelper.narrow(m1);
	cd.test();
	
	System.out.println("attach SaveContext"); 
	
	m2 = jspClient.addNewModule("SaveContext");
	sc  = SaveContextHelper.narrow(m2);
	sc.test();
	
	System.out.println("attach ContextManager"); 
	
	m3 = jspClient.addNewModule("ContextManager");
	cm  = ContextManagerHelper.narrow(m3);
	cm.test();
	
	System.out.println("attach RemoteFile"); 
	
	m5 = jspClient.addNewModule("RemoteFile");
	rf  = RemoteFileHelper.narrow(m5);
	rf.test();
	
	System.out.println("attach submitJob");
	m6=jspClient.addNewModule("submit");
	sj=submitJobHelper.narrow(m6);
	sj.test();
	
	System.out.println("attach FileBrowser");
	m7=jspClient.addNewModule("FileBrowser");
	fb=FBServerHelper.narrow(m7);
	fb.test();
	
	System.out.println("attach SerialHash");
	m8=jspClient.addNewModule("SerialHash");
	sh=SerialHashHelper.narrow(m8);
	sh.test();
	
	cm.init(jspClient,m2,m5);

	//String userDir="/app/gateway/apache/htdocs/GOW/WEB-INF/Descriptors/users/JSPClient/";
	//String userName="pierceme";
	
	if(!cm.setUserContextData(jspClient,userDir,userName)) {
	    //Restore ContextData
	    //read contents of the masterServerData
	    
	    String rootDir = userDir + "/" + userName;
	    sc.readContextData(jspClient,rootDir);
	    
	    System.out.println("now restore contexts");
	    restoreChildren(jspClient);
	}

	//slave webflow server
	masterID = master.getObjectID();
	slaveWFC = WebFlowContextHelper.narrow(master.getContext(masterID+"/"+slaveID));
	
	try {
	    slavejspClient=
	     WebFlowContextHelper.narrow(slaveWFC.addNewContext("JSPClient"));
	}
	catch(Exception e1) {
	    System.err.println("Unable to create JSPClient Context for slave server");
	    e1.printStackTrace();
	}

	//slave WebFlow Server
	//Now attach all of the modules to the jspClient context.
	
	m1 = slavejspClient.addNewModule("ContextData");
	slavecd  = ContextDataHelper.narrow(m1);
	slavecd.test();
	
	System.out.println("attach SaveContext for slave webflow server"); 
	
	m2 = slavejspClient.addNewModule("SaveContext");
	slavesc  = SaveContextHelper.narrow(m2);
	slavesc.test();
	
	System.out.println("attach ContextManager for slave webflow server"); 
	
	m3 = slavejspClient.addNewModule("ContextManager");
	slavecm  = ContextManagerHelper.narrow(m3);
	slavecm.test();
	
	System.out.println("attach RemoteFile for slave webflow server"); 
	
	m5 = slavejspClient.addNewModule("RemoteFile");
	slaverf  = RemoteFileHelper.narrow(m5);
	slaverf.test();
	
	System.out.println("attach submitJob for slave webflow server");
	m6=slavejspClient.addNewModule("submit");
	slavesj=submitJobHelper.narrow(m6);
	slavesj.test();
	
	System.out.println("attach FileBrowser for slave webflow server");
	m7=slavejspClient.addNewModule("FileBrowser");
	slavefb=FBServerHelper.narrow(m7);
	slavefb.test();
	
	System.out.println("attach SerialHash for slave webflow server");
	m8=slavejspClient.addNewModule("SerialHash");
	slavesh=SerialHashHelper.narrow(m8);
	slavesh.test();
	
	slavecm.init(slavejspClient,m2,m5);

	if(!slavecm.setUserContextData(slavejspClient,slaveuserDir,userName)) {
	    //Restore ContextData
	    //read contents of the masterServerData
	    
	    String rootDir = slaveuserDir + "/" + userName;
	    slavesc.readContextData(slavejspClient,rootDir);
	    
	    System.out.println("now restore contexts for slave webflow server");
	    restoreChildrenForSlave(slavejspClient);
	}
	
	System.out.println("ServerServlet is initialized");
    }

    public void restoreChildren(WebFlowContext context) {
	System.out.println("starting restoration ...");
        if(cm==null) System.out.println("cm is null"); 
        if(context==null) System.out.println("context is null"); 
	String children=cm.getContextData(context,"Children");
	System.err.println("children: "+children); 
	String pDir=cm.getContextData(context,"Directory");
	System.err.println("directory: "+pDir); 
	if(children.equals("null")) { 
	    // no more children: job done
	    System.out.println("no more children: job done");
	    return;
	}
	else {
	    //Children are in format:  name1+name2+name3
	    StringTokenizer st = new StringTokenizer(children,"+");
	    while(st.hasMoreTokens()) {
		System.out.println("has more tokens");
		String Child = st.nextToken();
		System.err.println("restore context "+Child);
		// create an empty context and put ContextData module to it
		WebFlowContext cc = restoreContext(context,Child);
		// a context name may have a suffix: .PC, .SC, or .AC. strip it
		String cDir = Child;
		int idx = Child.lastIndexOf(".");
		if(idx>-1) {
		    cDir = Child.substring(0,idx); 
		}  
		cDir = pDir+File.separator + cDir;
		System.out.println("cDir="+cDir);  
		sc.readContextData(cc,cDir);
		restoreChildren(cc);
	    }
	}
    }

    public void restoreChildrenForSlave(WebFlowContext context) {
	System.out.println("starting restoration ...for slave");
        if(slavecm==null) System.out.println("slavecm is null"); 
        if(context==null) System.out.println("slave_context is null"); 
	String children=slavecm.getContextData(context,"Children");
	System.err.println("slave_children: "+children); 
	String pDir=slavecm.getContextData(context,"Directory");
	System.err.println("slave_directory: "+pDir); 
	if(children.equals("null")) { 
	    // no more children: job done
	    System.out.println("no more children: job done for slave");
	    return;
	}
	else {
	    //Children are in format:  name1+name2+name3
	    StringTokenizer st = new StringTokenizer(children,"+");
	    while(st.hasMoreTokens()) {
		System.out.println("has more tokens for slave");
		String Child = st.nextToken();
		System.err.println("restore context for slave"+Child);
		// create an empty context and put ContextData module to it
		WebFlowContext cc = restoreContext(context,Child);
		// a context name may have a suffix: .PC, .SC, or .AC. strip it
		String cDir = Child;
		int idx = Child.lastIndexOf(".");
		if(idx>-1) {
		    cDir = Child.substring(0,idx); 
		}  
		cDir = pDir+File.separator + cDir;
		System.out.println("slave_cDir="+cDir);  
		slavesc.readContextData(cc,cDir);
		restoreChildrenForSlave(cc);
	    }
	}
    }
    
    public WebFlowContext restoreContext(WebFlowContext p, String name){
	try {
	    WebFlowContext c=
		WebFlowContextHelper.narrow(p.addNewContext(name));
	    if(c==null) System.out.println("c is null");
	    ContextData cdm=
		ContextDataHelper.narrow(c.addNewModule("ContextData"));
	    if(cdm==null) System.out.println("--->cd is null");
	    return c;
	} catch (Exception e) {
	    System.out.println(e +"while createGatewayContext");
	    return null;
	}  
    }

    /**
     * Now define all of the accessor methods that we will need.
     */
    public ContextManager getContextManager() { return cm; }
    public FBServer getFileBrowser() { return fb; }
    public RemoteFile getRemoteFile() { return rf; }
    public SerialHash getSerialHash() { return sh; }
    public submitJob getSubmitJob() { return sj; }
    public String getIorUrl() { return IorUrl; }

    /**
     * slave WebFlow Server
     * Now define all of the accessor methods that we will need.
     */
    public ContextManager getContextManagerForSlave() { return slavecm; }
    public FBServer getFileBrowserForSlave() { return slavefb; }
    public RemoteFile getRemoteFileForSlave() { return slaverf; }
    public SerialHash getSerialHashForSlave() { return slavesh; }
    public submitJob getSubmitJobForSlave() { return slavesj; }

}
