/**
 * This file extracts parameter values of the XSIL Viz tag.
 */ 
package extensions.generic;
import org.escience.XSIL.*;
import java.util.*;

public class parseXMLViz extends XSIL {

    //public String vizname;
    //public String vizpath;
    public String vizhostname;
    public Hashtable paramHash=new Hashtable();    //a hashtable to hold param names/values.
    
    boolean instantiated = false,constructed=false;
    
    public void construct(){	

	for(int ichild=0; ichild < getChildCount(); ichild++){
            XSIL x = getChild(ichild);
            if(x instanceof Param){
		Param p = (Param)x;
		paramHash.put(p.getName(),p.getText());
	    }
	}
	constructed=true;
    }

    // This function does the heavy lifting of reading arrays and so on
    // It is separate from the construction because it is not called 
    // unless necessary.

    public void instantiate(){
	construct();
	instantiated=true;
    }

    /**
     * Returns the hashtable of params and their values.
     */
    public Hashtable getParamHash() {
	if(!constructed) construct();
	return paramHash;
    }
    
    /**
     * Returns the value for the specified parameter.
     */
    public String getTagValue(String paramName) {
	if(!constructed) construct();
	if(paramHash.containsKey(paramName)) {
	    return (String)paramHash.get(paramName);
	}
	else {
	    System.err.println("Parameter not found!");
	    return null;
	}
    }

    public String getVizHost() { 
	if(!constructed) construct();
	return (String)paramHash.get("VizHostName");
    }

    public String getVizName() { 
	if(!constructed) construct();
	return (String)paramHash.get("VizName");
    }

    public String getVizpath() { 
	if(!constructed) construct();
	return (String)paramHash.get("VizPath");
    }
}
