
import java.util.StringTokenizer;

/**
 * Shared Data manager proxy message class.
 *
 * @version     0.94 7 April 1997
 * @author      Rich Burridge
 */

class
RegistryServerMessage extends SharedDataMessage {

    /** Handle to server-side registry object. */
    private Registry registry;

    /** Registry server thread associated with this message. */
    private RegistryServerThread thread;


/**
 * <A NAME="SD_REGISTRYSERVERMESSAGE"></A>
 * <EM>RegistryServerMessage</EM>
 *
 * @param <EM>registry</EM>
 * @param <EM>thread</EM>
 * @param <EM>tok</EM>
 */

    public
    RegistryServerMessage(Registry registry, RegistryServerThread thread) {
        if (RegistryServerMessage_Debug) {
            System.out.println("RegistryServerMessage: constructor:" +
                               " registry: " + registry +
                               " thread: "   + thread);
        }
 
        this.registry = registry;
	this.thread   = thread;
    }


/**
 * <A NAME="SD_HANDLEMESSAGE"></A>
 * <EM>handleMessage</EM>
 *
 * @param <EM>tok</EM>
 */

    protected void
    handleMessage(StringTokenizer tok) {
        String action = null;
        String reply  = null;
        String who    = null;

        if (RegistryServerMessage_Debug) {
            System.out.println("RegistryServerMessage: handleMessage:" +
                               " tok: " + tok);
        }
 
	action = tok.nextToken();
        who    = tok.nextToken();

               if (action.equals(T_Bind)) {
            reply = registry.bind(who, tok.nextToken());
        } else if (action.equals(T_Rebind)) {
            reply = registry.rebind(who, tok.nextToken());
        } else if (action.equals(T_Unbind)) {
            reply = registry.unbind(who, tok.nextToken());
        } else if (action.equals(T_Lookup)) {
            reply = registry.lookup(who, tok.nextToken());
        } else if (action.equals(T_List)) {
            reply = registry.list(who);
        }
 
        if (reply != null) {
            thread.writeLine(null, reply);
        }
    }
}
