
import java.net.Socket;
import java.util.StringTokenizer;

/**
 * Shared Data Registry Server Thread class.
 *
 * @version     0.84 24 October 1996
 * @author      Rich Burridge
 */
 
class
RegistryServerThread extends TCPSocketThread {
 
    /** Handle to server-side registry object. */
    private Registry registry;


/**
 * <A NAME="SD_REGISTRYSERVERTHREAD"></A>
 * <EM>RegistryServerThread</EM>
 *
 * @param <EM>socket</EM>
 * @param <EM>registry</EM>
 */

    public
    RegistryServerThread(Socket socket, Registry registry) {
        super(socket);

	if (RegistryServerThread_Debug) {
            System.out.println("RegistryServerThread: constructor:" +
			       " socket: "   + socket +
			       " registry: " + registry);
        }

	this.registry = registry;
    }    


/**
 * <A NAME="SD_HANDLEMESSAGE"></A>
 * <EM>handleMessage</EM>
 *
 * @param <EM>message</EM>
 */

    protected void
    handleMessage(String message) {

      message = T_Bind + T_Sep + "admin" + T_Sep + "cyoun";
        StringTokenizer tok = new StringTokenizer(message, T_Sep, false);
	RegistryServerMessage rsm = new RegistryServerMessage(registry, this);

        if (RegistryServerThread_Debug) {
            System.out.println("RegistryServerThread: handleMessage:" +
                               " message: " + message);
        }
 
        rsm.handleMessage(tok);
    }
}
