import ice.storm.*;
import java.awt.*;
import java.awt.event.*;
import java.beans.*;

import org.w3c.dom.*;
import org.w3c.dom.html.*;
import org.w3c.dom.events.*;

// HTML4 pilot, doc, DOM impl
import ice.pilots.html4.*;

import java.net.*;

import java.util.Hashtable;
import java.io.*;

public class BrowserFrame extends Frame implements
			ActionListener, 
			WindowListener, 
			PropertyChangeListener {

  private StormBase base;
  private String viewportId;
  private Panel panel;
  
  private TextField loc;
  private Button back, forward;
  private Label status;
  boolean controlFlag = false;
  InetAddress shost;
  int         sport;

  public BrowserFrame(StormBase b, Viewport viewport) {
    super("Storm - "+viewport.getName());
    this.base=b;
    this.viewportId=viewport.getId();
    setLayout(new BorderLayout());

    addWindowListener(this);

    base.addPropertyChangeListener(this,viewportId);

    Font f = new Font("SansSerif",Font.PLAIN,12);
    
    back = new Button("back");
    back.setFont(f);
    back.setBackground(Color.lightGray);
    back.addActionListener(this);
    forward = new Button("forward");
    forward.setFont(f);
    forward.setBackground(Color.lightGray);
    forward.addActionListener(this);
    
    loc = new TextField("",100);
    loc.setFont(f);
    loc.setBackground(Color.white);
    loc.setForeground(Color.black);
    loc.addActionListener(this);

    status = new Label("SimpleBrowser demo");
    status.setFont(f);
    status.setBackground(Color.lightGray);
    status.setForeground(Color.black);

    // Buttons in a panel
    Panel p = new Panel();
    p.setLayout(new FlowLayout(FlowLayout.LEFT,0,0));
    p.add(back);
    p.add(forward);
    
    // Panel with buttons and location
    Panel p2 = new Panel();
    p2.setBackground(Color.black);
    p2.setLayout(new BorderLayout(0,0));
    p2.add(p,"Center");
    p2.add(loc,"South");
    
    add(p2,"North");

    panel = new Panel();
    panel.setLayout(new BorderLayout(0,0));
    add(panel,"Center");
    
    add(status,"South");
    
    setSize(800,650);
    
    try{
      getHostNamePort();
    }catch(IOException e){
      e.printStackTrace();
    }
    
    
  }

  Panel getPanel() {return panel;}
  
  
  public void actionPerformed(ActionEvent e) {
    
    Object src=e.getSource();
    
    if (src==loc) {
      String vname=viewportId;
      String str = loc.getText();
      
      base.renderContent(str,null,vname);
    }
    else if (src==back) {
      base.goBack(viewportId);
    }
    else if (src==forward) {
      base.goForward(viewportId);
    }
  }
  
  // PropertyChangeListener implementation
  
  public void propertyChange(PropertyChangeEvent e) {
    
    //System.out.println("PropertyChange invoked ..."+controlFlag);
    
    Viewport v = (Viewport)e.getSource();
    boolean isMyView=v.getId().equals(viewportId);
    
    //System.out.println("ViewportID: "+v.getId()+"Bool: "+isMyView);

    String name = e.getPropertyName();
    String evalue = (String)e.getNewValue();
    //System.out.println("Name: "+name);
    //System.out.println("Value: "+evalue);
    
    if (isMyView&&name.equals("title")) {
      setTitle("ICE Storm - "+v.getName()+" - "+e.getNewValue());
      //if(controlFlag) {
      //sendObject((String)e.getNewValue());
      //}
    }
    else if (isMyView && name.equals("location")) {
      loc.setText((String)e.getNewValue());
      System.out.println("Location: "+(String)e.getNewValue());
      if(controlFlag) {
        sendObject((String)e.getNewValue());
      }
    }
    else if (name.equals("statusLine")) {
      status.setText((String)e.getNewValue());
    }
    else if (name.equals("contentLoadingProgress")) {
      try {
        String val = (String)e.getNewValue();
        int idx1=val.indexOf(' ');
        int idx2=val.indexOf(' ',idx1+1);
        
        int l = Integer.parseInt(val.substring(idx1+1,idx2));
        int t = Integer.parseInt(val.substring(idx2+1));
        
        status.setText("loading "+l+" "+t);
        //status.updateProgress(val.substring(0,idx1),l,t);
      }
      catch(Exception ex) {
	//ex.printStackTrace();
        System.out.println("PropertyChange....CallBack");
      }
      
    }
    else if(name.equals("outstandingImages")) {
      
      String val1 = (String)e.getNewValue();
      if (val1.equals("0"))
        status.setText("loading images: done");
      else
        status.setText("loading images: "+val1+" left");      
    }
    else { 
      status.setText(name+": "+(String)e.getNewValue());
    }
  }

  public void getHostNamePort() throws IOException{
    //hardcoding, need improve..................
    shost = InetAddress.getByName("magnolia.csit.fsu.edu");  
    sport = 8585;
  }

  public void sendObject(String data){        
    Socket socket = null;
    BufferedOutputStream ds = null;
    String datatype = null;
    byte[] databyte = null;
    
    try{
      socket = new Socket(shost,sport);
      ds =  new BufferedOutputStream(socket.getOutputStream());
    }catch(Exception e){        
      System.out.println("err");
    }
    
    try{          
      System.out.println("Begin write ...........");
      datatype = "1\n";
      databyte = datatype.getBytes();
      ds.write(databyte, 0, databyte.length);
	    ds.flush();

	    databyte = data.getBytes();
	    ds.write(databyte, 0, databyte.length);
	    ds.flush();    
	    System.out.println("End write");        
	    ds.close();
	    socket.close();
	}catch(Exception e){        
	    e.printStackTrace();
	    System.out.println("err");
	}    
    }
    
// WindowListener implementation (remove this???)
        public void windowClosing(WindowEvent e) {
		base.closeViewport(viewportId);
        }

	public void windowClosed(WindowEvent ev) {}
 	public void windowOpened(WindowEvent ev) {}
	public void windowIconified(WindowEvent ev) {}
	public void windowDeiconified(WindowEvent ev) {}
	public void windowActivated(WindowEvent ev) {}
	public void windowDeactivated(WindowEvent ev) {}
}
