import java.io.*;
import java.net.*;
import java.util.*;

public class ClientRecvChannel extends Thread{

    private ServerSocket sock = null;
    int port;

  static ClientViewer parent;

  /**
   * constructor
   * @param eng parent module(SV2Engine)
   * @param p port for the server socket
   */
  public ClientRecvChannel(ClientViewer pa, String p) {
    parent = pa;
    port = Integer.parseInt(p);

    try {
      sock = new ServerSocket(port);
    } catch(Exception e) { 
      System.err.println("Can't create server socket."+p);
      
      e.printStackTrace();
      //System.exit(1);
    }  
  }

  /**
   * waits for a connection 
   */
  public void run() {
      Vector convec = new Vector();
     
    // continuously listen the socket
    while (true) {
      try {
         Socket incoming = sock.accept();
	
         ClientRecvHandler handler = new ClientRecvHandler(incoming, parent);
         handler.start();
         convec.addElement(handler);

         //clean up the vector if needed
         for (int i=0; i<convec.size(); i++)
           if (!((ClientRecvHandler)(convec.elementAt(i))).isAlive())
             convec.removeElementAt(i);

      } catch(Exception e) {
         System.err.println("Can't accept a connection by server socket.");
         return;
      }
    }
  }

} // end of class
