import java.net.*;
import java.io.*;
import java.util.*;

/**
 * RecvHandler
 * work after getting connection from client or simulation engine
 */

public class RecvHandler extends Thread {

    private Socket socket;
    private BufferedOutputStream out;
    private BufferedReader in;

    private CollServer server;

    public RecvHandler(Socket socket, CollServer server) {
	this.socket = socket;
	this.server = server;
    }

    /**
     * close the connection
     */
    public void closeConnection() throws IOException {
	in.close();
	out.close();
	socket.close();
    }

    /**
     * read commands from the client and do work
     */
    public void run() {
	String command = null;

	try {
	    out =  new BufferedOutputStream(socket.getOutputStream());
	    in =  new BufferedReader(new 		
		      InputStreamReader(socket.getInputStream()));

	    command = in.readLine();

	    doAction(command);

	    out.close();
	    in.close();
	    socket.close();
	    
	} catch (Exception e) {
	    System.out.println("Server connection error: " + command);

	    try { 
		out.close();
		in.close();
		socket.close(); 
	    } catch (Exception e1) {}
	}
    }

    private synchronized void doAction(String command){

	int comm = Integer.parseInt(command);
	switch(comm) {
	case 0:
	    registerClient();
	    System.out.println("Registering client .....");
	    break;
        
	case 1:
	    getDataAction();
	    System.out.println("getting data from the control client");
	    break;
	    
	default:
	    System.err.println("Got undefined command: " + command);
	}
    }  
    
    private void getDataAction(){
	//receive the data here
	String receivedata = null;
	try {
	    receivedata = in.readLine();
	    System.out.println("the received data: "+receivedata);
	}catch(Exception e) {}

	server.getSender().sendData(receivedata);   
    }
  
    private void registerClient(){

	String port = null;
	try {
	    port = in.readLine();
	    System.out.println("the received data: "+port);
	}catch(Exception e) {}
	int iport = Integer.parseInt(port);
	InetAddress host = socket.getInetAddress();
	server.getSender().addCollaborator(host,iport);
    }
  
} // end of class

