import java.awt.*;
import javax.swing.*;
import WebFlow.submitJob2.*;
import java.io.*;
import java.util.*;

public class crpcSend implements Runnable {

private String file_name;
private boolean debug;
private JTextField status;
private JTextArea resultText;
private JScrollPane sp;
private JViewport vp;
private Point p;
private Dimension d;
private int x,y;

String src = "/home/pse/CRPC/beowulf/";
String dest = "/home/scri97/users/cyoun/birch/XPcrpc/util/data/";
String remotehost = "oscbw.osc.edu";
String user = "pse";
String file_context = null;

//vel file
int vel_size = 1000;
int finish_line = 0;
int previous_vel_count=0;
int[] vel_flag;

//pres file
int finish_line1 = 0;
int previous_pres_count=0;
int[] pres_flag;

//pres file
int finish_line2 = 0;
int previous_conc_count=0;
int[] conc_flag;



    public crpcSend(String file_name, JTextField status, JTextArea resultText, JScrollPane sp,
		    boolean debug) {
	this.file_name = file_name;
	this.status = status;
	this.resultText = resultText;
	this.sp = sp;
	this.debug = debug;

	vp = sp.getViewport();
	p = vp.getViewPosition();
	d = vp.getExtentSize();
	x=p.x;
    }

    public void run(){
	System.out.println("crpcSend Started............") ;
	System.out.println("debug is " + debug) ;
	
//Copying vel* file remotely .....................
	
	if (file_name.equals("vel")) {

	    status.setText("Copying .... vel* ");
	    boolean vel_finish_flag = false;

	    vel_flag = new int[vel_size]; //0:intial, 1:ready to read, 2:read

	    for(int i=0; i < vel_size; i++) vel_flag[i] = 0;

	    rcpFromoscbwToheechee("infile_Movie");

	    while( true ) {

		if ( !vel_finish_flag ) vel_finish_flag = velTypeFileCopy();
		if ( vel_finish_flag ) break;

	    } //while outer
	    if (debug) System.out.println("Copy is Done for vel* file Remotely");
	    resultText.append("Copy is Done for vel* file Remotely");
	} //if (vel parameter check

	else if (file_name.equals("pres")) {

	    status.setText("Copying .... pres* ");
 	    boolean pres_finish_flag = false;

	    pres_flag = new int[vel_size];

	    for(int i=0; i < vel_size; i++) pres_flag[i] = 0;	 

	    while( true ) {

 		if ( !pres_finish_flag ) pres_finish_flag = presTypeFileCopy();
		if ( pres_finish_flag ) break;

	    } //while outer
	    if (debug) System.out.println("Copy is Done for pres* file Remotely");
	    resultText.append("Copy is Done for pres* file Remotely");
	} //else if (conc parameter check)

	else {

	    status.setText("Copying ....");
            boolean conc_finish_flag = false;

	    conc_flag = new int[vel_size];

	    for(int i=0; i < vel_size; i++) conc_flag[i] = 0;	 

	    while( true ) {

		if ( !conc_finish_flag ) conc_finish_flag = concTypeFileCopy();
		if ( conc_finish_flag ) break;

	    } //while outer
	    if (debug) System.out.println("Copy is Done for conc* file Remotely");
	    resultText.append("Copy is Done for conc* file Remotely");
	} //else (conc parameter check)

    } //void run

    public boolean velTypeFileCopy() {

	    int vel_count=0;
	    boolean vel_check_flag = false;
	    String vel_file;

	      if ( !vel_check_flag ) {

		status.setText("vel file Copying ...");

		rcpFromoscbwToheechee("velTime");	

		resultText.append("velTime reading ......\n");
		if(debug) System.out.println("velTime reading.....");

		getReadBlock_vel("velTime");
		StringTokenizer st = new StringTokenizer(file_context);
		while (st.hasMoreTokens()) {
			st.nextToken();
			st.nextToken();
			if( vel_flag[vel_count] == 0 ) vel_flag[vel_count] = 1;
			vel_count = vel_count + 1; 
		}
        
		if (debug) System.out.println("vel_count= "+vel_count);

		for (int i = 0; i < vel_count; i++) {
	
		    status.setText("vel file Copying ...");
	 
		    if ( i >= 0 && i < 10 ) vel_file = "vel.00" + i + ".plt" ;
		    else if ( i >= 10 && i < 100) vel_file = "vel.0" + i + ".plt";
		    else vel_file = "vel."+ i + ".plt";

		    if (vel_flag[i] == 1) {
			rcpFromoscbwToheechee(vel_file);
			vel_flag[i] = 2;
		    }
		}  //for i=0
		}  //if (vel_check_flag

		if ( !vel_check_flag ) {
		if ( finish_line == 0 ) previous_vel_count = vel_count;
		if ( previous_vel_count == vel_count ) finish_line = finish_line + 1;
		else finish_line = 0;

		if (finish_line > 5) { vel_check_flag = true;
					     resultText.append("vel Copying ... Done!!!\n");
					     if (debug) System.out.println("vel Copying ... Done!!!");
                                  }
		else  while (Connection.remote.exists(dest+"velTime"))
		             Connection.remote.delete(dest+"velTime");
		}
		return vel_check_flag;
    }

    public boolean presTypeFileCopy() {

	    int pres_count=0;
	    boolean pres_check_flag = false;
	    String pres_file;
	 
		if (!pres_check_flag) {
		status.setText("pres file Copying ...");

		rcpFromoscbwToheechee("presTime");

		resultText.append("presTime reading ....\n");
		if(debug) System.out.println("presTime reading...");

		getReadBlock_pres("presTime");
		StringTokenizer st1 = new StringTokenizer(file_context);
		while (st1.hasMoreTokens()) {
			st1.nextToken();
			st1.nextToken();
			if( pres_flag[pres_count] == 0 ) pres_flag[pres_count] = 1;
			pres_count = pres_count + 1; 
		}
        
		if (debug) System.out.println("pres_count= "+pres_count);
	  
		for (int i = 0; i < pres_count; i++) {
		 
		    status.setText("pres file Copying...");
		    if ( i >= 0 && i < 10 ) pres_file = "pres.00" + i + ".plt" ;
		    else if ( i >= 10 && i < 100) pres_file = "pres.0" + i + ".plt";
		    else pres_file = "pres."+ i + ".plt";

		    if (pres_flag[i] == 1) {
			rcpFromoscbwToheechee(pres_file);
			pres_flag[i] = 2;
		    }
		}  //for i=0
		} //if(pres_check_flag)

		if ( !pres_check_flag ) {
		if ( finish_line1 == 0 ) previous_pres_count = pres_count;
		if ( previous_pres_count == pres_count ) finish_line1 = finish_line1 + 1;
		else finish_line1 = 0;

		if (finish_line1 > 5) { pres_check_flag = true;
					      if (debug) System.out.println("pres Copying ... Done!!!");
						resultText.append("pres Copying ... Done!!!\n");
 					    }
		else  while (Connection.remote.exists(dest+"presTime"))
		             Connection.remote.delete(dest+"presTime");
		}
		return pres_check_flag;
    }


    public boolean concTypeFileCopy() {

	    int conc_count=0;
	    boolean conc_check_flag = false;
	    String conc_file, conc_file11, conc_file21;
	 
		if (!conc_check_flag) {
		status.setText("conc file Copying ...");
		
		rcpFromoscbwToheechee("concTime");

		resultText.append("concTime reading ....\n");
		if(debug) System.out.println("concTime reading...");

		getReadBlock_conc("concTime");
		StringTokenizer st2 = new StringTokenizer(file_context);
		while (st2.hasMoreTokens()) {
			st2.nextToken();
			st2.nextToken();
			if( conc_flag[conc_count] == 0 ) conc_flag[conc_count] = 1;
			conc_count = conc_count + 1; 
		}
        
		if (debug) System.out.println("conc_count= "+conc_count);
	  
		for (int i = 0; i < conc_count; i++) {
		 
		    status.setText("conc file Copying...");
		    if ( i >= 0 && i < 10 ) { conc_file = "conc1-10.00" + i + ".plt" ;
							conc_file11 = "conc11-20.00" + i + ".plt";
							conc_file21 = "conc21-27.00" + i + ".plt"; }

		    else if ( i >= 10 && i < 100) { conc_file = "conc1-10.0" + i + ".plt";
								conc_file11 = "conc11-20.0" + i + ".plt";
								conc_file21 = "conc21-27.0" + i + ".plt"; }

		    else {  conc_file = "conc1-10."+ i + ".plt";
			     	conc_file11 = "conc11-20." + i + ".plt";
				conc_file21 = "conc21-27." + i + ".plt";  }

		    if (conc_flag[i] == 1) {
			rcpFromoscbwToheechee(conc_file);
			rcpFromoscbwToheechee(conc_file11);
			rcpFromoscbwToheechee(conc_file21);
			conc_flag[i] = 2;
		    }
		}  //for i=0
		} //if(conc_check_flag)

		if ( !conc_check_flag ) {
		if ( finish_line2 == 0 ) previous_conc_count = conc_count;
		if ( previous_conc_count == conc_count ) finish_line2 = finish_line2 + 1;
		else finish_line2 = 0;

		if (finish_line2 > 5) { conc_check_flag = true;
					      if (debug) System.out.println("conc Copying ... Done!!!");
						resultText.append("conc Copying ... Done!!!\n");
 					    }
		else  while (Connection.remote.exists(dest+"concTime"))
		             Connection.remote.delete(dest+"concTime");
		}
		return conc_check_flag;
    }


    public void rcpFromoscbwToheechee(String filename) {

	do {
		resultText.append("waiting... "+filename+"\n");
		if (debug) System.out.println("waiting... "+filename);
		Connection.submit.importFile(src+filename, dest, remotehost, user);
	}while (!Connection.remote.exists(dest+filename));
		
      if(debug) System.out.println(filename+" : Done");

    }


    public void getReadBlock_vel(String filename) {
  
	String file_context1 = null;
	byte[] file_read = null;
	int    read_block_num = 0;
	int    blocksize = 1024;
	int    filesize = 0;

	try {

	Connection.remote.open_file1(dest+filename, "r");
	filesize = Connection.remote.getFileSize_file1();

 	if ( filesize <= blocksize ) {
		file_read = Connection.remote.getBlock_file1();
		file_context = new String(file_read);   }
	else {
		read_block_num = filesize / blocksize;
		if ( (filesize % blocksize) > 0 ) read_block_num = read_block_num + 1;
	 	    	file_read = Connection.remote.getBlock_file1();
		    	file_context = new String(file_read);
	
			for ( int i=1; i < read_block_num; i++) {		
	 	         	file_read = Connection.remote.getBlock_file1();
		    		file_context1 = new String(file_read);
				file_context = file_context.concat(file_context1); } 
	}
	Connection.remote.close_file1();
	if(debug) System.out.println("FILE size: "+filesize);
	if (debug) System.out.println("Reading veltime: "+file_context);

	} catch(WebFlow.RemoteFile2.RemoteFile2Package.FileException ex)
		{
			if (debug) { System.out.println("Can't read from `" +
						    ex.getMessage() + "'");
			System.exit(1); }
		 } catch (WebFlow.RemoteFile2.RemoteFile2Package.EOFFileException ex1) {
			if (debug) { System.out.println("Can't read from `" +
			              ex1.getMessage() + "'");
		        System.exit(1); }
		 }
    }

    public void getReadBlock_pres(String filename) {
  
	String file_context1 = null;
	byte[] file_read = null;
	int    read_block_num = 0;
	int    blocksize = 1024;
	int    filesize = 0;

	try {

	Connection.remote.open_file2(dest+filename, "r");
	filesize = Connection.remote.getFileSize_file2();

 	if ( filesize <= blocksize ) {
		file_read = Connection.remote.getBlock_file2();
		file_context = new String(file_read);   }
	else {
		read_block_num = filesize / blocksize;
		if ( (filesize % blocksize) > 0 ) read_block_num = read_block_num + 1;
	 	    	file_read = Connection.remote.getBlock_file2();
		    	file_context = new String(file_read);
	
			for ( int i=1; i < read_block_num; i++) {		
	 	         	file_read = Connection.remote.getBlock_file2();
		    		file_context1 = new String(file_read);
				file_context = file_context.concat(file_context1); } 
	}
	Connection.remote.close_file2();
	if(debug) System.out.println("FILE size: "+filesize);
	if (debug) System.out.println("Reading Prestime: "+file_context);

	} catch(WebFlow.RemoteFile2.RemoteFile2Package.FileException ex)
		{
			if (debug) { System.out.println("Can't read from `" +
						    ex.getMessage() + "'");
			System.exit(1); }
		 } catch (WebFlow.RemoteFile2.RemoteFile2Package.EOFFileException ex1) {
			if (debug) { System.out.println("Can't read from `" +
			              ex1.getMessage() + "'");
		        System.exit(1); }
		 }
    }

    public void getReadBlock_conc(String filename) {
  
	String file_context1 = null;
	byte[] file_read = null;
	int    read_block_num = 0;
	int    blocksize = 1024;
	int    filesize = 0;

	try {

	Connection.remote.open_file3(dest+filename, "r");
	filesize = Connection.remote.getFileSize_file3();

 	if ( filesize <= blocksize ) {
		file_read = Connection.remote.getBlock_file3();
		file_context = new String(file_read);   }
	else {
		read_block_num = filesize / blocksize;
		if ( (filesize % blocksize) > 0 ) read_block_num = read_block_num + 1;
	 	    	file_read = Connection.remote.getBlock_file3();
		    	file_context = new String(file_read);
	
			for ( int i=1; i < read_block_num; i++) {		
	 	         	file_read = Connection.remote.getBlock_file3();
		    		file_context1 = new String(file_read);
				file_context = file_context.concat(file_context1); } 
	}
	Connection.remote.close_file3();
	if(debug) System.out.println("FILE size: "+filesize);
	if (debug) System.out.println("Reading concTime: "+file_context);

	} catch(WebFlow.RemoteFile2.RemoteFile2Package.FileException ex)
		{
			if (debug) { System.out.println("Can't read from `" +
						    ex.getMessage() + "'");
			System.exit(1); }
		 } catch (WebFlow.RemoteFile2.RemoteFile2Package.EOFFileException ex1) {
			if (debug) { System.out.println("Can't read from `" +
			              ex1.getMessage() + "'");
		        System.exit(1); }
		 }
    }


    public void submitJobcrpc(String command) {
	Connection.submit.submitLocally(command);

	if(debug) System.out.println("run locally completed");
	String OLine="";
	resultText.setText(OLine);
	int curLine=0; 
	if(debug) System.out.println("start reading...");
	while(!OLine.equals("theEnd")) {
	    OLine=Connection.submit.getOLine(curLine);
	    if(OLine.equals("wait")) {
		if(debug) System.out.println("waiting...");
		waitFor(10);
	    }
	    else {
		if(debug) System.out.println(curLine+" "+OLine);
		resultText.append(OLine+"\n");
		
		Connection.submit.setLineRead(curLine);
		curLine++;
		if(curLine==20) curLine=0;
	    } 
	}
    }

  public synchronized void waitFor(long howLong){
     try {
        wait(howLong);
     } catch (Exception e) { System.out.println(e);}
   }

}






















