import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import java.io.*;
import java.util.*;

public class CopyPanel extends JPanel {

    String[] conf; 
    String[] params;
    JTextField[] s;
    ActionListener[] al;
    JPanel[] pp;
    JPanel pp1;
    int n;
    String WebFlowServerFileName;
    desktop d;
    String selectedServer;

    public CopyPanel(desktop d, String selectedServer) {
	
	this.d = d;
	this.selectedServer = selectedServer;
	n = d.n_c;
  
	conf = new String[n];
	for(int i=0;i<n;i++) {
	    conf[i]="";
	}
	s = new JTextField[n-1];
	params = new String[n];
	params[0]="                        RCP type ";
	params[1]="                    Parssim Host ";
	params[2]="                     Passim User ";
	params[3]="        Parssim Source directory ";
	params[4]=" WebServer Destination directory "; 
	params[5]="                    Express Host ";
	params[6]="                    Express User ";
	params[7]="   Express Destination directory ";

	pp = new JPanel[n-1];
	al = new ActionListener[n];
  
	WebFlowServerFileName = selectedServer+"RCP.conf";

	conf[0] = "Local";
	conf[1] = "oscbw.osc.edu";
	conf[2] = "pse";
	conf[3] = "/home/pse/CRPC/beowulf/";
	conf[4] = "/home/scri97/users/cyoun/birch/XPcrpc/util/data/";
	conf[5] = "queso.csit.fsu.edu";
	conf[6] = "cyoun";
	conf[7] = "/home.orig/cyoun/XPcrpc/util/data/";

	File conffile = new File(WebFlowServerFileName);
	if(conffile.exists()) {
	    try {
		FileReader fr = new FileReader(conffile);
		BufferedReader in = new BufferedReader(fr);
		String nextline = in.readLine();
		in.close();
		StringTokenizer st = new StringTokenizer(nextline,"+");
		for(int i=0; i<n; i++) {
		    conf[i] = st.nextToken();
		}
		d.setCopyConfig(conf);
	    }
	    catch (Exception e) {System.out.println(e);}
	}  
	else {
	    System.out.println("new configuration");
	}


	setLayout(new BorderLayout());
	
	JPanel ss = new JPanel();
	ss.setLayout(new GridLayout(n,1));

	JLabel l;

	pp1 = new JPanel();
	pp1.setLayout(new BorderLayout());
	l = new JLabel(params[0]);
	l.setFont(new Font("Courier", Font.BOLD, 12));
	l.setForeground(Color.black);
	pp1.add(l,BorderLayout.WEST);

	String[] copy_options = new String[4];
	copy_options[0] = "Local";
	copy_options[1] = "Remote";
	copy_options[2] = "TransferLocal";
	copy_options[3] = "TransferRemote";

	JComboBox cb = new JComboBox(copy_options);
	cb.addItemListener(new ItemListener() {
		public void itemStateChanged(ItemEvent e) {
		    conf[0] = (String)e.getItem();
		}
	    });
	
	if(conf[0].equals(copy_options[0])) cb.setSelectedIndex(0);
	else if(conf[0].equals(copy_options[1])) cb.setSelectedIndex(1);
	else if(conf[0].equals(copy_options[2])) cb.setSelectedIndex(2);
	else cb.setSelectedIndex(3);

	pp1.add(cb, BorderLayout.CENTER);
	ss.add(pp1);  

	for (int i = 0; i<n-1; i++) {
	    pp[i] = new JPanel();
	    pp[i].setLayout(new BorderLayout());
	    l = new JLabel(params[i+1]);
	    l.setFont(new Font("Courier", Font.BOLD, 12));
	    l.setForeground(Color.black);
	    pp[i].add(l,BorderLayout.WEST);
	    s[i] = new JTextField(conf[i+1],25);
	    s[i].setPreferredSize(new Dimension(100,5));
	    pp[i].add(s[i],BorderLayout.CENTER);
	    ss.add(pp[i]);  
	}
  
	add(ss,BorderLayout.CENTER);
  
	JPanel bp = new JPanel();
	bp.setLayout(new GridLayout(1,2));
	JButton b1 = new JButton("Commit");
	b1.addActionListener(new ActionListener() {
		public void actionPerformed(ActionEvent e) {
		    commit();
		}
	    });
	bp.add(b1);

	JButton b2 = new JButton("Reset");
	b2.addActionListener(new ActionListener() {
		public void actionPerformed(ActionEvent e) {
		    reset();
		}
	    });
	bp.add(b2);
	add(bp,BorderLayout.SOUTH);
    }


    public void setCopyconf(int i, String h) {
	conf[i]=h;
    } 

    public void commit() {

	for(int i=1;i<n;i++) {
	    conf[i]=s[i-1].getText();
	}  

	d.setCopyConfig(conf);
	try {    
	    FileWriter fw = new FileWriter(WebFlowServerFileName);
	    for (int i=0;i<n;i++) {
		if(conf[i].length()<1) fw.write("null+"); 
		else fw.write(conf[i]+"+");
	    }
	    fw.flush();
	    fw.close();
	}
	catch (Exception e) { System.out.println(e);}
    }

    public void reset() {

	for(int i=1;i<n;i++) {
	    conf[i]="";
	    s[i-1].setText("");
	}
    }
    
}


