import java.awt.*;
import javax.swing.*;


public class CrpcDisplay implements Runnable {

    private JTextField status;
    private JTextArea resultText;
    private JScrollPane sp;
    private String file_name;
    private boolean debug;
    private Thread rjThread, sfThread, rfThread, meThread;
    private String ParssimSrc, ParssimHost, ParssimUser, WebserverDest;
    private String ExpressHost, ExpressUser, ExpressDest, RCPtype;

  public CrpcDisplay(JTextField status, JTextArea resultText, 
                   JScrollPane sp, String file_name, String RCPtype, String ParssimHost, String ParssimUser, String ParssimSrc, String WebserverDest, String ExpressHost, String ExpressUser, String ExpressDest, boolean debug) {

    this.status = status;
    this.resultText = resultText;
    this.sp = sp;
    this.file_name = file_name;
    this.RCPtype = RCPtype;
    this.ParssimHost = ParssimHost;
    this.ParssimUser = ParssimUser;
    this.WebserverDest = WebserverDest;
    this.ParssimSrc = ParssimSrc;
    this.ExpressHost = ExpressHost;
    this.ExpressUser = ExpressUser;
    this.ExpressDest = ExpressDest;

    this.debug = debug;
    if(debug) System.out.println("CrpcDisplay constructor completed");
  }

  public void run(){

      /* then run the job */ 
      status.setText("Copying...");
      crpcSend rj = new crpcSend(file_name, status, resultText, sp, RCPtype, ParssimHost, ParssimUser, ParssimSrc, WebserverDest, ExpressHost, ExpressUser, ExpressDest, debug);

      rjThread = new Thread(rj);
      rjThread.setName("crpc_display");
      rjThread.start();
      MonitorExecution me = new MonitorExecution(rjThread,status,debug);
      meThread = new Thread(me);
      meThread.setName("monitor");
      meThread.start();
      try {
        meThread.join();
      } catch (Exception e) {System.out.println("run "+e);}

  }

  public synchronized void waitFor(long howLong){
     try {
        wait(howLong);
     } catch (Exception e) { System.out.println(e);}
   }

}




