import java.awt.*;
import javax.swing.*;


public class CrpcSubmitJob implements Runnable {

    private JTextField status;
    private JTextArea resultText;
    private JScrollPane sp;
    private boolean debug;
    private boolean getJobid = false;

    private String CPcmd;
    private String ParssimSrc, ParssimHost, ParssimUser, WebserverDest;
    private String ExpressHost, ExpressUser, ExpressDest, RCPtype;
    private String RParssimSrc, RParssimHost, RParssimUser, RWebserverDest;

    private Thread exeB, exeC;
    private Thread exeP;

    public CrpcSubmitJob(JTextField status,JTextArea resultText,JScrollPane sp,String CPcmd, String RCPtype, String ParssimHost, String ParssimUser, String ParssimSrc, String WebserverDest, String ExpressHost, String ExpressUser, String ExpressDest, boolean debug) {

	this.status = status;
	this.resultText = resultText;
	this.sp = sp;
	this.RCPtype = RCPtype;
	this.ParssimHost = ParssimHost;
	this.ParssimUser = ParssimUser;
	this.WebserverDest = WebserverDest;
	this.ParssimSrc = ParssimSrc;
	this.ExpressHost = ExpressHost;
	this.ExpressUser = ExpressUser;
	this.ExpressDest = ExpressDest;
	this.CPcmd = CPcmd;
       
	this.debug = debug;
	if(debug) System.out.println("CrpcSubmitJob constructor completed");
    }

    public void run(){

	/* then run the job */ 
	status.setText("running...");

	Connection.submit.submitLocally(CPcmd);
	
	if(debug) System.out.println("run locally completed");
	String OLine="";
	resultText.setText(OLine);
	int curLine=0; 
	if(debug) System.out.println("start reading...");
	while(!OLine.equals("theEnd")) {
	    OLine=Connection.submit.getOLine(curLine);
	    if(OLine.equals("wait")) {
		if(debug) System.out.println("waiting...");
		waitFor(10);
	    }
	    else {
		if(debug) System.out.println(curLine+" "+OLine);
		resultText.append(OLine+"\n");
		Connection.submit.setOLine(curLine, OLine);

		if (OLine.endsWith("osc.edu")) {

		    waitFor(5000);
		    getJobid = true;
		    
		    //CrpcDisplay velth = new CrpcDisplay(status,resultText,sp,"vel",RCPtype, ParssimHost, ParssimUser, ParssimSrc, WebserverDest, ExpressHost, ExpressUser, ExpressDest,debug);
		    crpcSend velth = new crpcSend("vel", status, resultText, sp, RCPtype, ParssimHost, ParssimUser, ParssimSrc, WebserverDest, ExpressHost, ExpressUser, ExpressDest, debug);
		    exeB = new Thread(velth);
		    exeB.start();

		    //CrpcDisplay presth = new CrpcDisplay(status,resultText,sp,"pres",RCPtype, ParssimHost, ParssimUser, ParssimSrc, WebserverDest, ExpressHost, ExpressUser, ExpressDest,debug);
		    crpcSend presth = new crpcSend("pres", status, resultText, sp, RCPtype, ParssimHost, ParssimUser, ParssimSrc, WebserverDest, ExpressHost, ExpressUser, ExpressDest, debug);
		    exeP = new Thread(presth);
		    exeP.start();
		    
		    //CrpcDisplay concth = new CrpcDisplay(status,resultText,sp,"conc",RCPtype, ParssimHost, ParssimUser, ParssimSrc, WebserverDest, ExpressHost, ExpressUser, ExpressDest,debug);
		    crpcSend concth = new crpcSend("conc", status, resultText, sp, RCPtype, ParssimHost, ParssimUser, ParssimSrc, WebserverDest, ExpressHost, ExpressUser, ExpressDest, debug);
		    exeC = new Thread(concth);
		    exeC.start();
		}
		
		if(OLine.equals("theEnd") && !getJobid) {
		    resultText.append("Parssim is failed to run ...\n");
		    resultText.append("Please restart ...\n");
		}

		Connection.submit.setLineRead(curLine);
		curLine++;
		if(curLine==20) curLine=0;
	    } 
	}
    }

    public synchronized void waitFor(long howLong){
	try {
	    wait(howLong);
	} catch (Exception e) { System.out.println(e);}
    }
}



