import java.awt.*;
import javax.swing.*;
import WebFlow.submitJob2.*;
import java.io.*;
import java.util.*;

public class crpcSend implements Runnable {

    private String file_name;
    private boolean debug;
    private JTextField status;
    private JTextArea resultText;
    private JScrollPane sp;
    private JViewport vp;
    private Point p;
    private Dimension d;
    private int x,y;

    private String ParssimSrc, ParssimHost, ParssimUser, WebserverDest;
    private String ExpressHost, ExpressUser, ExpressDest, RCPtype;
    private String finishFileName;
    private boolean cpserviceflag = false;

    /*
      String src = "/home/pse/CRPC/beowulf/";
      String dest = "/home/scri97/users/cyoun/birch/XPcrpc/util/data/";
      String remotehost = "oscbw.osc.edu";
      String user = "pse";
    */

/*
    String file_context_vel = null;
    String file_context_pres = null;
    String file_context_conc = null;
*/

    //vel file
    int vel_size = 1000;
    int[] vel_flag;
    String FileExistORNotVel;
    int    stdindexVel;
    int    filesizeVel;
    int    preFilesizeVel = 0;
    String stdoutvel, stderrvel;
    StringTokenizer stvel;
    
    
    //pres file
    int[] pres_flag;
    String FileExistORNotPres;
    int    stdindexPres;
    int    filesizePres;
    int    preFilesizePres = 0;
    String stdoutpres, stderrpres;
    StringTokenizer stpres;
    
    //conc file
    int[] conc_flag;
    String FileExistORNotConc;
    int    stdindexConc;
    int    filesizeConc;
    int    preFilesizeConc = 0;
    String stdoutconc, stderrconc;    
    StringTokenizer stconc;

    
    public crpcSend(String file_name, JTextField status, JTextArea resultText, JScrollPane sp, String RCPtype, String ParssimHost, String ParssimUser, String ParssimSrc, String WebserverDest, String ExpressHost, String ExpressUser, String ExpressDest, boolean debug) {
	this.file_name = file_name;
	this.status = status;
	this.resultText = resultText;
	this.sp = sp;
	this.RCPtype = RCPtype;
	this.ParssimHost = ParssimHost;
	this.ParssimUser = ParssimUser;
	this.WebserverDest = WebserverDest;
	this.ParssimSrc = ParssimSrc;
	this.ExpressHost = ExpressHost;
	this.ExpressUser = ExpressUser;
	this.ExpressDest = ExpressDest;

	this.debug = debug;

	vp = sp.getViewport();
	p = vp.getViewPosition();
	d = vp.getExtentSize();
	x=p.x;
    }

    public void run(){

	String jobid, subjobid;
	System.out.println("crpcSend Started............") ;
	System.out.println("debug is " + debug) ;

	if(RCPtype.equals("TransferLocal") || RCPtype.equals("TransferRemote")){
	    cpserviceflag = true;
	    submitJobcrpc("date");
	    if (RCPtype.equals("TransferLocal")) RCPtype = "Local"; 
	    else RCPtype = "Remote";
	}
	else {
	    jobid = Connection.submit.getOLine(0);
	    subjobid = jobid.substring(0, jobid.indexOf("."));	

	    finishFileName = "parssim.o"+subjobid;  //finish parssim
	    //finishFileName = "parssim.o15788";  //finish parssim

	    System.out.println("Finish Parssim: "+finishFileName);
	}

	//Copying vel* file remotely .....................
	
	if (file_name.equals("vel")) {

	    status.setText("Copying .... vel* ");
	    boolean vel_finish_flag = false;

	    if (!cpserviceflag) {

	    checkingFileStatusVel("/home/pse/CRPC/beowulf/velTime");

	    if(stvel.hasMoreTokens()) { Connection.submit.submitAIXRshwait(ParssimHost, ParssimUser,
              "rm /home/pse/CRPC/beowulf/velTime");
	       resultText.append("You have velTime already, so it is deleted.....\n");
               System.out.println("You have velTime already, so it is deleted.....");
   	    }
            else { resultText.append("Wait for velTime file....\n");
                   System.out.println("Wait for velTime file....");   }
            }

	    vel_flag = new int[vel_size]; //0:intial, 1:ready to read, 2:read

	    for(int i=0; i < vel_size; i++) vel_flag[i] = 0;

	    if (RCPtype.equals("Remote")) rcpFromoscbwToexpress("infile_Movie");
	    else rcpFromoscbwToheechee("infile_Movie");

	    while( true ) {

		if ( !vel_finish_flag ) vel_finish_flag = velTypeFileCopy();
		if ( vel_finish_flag ) break;

	    } //while outer
	    if (debug) System.out.println("Copy is Done for vel* file Remotely");
	    resultText.append("Copy is Done for vel* file Remotely");
	} //if (vel parameter check

	else if (file_name.equals("pres")) {

	    status.setText("Copying .... pres* ");
 	    boolean pres_finish_flag = false;
	    
	    if (!cpserviceflag) {

	    checkingFileStatusPres("/home/pse/CRPC/beowulf/presTime");

	    if(stpres.hasMoreTokens()) { Connection.submit.submitAIXRshwait(ParssimHost, ParssimUser,
              "rm /home/pse/CRPC/beowulf/presTime");
	       resultText.append("You have presTime already, so it is deleted.....\n");
               System.out.println("You have presTime already, so it is deleted.....");
   	    }
            else { resultText.append("Wait for presTime file....\n");
 		   System.out.println("Wait for presTime file....");  }
            }

	    pres_flag = new int[vel_size];

	    for(int i=0; i < vel_size; i++) pres_flag[i] = 0;	 

	    while( true ) {

 		if ( !pres_finish_flag ) pres_finish_flag = presTypeFileCopy();
		if ( pres_finish_flag ) break;

	    } //while outer
	    if (debug) System.out.println("Copy is Done for pres* file Remotely");
	    resultText.append("Copy is Done for pres* file Remotely");
	} //else if (conc parameter check)

	else {

	    status.setText("Copying .... conc* ");
            boolean conc_finish_flag = false;

	    if (!cpserviceflag) {

	    checkingFileStatusConc("/home/pse/CRPC/beowulf/concTime");

	    if(stconc.hasMoreTokens()) { Connection.submit.submitAIXRshwait(ParssimHost, ParssimUser,
              "rm /home/pse/CRPC/beowulf/concTime");
	       resultText.append("You have concTime already, so it is deleted.....\n");
               System.out.println("You have concTime already, so it is deleted.....");
   	    }
            else { resultText.append("Wait for concTime file....\n");
         	   System.out.println("Wait for concTime file...."); }
            }

	    conc_flag = new int[vel_size];

	    for(int i=0; i < vel_size; i++) conc_flag[i] = 0;	 

	    while( true ) {

		if ( !conc_finish_flag ) conc_finish_flag = concTypeFileCopy();
		if ( conc_finish_flag ) break;

	    } //while outer
	    if (debug) System.out.println("Copy is Done for conc* file Remotely");
	    resultText.append("Copy is Done for conc* file Remotely");
	} //else (conc parameter check)

    } //void run

    public boolean velTypeFileCopy() {
	
	int vel_count=0;
	boolean vel_check_flag = false;
	String vel_file;

	filesizeVel = 0;	    
	if ( !vel_check_flag ) {
	    
	    status.setText("vel file Copying ...");

	    do {

	    checkingFileStatusVel("/home/pse/CRPC/beowulf/velTime");
       	    
	    if (stvel.hasMoreTokens()) {
		stvel.nextToken();
                stvel.nextToken();
		stvel.nextToken();
		stvel.nextToken();
		filesizeVel = Integer.parseInt(stvel.nextToken());

                if (debug) System.out.println("velTime file size = "+filesizeVel);
		if (filesizeVel < 5) filesizeVel = 0;

	    if (preFilesizeVel == filesizeVel) {

	       checkingFileStatusVel(ParssimSrc+finishFileName);

	       if(stvel.hasMoreTokens()) {
		     resultText.append("Parssim(velTime) is finished ....\n");
		     System.out.println("Parssim(velTime) is finished ...."); 
                     vel_check_flag = true;

	             checkingFileStatusVel("/home/pse/CRPC/beowulf/velTime");
       	    
		     stvel.nextToken();
                     stvel.nextToken();
		     stvel.nextToken();
		     stvel.nextToken();
		     filesizeVel = Integer.parseInt(stvel.nextToken());

                     if (debug) System.out.println("End!! => velTime file size = "+filesizeVel);
                     if (preFilesizeVel == filesizeVel) return vel_check_flag; }
       	    }                                                   
	    }
            else { 
               if (debug) System.out.println("Wait for velTime file.....");

	       checkingFileStatusVel(ParssimSrc+finishFileName);

	       if(stvel.hasMoreTokens()) {
	    	     resultText.append("Parssim(velTime) is finished immediately,\n");
 		     resultText.append("please restart...\n");		     
		     System.out.println("Parssim(velTime) is finished immediately, please restart...");  
                     vel_check_flag = true;
                     return vel_check_flag;  }
            }

            } while (preFilesizeVel == filesizeVel);
	
	    preFilesizeVel = filesizeVel;			    	

	    waitFor(1000);
	    if (RCPtype.equals("Remote")) rcpFromoscbwToexpress("velTime");
	    else rcpFromoscbwToheechee("velTime");	

	    resultText.append("velTime reading ......\n");
	    if(debug) System.out.println("velTime reading.....");
	    
	    short k = 0;
	    StringTokenizer st = new StringTokenizer(getReadBlock(k,"velTime"));
	    while (st.hasMoreTokens()) {
		st.nextToken();
		st.nextToken();
		if( vel_flag[vel_count] == 0 ) vel_flag[vel_count] = 1;
		vel_count = vel_count + 1; 
	    }
	    
	    if (debug) System.out.println("vel_count= "+vel_count);
	    
	    for (int i = 0; i < vel_count; i++) {
		
		status.setText("vel file Copying ...");
		
		if ( i >= 0 && i < 10 ) vel_file = "vel.00" + i + ".plt" ;
		else if ( i >= 10 && i < 100) vel_file = "vel.0" + i + ".plt";
		else vel_file = "vel."+ i + ".plt";
		
		if (vel_flag[i] == 1) {
		    if(RCPtype.equals("Remote")) rcpFromoscbwToexpress(vel_file);
		    else rcpFromoscbwToheechee(vel_file);
		    vel_flag[i] = 2;
		}
	    }  //for i=0
	
	    if (cpserviceflag) {
		vel_check_flag = true;
		resultText.append("vel Copying ... Done!!!\n");
		if (debug) System.out.println("vel Copying ... Done!!!");
	    }   

	} //if (vel_check_flag)
	return vel_check_flag;
    }
    
    public boolean presTypeFileCopy() {
	
	int pres_count=0;
	boolean pres_check_flag = false;
	String pres_file;
	
	if (!pres_check_flag) {
	    status.setText("pres file Copying ...");
	    
	    do {

	    checkingFileStatusPres("/home/pse/CRPC/beowulf/presTime");
       	    
	    if (stpres.hasMoreTokens()) {
		stpres.nextToken();
                stpres.nextToken();
		stpres.nextToken();
		stpres.nextToken();
		filesizePres = Integer.parseInt(stpres.nextToken());
                if (debug) System.out.println("presTime file size = "+filesizePres);
		if(filesizePres < 5) filesizePres = 0;

	    if (preFilesizePres == filesizePres) {

	       checkingFileStatusPres(ParssimSrc+finishFileName);

	       if(stpres.hasMoreTokens()) {

		     resultText.append("Parssim(presTime) is finished ....\n");
		     System.out.println("Parssim(presTime) is finished ...."); 
                     pres_check_flag = true;

	             checkingFileStatusPres("/home/pse/CRPC/beowulf/presTime");

		     stpres.nextToken();
                     stpres.nextToken();
		     stpres.nextToken();
		     stpres.nextToken();
		     filesizePres = Integer.parseInt(stpres.nextToken());
                     if (debug) System.out.println("End!! => presTime file size = "+filesizePres);
		     if(preFilesizePres == filesizePres) return pres_check_flag;  }
       	    }                                                   
	    }
            else { 
               if (debug) System.out.println("Wait for presTime file.....");

	       checkingFileStatusPres(ParssimSrc+finishFileName);

	       if(stpres.hasMoreTokens()) {
	    	     resultText.append("Parssim(presTime) is finished immediately,\n");
 		     resultText.append("please restart...\n");	
		     System.out.println("Parssim(presTime) is finished immediately, please restart ....");  
                     pres_check_flag = true;
                     return pres_check_flag;  }
            }

            } while (preFilesizePres == filesizePres);
	
	    preFilesizePres = filesizePres;		

	    waitFor(1000);
	    if (RCPtype.equals("Remote")) rcpFromoscbwToexpress("presTime");
	    else rcpFromoscbwToheechee("presTime");
	    
	    resultText.append("presTime reading ....\n");
	    if(debug) System.out.println("presTime reading...");
	    
	    short k = 1;
	    StringTokenizer st1 = new StringTokenizer(getReadBlock(k,"presTime"));
	    while (st1.hasMoreTokens()) {
		st1.nextToken();
		st1.nextToken();
		if( pres_flag[pres_count] == 0 ) pres_flag[pres_count] = 1;
		pres_count = pres_count + 1; 
	    }
	    
	    if (debug) System.out.println("pres_count= "+pres_count);
	    
	    for (int i = 0; i < pres_count; i++) {
		
		status.setText("pres file Copying...");
		if ( i >= 0 && i < 10 ) pres_file = "pres.00" + i + ".plt" ;
		else if ( i >= 10 && i < 100) pres_file = "pres.0" + i + ".plt";
		else pres_file = "pres."+ i + ".plt";
		
		if (pres_flag[i] == 1) {
		    if (RCPtype.equals("Remote")) rcpFromoscbwToexpress(pres_file);
		    else rcpFromoscbwToheechee(pres_file);
		    pres_flag[i] = 2;
		}
	    }  //for i=0


	    if(cpserviceflag) {
		pres_check_flag = true;
		if (debug) System.out.println("pres Copying ... Done!!!");
		resultText.append("pres Copying ... Done!!!\n");
	    }
	}
	return pres_check_flag;
    }


    public boolean concTypeFileCopy() {
	
	int conc_count=0;
	boolean conc_check_flag = false;
	String conc_file, conc_file11, conc_file21;
	
	if (!conc_check_flag) {
	    status.setText("conc file Copying ...");
	    
	    do {

	    checkingFileStatusConc("/home/pse/CRPC/beowulf/concTime");
       	    
	    if (stconc.hasMoreTokens()) {
		stconc.nextToken();
                stconc.nextToken();
		stconc.nextToken();
		stconc.nextToken();
		filesizeConc = Integer.parseInt(stconc.nextToken());
                if (debug) System.out.println("concTime file size = "+filesizeConc);

	    if (preFilesizeConc == filesizeConc) {

	       checkingFileStatusConc(ParssimSrc+finishFileName);

	       if(stconc.hasMoreTokens()) {
		     resultText.append("Parssim(concTime) is finished ....\n");
		     System.out.println("Parssim(concTime) is finished ...."); 
                     conc_check_flag = true;

	             checkingFileStatusConc("/home/pse/CRPC/beowulf/concTime");
       	    
		     stconc.nextToken();
                     stconc.nextToken();
		     stconc.nextToken();
		     stconc.nextToken();
		     filesizeConc = Integer.parseInt(stconc.nextToken());
                     if (debug) System.out.println("End!! => concTime file size = "+filesizeConc);

		     if(preFilesizeConc == filesizeConc) return conc_check_flag;		   
               }
       	    }                                                   
	    }
            else { 
               if (debug) System.out.println("Wait for concTime file.....");

	       checkingFileStatusConc(ParssimSrc+finishFileName);

	       if(stconc.hasMoreTokens()) {
	    	     resultText.append("Parssim(concTime) is finished immediately,\n");
 		     resultText.append("please restart...\n");
		     System.out.println("Parssim(concTime) is finished ....");  
                     conc_check_flag = true;
                     return conc_check_flag;  }
            }

            } while (preFilesizeConc == filesizeConc);
	
	    preFilesizeConc = filesizeConc;		

	    waitFor(1000);
	    if (RCPtype.equals("Remote")) rcpFromoscbwToexpress("concTime");
	    else rcpFromoscbwToheechee("concTime");
	    
	    resultText.append("concTime reading ....\n");
	    if(debug) System.out.println("concTime reading...");
	   
	    short k = 2; 
	    StringTokenizer st2 = new StringTokenizer(getReadBlock(k,"concTime"));
	    while (st2.hasMoreTokens()) {
		st2.nextToken();
		st2.nextToken();
		if( conc_flag[conc_count] == 0 ) conc_flag[conc_count] = 1;
		conc_count = conc_count + 1; 
	    }
	    
	    if (debug) System.out.println("conc_count= "+conc_count);
	    
	    for (int i = 0; i < conc_count; i++) {
		
		status.setText("conc file Copying...");
		if ( i >= 0 && i < 10 ) {
		    conc_file = "conc1-10.00" + i + ".plt" ;
		    conc_file11 = "conc11-20.00" + i + ".plt";
		    conc_file21 = "conc21-27.00" + i + ".plt"; }
		
		else if ( i >= 10 && i < 100) { 
		    conc_file = "conc1-10.0" + i + ".plt";
		    conc_file11 = "conc11-20.0" + i + ".plt";
		    conc_file21 = "conc21-27.0" + i + ".plt"; }
		
		else {  
		    conc_file = "conc1-10."+ i + ".plt";
		    conc_file11 = "conc11-20." + i + ".plt";
		    conc_file21 = "conc21-27." + i + ".plt";  }
		
		if (conc_flag[i] == 1) {
		    if (RCPtype.equals("Remote")) {
			rcpFromoscbwToexpress(conc_file);
			waitFor(500);
			rcpFromoscbwToexpress(conc_file11);
   			waitFor(500);
			rcpFromoscbwToexpress(conc_file21);
		    }
		    else {
			rcpFromoscbwToheechee(conc_file);
			waitFor(500);
			rcpFromoscbwToheechee(conc_file11);
			waitFor(500);
			rcpFromoscbwToheechee(conc_file21);
		    }
		    conc_flag[i] = 2;
		}
	    }  //for i=0


	    if(cpserviceflag) {
		conc_check_flag = true;
		if (debug) System.out.println("conc Copying ... Done!!!");
		resultText.append("conc Copying ... Done!!!\n");
	    }
	}
	return conc_check_flag;
    }

    
    public synchronized void rcpFromoscbwToheechee(String filename) {
	
	//resultText.append("waiting... "+filename+"\n");
	//if (debug) System.out.println("waiting... "+filename);
	resultText.append("rcp -p "+ParssimUser+"@"+ParssimHost+":"+ParssimSrc+filename+" "+WebserverDest+"\n");
	if (debug) System.out.println("rcp -p "+ParssimUser+"@"+ParssimHost+":"+ParssimSrc+filename+" "+WebserverDest);

	//do {
	Connection.submit.importFile(ParssimSrc+filename, WebserverDest, ParssimHost, ParssimUser);
	//}while (!Connection.remote.exists(WebserverDest+filename));
	
	//if(debug) System.out.println(filename+" : Done");	
    }


    public synchronized void rcpFromoscbwToexpress(String filename) {

	String cmdLine = "rcp -p "+ParssimUser+"@"+ParssimHost+":"+ParssimSrc+filename+" "+ExpressDest;
	
	resultText.append("waiting... Remote: "+filename+"\n");
	if (debug) System.out.println("waiting...Remote: "+filename);

	resultText.append("rsh -l "+ExpressUser+" "+ExpressHost+" "+cmdLine+"\n");
	if (debug) System.out.println("rsh -l "+ExpressUser+" "+ExpressHost+" "+cmdLine);

	Connection.submit.submitRshwait(ExpressHost, ExpressUser, cmdLine);

	if ( filename.equals("velTime") || filename.equals("presTime") || filename.equals("concTime")) {
	    resultText.append("waiting... Local: "+filename+"\n");
	    resultText.append("rcp -p "+ParssimUser+"@"+ParssimHost+":"+ParssimSrc+filename+" "+WebserverDest+"\n");
	    if (debug) System.out.println("rcp -p "+ParssimUser+"@"+ParssimHost+":"+ParssimSrc+filename+" "+WebserverDest);
	    if (debug) System.out.println("waiting...Local "+filename);
	    
	    //do {
	    Connection.submit.importFile(ParssimSrc+filename, WebserverDest, ParssimHost, ParssimUser);
	    //}while (!Connection.remote.exists(WebserverDest+filename));
	}
	
	//if(debug) System.out.println(filename+" : Done");

    }


    public String getReadBlock(short index, String filename) {
  
	String file_context1 = null;
	String file_context = null;
	byte[] file_read = null;
	int    read_block_num = 0;
	int    blocksize = 1024;
	int    filesize = 0;

	try {

	    Connection.remote.openArray(index, WebserverDest+filename, "r");
	    filesize = Connection.remote.getFileSizeArray(index);
	    
	    if ( filesize <= blocksize ) {
		file_read = Connection.remote.getBlockArray(index);
		file_context = new String(file_read);   }
	    else {
		read_block_num = filesize / blocksize;
		if ( (filesize % blocksize) > 0 ) read_block_num = read_block_num + 1;
		file_read = Connection.remote.getBlockArray(index);
		file_context = new String(file_read);
		
		for ( int i=1; i < read_block_num; i++) {		
		    file_read = Connection.remote.getBlockArray(index);
		    file_context1 = new String(file_read);
		    file_context = file_context.concat(file_context1); } 
	    }
	    Connection.remote.closeArray(index);
	    if(debug) System.out.println("FILE size: "+filesize);
	    if (debug) System.out.println("Reading veltime: "+file_context);
	    
	} catch(WebFlow.RemoteFile2.RemoteFile2Package.FileException ex)
	    {
		System.out.println("Can't read from `" +
				ex.getMessage() + "'");
		System.exit(1);
	    } catch (WebFlow.RemoteFile2.RemoteFile2Package.EOFFileException ex1) {
		System.out.println("Can't read from `" +
				ex1.getMessage() + "'");
		System.exit(1);
	    }
        return file_context;
    }

    public void checkingFileStatusVel (String filename) {
	FileExistORNotVel = Connection.submit.submitAIXRshwait(ParssimHost, ParssimUser,
              "ls -l "+filename);
        stdindexVel = FileExistORNotVel.indexOf("STDERR:");
        stdoutvel = FileExistORNotVel.substring(0, stdindexVel-1);
  	//stderrvel = FileExistORNotVel.substring(stdindexVel);        

	stvel = new StringTokenizer(stdoutvel);
	stvel.nextToken();
   }

    public void checkingFileStatusPres (String filename) {
	FileExistORNotPres = Connection.submit.submitAIXRshwait(ParssimHost, ParssimUser,
              "ls -l "+filename);
        stdindexPres = FileExistORNotPres.indexOf("STDERR:");
        stdoutpres = FileExistORNotPres.substring(0, stdindexPres-1);
  	//stderrpres = FileExistORNotPres.substring(stdindexPres);        

	stpres = new StringTokenizer(stdoutpres);
	stpres.nextToken();
   }

    public void checkingFileStatusConc (String filename) {
	FileExistORNotConc = Connection.submit.submitAIXRshwait(ParssimHost, ParssimUser,
              "ls -l "+filename);
        stdindexConc = FileExistORNotConc.indexOf("STDERR:");
        stdoutconc = FileExistORNotConc.substring(0, stdindexConc-1);
  	//stderrconc = FileExistORNotConc.substring(stdindexConc);        

	stconc = new StringTokenizer(stdoutconc);
	stconc.nextToken();
   }

    public synchronized void submitJobcrpc(String command) {
	Connection.submit.submitLocally(command);
	
	if(debug) System.out.println("run locally completed");
	String OLine="";
	resultText.setText(OLine);
	int curLine=0; 
	if(debug) System.out.println("start reading...");
	while(!OLine.equals("theEnd")) {
	    OLine=Connection.submit.getOLine(curLine);
	    if(OLine.equals("wait")) {
		if(debug) System.out.println("waiting...");
		waitFor(10);
	    }
	    else {
		if(debug) System.out.println(curLine+" "+OLine);
		resultText.append(OLine+"\n");
		
		Connection.submit.setLineRead(curLine);
		curLine++;
		if(curLine==20) curLine=0;
	    } 
	}
    }

  public synchronized void waitFor(long howLong){
     try {
        wait(howLong);
     } catch (Exception e) { System.out.println(e);}
   }

}






















