/**
 * The "administration" servlet that handles all JSP page requests.
 */ 
package WebFlow.Servlets;

import java.io.*;
import java.util.*;
import javax.servlet.*;
import javax.servlet.http.*;
import extensions.generic.*;

public class GOWAdminServlet extends HttpServlet {
    Hashtable commandHash=new Hashtable();
    //Change the following to /Generic/ or /CSM/ or whatever.
    String rootDir="/Generic/";

    protected void doGet(HttpServletRequest req, HttpServletResponse res)
	throws ServletException, IOException {
	doPost(req, res);
    }
    
    
    protected void doPost(HttpServletRequest req, HttpServletResponse res)
	throws ServletException, IOException {
	String nextPage;
	Command cmd=getCommand(req.getParameter("cmd"));
	nextPage=cmd.execute(req);
	RequestDispatcher rd;
	rd=getServletContext().getRequestDispatcher(rootDir+nextPage);
	rd.forward(req,res);
    }

    /** 
     * Initialize this the first time the servlet is called.
     */
    public void init(ServletConfig config) throws ServletException {
	super.init(config);
	initCommands();
    }
    
    /**
     * The commandHash hashtable maps all of the commands to the 
     * a convenient name, or handle.  
     */ 
    private void initCommands() {

	commandHash.put("AdminAdd",new ForwardCommand("AdminAdd.jsp"));
	commandHash.put("AdminChange",new ForwardCommand("AdminChange.jsp"));
	commandHash.put("AdminChangeAdd",new ForwardCommand("AdminChangeAdd.jsp"));
	commandHash.put("AdminChangeDelete",new ForwardCommand("AdminChangeDelete.jsp"));
	commandHash.put("AdminChangeHost",new ForwardCommand("AdminChangeHost.jsp"));
	commandHash.put("AdminChangeHostDelete",new ForwardCommand("AdminChangeHostDelete.jsp"));
	commandHash.put("AdminDelete",new ForwardCommand("AdminDelete.jsp"));
	commandHash.put("AdminDispInfo",new ForwardCommand("AdminDispInfo.jsp"));
	commandHash.put("AdminHostAdd",new ForwardCommand("AdminHostAdd.jsp"));
	commandHash.put("AdminHostDelete",new ForwardCommand("AdminHostDelete.jsp"));
	commandHash.put("AdminLogin",new ForwardCommand("AdminLogin.jsp"));
	commandHash.put("AdminUpdate",new ForwardCommand("AdminUpdate.jsp"));
	commandHash.put("AdminXML",new ForwardCommand("AdminXML.jsp"));
	commandHash.put("AdminXMLcancel",new ForwardCommand("AdminXMLcancel.jsp"));
	commandHash.put("CodeSelect",new ForwardCommand("CodeSelect.jsp"));
	commandHash.put("DataArchive",new ForwardCommand("DataArchive.jsp"));
	commandHash.put("DataDispInfo",new ForwardCommand("DataDispInfo.jsp"));
	commandHash.put("DataProblemSession",new ForwardCommand("DataProblemSession.jsp"));
	commandHash.put("DispInfo",new ForwardCommand("DispInfo.jsp"));
	commandHash.put("JobScript",new ForwardCommand("JobScript.jsp"));
	commandHash.put("Main",new ForwardCommand("Main.jsp"));
	commandHash.put("ProbArchive",new ForwardCommand("ProbArchive.jsp"));
	commandHash.put("ProblemSession",new ForwardCommand("ProblemSession.jsp"));
	commandHash.put("ReturnPage",new ForwardCommand("ReturnPage.jsp"));
	commandHash.put("Submitted",new ForwardCommand("Submitted.jsp"));
	commandHash.put("VizReturnPage",new ForwardCommand("VizReturnPage.jsp"));
	commandHash.put("VizScript",new ForwardCommand("VizScript.jsp"));
	commandHash.put("Vizsubmit",new ForwardCommand("Vizsubmit.jsp"));
    }

    /** 
     * Get the command from the hashtable and return it.  Return
     * the Welcome command by default.
     */

    public Command getCommand(String cmdName) {
	if(commandHash.containsKey(cmdName)) {
	    return (Command)commandHash.get(cmdName);
	}
	else {
	    return (Command)commandHash.get("Welcome");
	}
    }

    public Hashtable getCommandHash() { return commandHash; }
}
 
