package extensions.generic;
import org.escience.XSIL.*;
import java.util.*;

public class parseXMLDesc extends XSIL {

    public Vector hostList,hostListNames;
    public Hashtable paramHash=new Hashtable();

    public Vector vizList,vizListNames;

    boolean instantiated = false,constructed=false;
    
    public void construct(){
	hostList=new Vector();
	hostListNames=new Vector();
	vizList=new Vector();
	vizListNames=new Vector();

	for(int ichild=0; ichild < getChildCount(); ichild++){
            XSIL x = getChild(ichild);
            if(x instanceof Param){
		Param p = (Param)x;
		paramHash.put(p.getName(),p.getText());
	    }
  	    else if(x instanceof parseXMLHost) {
  		hostList.addElement((parseXMLHost)x);
  		//hostListNames.addElement(x.getName());
		hostListNames.addElement(((parseXMLHost)x).getHost());
  	    }
	    else if(x instanceof parseXMLViz) {
  		vizList.addElement((parseXMLViz)x);
  		vizListNames.addElement(x.getName());
		//vizListNames.addElement(((parseXMLHost)x).getHost());
	    }		
	}
	constructed=true;
    }
    
// This function does the heavy lifting of reading arrays and so on
// It is separate from the construction because it is not called unless necessary.

    public void instantiate(){
	construct();
	instantiated=true;
    }

    /**
     * Returns the hashtable containing the application's parameters
     * and their values.
     */
    public Hashtable getCodeTagList() { 
	if(!constructed) construct();    //Just in case.
	return paramHash; 
    }

    /**
     * Returns the value for a particular tag.
     */ 
    public String getCodeTagValue(String paramName) {
	if(paramHash.containsKey(paramName)) {
	    return (String)paramHash.get(paramName);
	}
	else {
	    System.err.println("Parameter not found for this code!");
	    return null;
	}
    }
    

    /**
     * Returns the list of host machines that offer this code.
     */ 
        
    public Vector getHostList() { return hostList; }
    public Vector getHostListNames() { return hostListNames; }
    public Vector getVizList() { return vizList; }
    public Vector getVizListNames() { return vizListNames; }

}



