
import WebFlow.*;
import WebFlow.VtkModule.*;
import WebFlow.event.*;
import org.omg.CORBA.*;
import java.io.*;
import java.awt.*;
import java.awt.event.*;
import java.net.*;
import java.util.*;

public class Client{

    public static void main(String args[]) {
	try {
	    //  Create ORB
	    Properties props = System.getProperties();
	    props.put("org.omg.CORBA.ORBClass", "com.ooc.CORBA.ORB");
	    props.put("org.omg.CORBA.ORBSingletonClass", "com.ooc.CORBA.ORBSingleton");
	    System.setProperties(props);
	    ORB orb = ORB.init(args, props);

	    //Connect to the master server
	    
	    /*
	    if(args.length !=2) {
		System.out.println("Usage:");
		System.out.println("   WebFlow.JobService.Client url xml");
		System.out.println("     url - url to the master's IOR");
		System.out.println("     filename - where the script is to be written");
		System.exit(1);
	    }
	    */

	    String masterURL = args[0] ; 

	    String ref ; 
	    org.omg.CORBA.Object obj = null ; 
	    System.out.println(" masterURL : "+masterURL);

	    ref = getIORFromURL(masterURL);
	    System.out.println("REF: "+ref);

	    obj = orb.string_to_object(ref);

	    if(obj == null)
		throw new RuntimeException(); 

	    WebFlowContext ws =  WebFlowContextHelper.narrow(obj);
	    System.out.println("Clinet: got master "+ws);
  
	    if(ws == null)
		throw new RuntimeException(); 
         
	    org.omg.CORBA.Object p1 = ws.addNewModule("VtkModule"); 
	    VtkModule vm = VtkModuleHelper.narrow(p1);   
	    vm.test();

	    vm.vtkInit();
            vm.vtkRotate(100.0, 50.0);
            vm.vtkScale(-15.0);
	    vm.getCaptureImg("C:\\GOW\\WEB-INF\\src\\BeanContext_2.2.3\\VtkModule\\block1.ps");

            vm.vtkInit();
	    vm.vtkRotate(200.0,100.0);
	    vm.vtkScale(-35.0);
	    vm.getCaptureImg("C:\\GOW\\WEB-INF\\src\\BeanContext_2.2.3\\VtkModule\\block2.ps");
	    System.out.println("vtk is done!!!");


	} catch(COMM_FAILURE ex) {
	    System.out.println("Command_Error: "+ex);
	    System.err.println(ex.getMessage());
	    ex.printStackTrace();
	    System.exit(1);
	} 
    }
    
    static public String getIORFromURL(String url) {

	System.out.println("Slave WebFlow is getting IOR from url:"+url);
	String masterServerIOR ="";
	String thisLine = null;

	//Open the URL for reading

	try{
	    URL u = new URL(url);
	    // now turn the URL into a DataInputStream

	    try{
		java.io.DataInputStream theHTML = new java.io.DataInputStream(u.openStream());
		while((thisLine = theHTML.readLine()) != null){
		    masterServerIOR += thisLine;
		}
	    }
	    catch(Exception e){
		System.out.println("configReader:getIORfromURL:"+e);
	    }
	}
	catch(Exception e){
	    System.out.println("configReader:getIORfromURL:"+e);
	}
	return masterServerIOR;
    }
}




