/**
 * Program: VtkModuleImpl.java
 * Comments: A WebFlow module for visualizing data using the vtk. 
 *
 */

package WebFlow.VtkModule;

import WebFlow.*;
import vtk.*;
import java.awt.*;
import java.awt.event.*;
//import java.applet.*;
import java.io.FileInputStream;
import java.net.URL;

public class VtkModuleImpl extends WebFlow.BeanContextChildSupport
    implements VtkModuleOperations { 
    
    String msg_;
    org.omg.CORBA.Object peer;

    VTKModel md;
    public String mdname = null;
    public String message = null;
    public vtkPolyDataReader pr = null;
    public vtkWarpVector warp = null;
    public vtkGeometryFilter ds2poly = null;
    public vtkCleanPolyData clean = null;
    public vtkPolyDataNormals normals = null;
    public vtkVectorDot color = null;
    public vtkDataSetMapper plateMapper = null;
    public vtkPanel panel = null;
    public vtkActor a = null;
    public vtkCamera cam = null;

    public VtkModuleImpl(org.omg.CORBA.Object peer, String msg) 
	throws WebFlow.NullPointerException {
	super(peer);
	this.peer=peer;
	String msg_=msg;

        /*
	panel = new vtkPanel();
	panel.resize(400,400);

	FileInputStream is = null;
	try {	
	    mdname = "C:\\GOW\\WEB-INF\\src\\BeanContext_2.2.3\\VtkModule\\plate.vtk";
	    is = new FileInputStream(mdname);
	    md = new VTKModel(is);

	    // create the model
	    pr = new vtkPolyDataReader();
	    pr.ReadFromInputStringOn();
	    pr.SetInputString(md.GetData());
	
	    //pr.SetFileName("plate.vtk");

	    //pr.SetVectorsName("mode1");
	    pr.SetVectorsName("mode4");
	    warp = new vtkWarpVector();
	    warp.SetInput(pr.GetOutput());
	    warp.SetScaleFactor(0.5);
	    ds2poly = new vtkGeometryFilter();
	    ds2poly.SetInput(warp.GetOutput());
	    clean = new vtkCleanPolyData();
	    clean.SetInput(ds2poly.GetOutput());
	    normals = new vtkPolyDataNormals();
	    normals.SetInput(clean.GetOutput());
	    color = new vtkVectorDot();
	    color.SetInput(normals.GetOutput());
	    plateMapper = new vtkDataSetMapper();
	    //plateMapper.ScalarVisibilityOff();
	    plateMapper.ScalarVisibilityOn();
	    plateMapper.SetInput(color.GetOutput());
	    plateMapper.SetScalarRange(-1,1);
	    a = new vtkActor();
	    a.SetMapper(plateMapper);

	    panel.getRenderer().AddActor(a);
	    //panel.getRenderer().SetStartRenderMethod(this,"testme");
	    cam =  panel.getCamera();

	    //vtkRotate(100.0, 50.0);
	    //vtkScale(-15.0);

	} catch(Exception e) {
	    e.printStackTrace();
	    md = null;
	    message = e.toString();
	}
	try {
	    if (is != null) is.close();
	} catch(Exception e) { }
        */

    }
    
    public void test() {
	System.out.println("VtkModule is up");
    }
    
    public void vtkInit() {
	panel = new vtkPanel();
	panel.resize(400,400);

	FileInputStream is = null;
	try {	
	    mdname = "C:\\GOW\\WEB-INF\\src\\BeanContext_2.2.3\\VtkModule\\plate.vtk";
	    is = new FileInputStream(mdname);
	    md = new VTKModel(is);

	    // create the model
            //System.out.println("Vtk start!!!!!!");
	    pr = new vtkPolyDataReader();
	    pr.ReadFromInputStringOn();
	    pr.SetInputString(md.GetData());

            //System.out.println("vtkPolyDataReader: ");
	    //pr.SetFileName("plate.vtk");

	    //pr.SetVectorsName("mode1");
	    pr.SetVectorsName("mode4");
	    warp = new vtkWarpVector();
	    warp.SetInput(pr.GetOutput());
	    warp.SetScaleFactor(0.5);
            //System.out.println("vtkWarpVector: ");


	    ds2poly = new vtkGeometryFilter();
	    ds2poly.SetInput(warp.GetOutput());
            //System.out.println("vtkGeometryFilter: ");

	    clean = new vtkCleanPolyData();
	    clean.SetInput(ds2poly.GetOutput());
            //System.out.println("vtkCleanPolyData: ");

	    normals = new vtkPolyDataNormals();
	    normals.SetInput(clean.GetOutput());
            //System.out.println("vtkPolyDataNormals: ");

	    color = new vtkVectorDot();
	    color.SetInput(normals.GetOutput());
            //System.out.println("vtkVectorDot: ");

	    plateMapper = new vtkDataSetMapper();
	    //plateMapper.ScalarVisibilityOff();
	    plateMapper.ScalarVisibilityOn();
	    plateMapper.SetInput(color.GetOutput());
	    plateMapper.SetScalarRange(-1,1);
            //System.out.println("vtkDataSetMapper: ");

	    a = new vtkActor();
	    a.SetMapper(plateMapper);

            //System.out.println("vtkActor: ");
	    panel.getRenderer().AddActor(a);
            //System.out.println("AddActor: ");
	    //panel.getRenderer().SetStartRenderMethod(this,"testme");
            //System.out.println("panel renderer: ");

	    cam =  panel.getCamera();
            //System.out.println("vtkRotating start.....");
	    //vtkRotate(100.0, 50.0);
            //System.out.println("vtkscaling start.....");
	    //vtkScale(-15.0);
            System.out.println("Setting done.......");

	} catch(Exception e) {
	    e.printStackTrace();
	    md = null;
	    message = e.toString();
	}
	try {
	    if (is != null) is.close();
	} catch(Exception e) { }
    }

    public void vtkRotate(double azimuth, double elevation) {
      System.out.println("Rotate setting up Start.......");
	cam = panel.getRenderer().GetActiveCamera();
	panel.getRenderWindow().SetDesiredUpdateRate(5.0);
	cam.Azimuth(azimuth); //100.0
	cam.Elevation(elevation); //50.0
	cam.OrthogonalizeViewUp();
	panel.getRenderer().ResetCameraClippingRange();
	panel.getLight().SetPosition(cam.GetPosition());
	panel.getLight().SetFocalPoint(cam.GetFocalPoint());
      System.out.println("Rotate setting up Done.......");
    }

    public void vtkScale(double scalefactor) {
	double zoomFactor;
	double clippingRange[];

      System.out.println("Scale setting up Start.......");
	zoomFactor = Math.pow(1.02,scalefactor);
	System.out.println("Zoom Factor: "+zoomFactor);
	cam = panel.getRenderer().GetActiveCamera();
    
	if (cam.GetParallelProjection() == 1) {
	    cam.SetParallelScale(cam.GetParallelScale()/zoomFactor);
	} else {
	    cam.Dolly(zoomFactor);
	    panel.getRenderer().ResetCameraClippingRange();
	}
      System.out.println("Scale setting up Done.......");
    }

    public void getCaptureImg(String filename) {
 
	//panel.Render();
      System.out.println("Imaging capturing start.......");
      pr.Update();
      panel.getRenderWindow().Render();
	
	vtkRendererSource vtkrs = new vtkRendererSource();
	vtkrs.SetInput(panel.getRenderer());
	vtkrs.WholeWindowOn();

	vtkPostScriptWriter vtkps = new vtkPostScriptWriter();
	//vtkTIFFWriter vtkps = new vtkTIFFWriter();
	//vtkBMPWriter vtkps = new vtkBMPWriter();
	vtkps.SetInput(vtkrs.GetOutput());
	vtkps.SetFileName(filename);
	vtkps.Write();
      System.out.println("Imaging capturing Done.......");
    }
}






