/** 
 * Draw image, just scribble feature added
 */
import java.awt.*;
import javax.swing.*;
import java.awt.event.*; 
import javax.swing.event.*;
import java.util.*;
import java.awt.geom.*;
import org.apache.batik.util.awt.svg.SVGGraphics2D;

public class DrawPanel extends JPanel 
    implements MouseListener, MouseMotionListener {
    
    Vector lines = new Vector();
    Vector colors = new Vector();
    int x1,y1;
    int x2,y2;
    int xl, yl;
    public ViewerFrame vf;
    public SVGGraphics2D svg2d;
    
    public DrawPanel(ViewerFrame vf) {
	this.vf=vf;
	svg2d=vf.getMain().getSVGGenerator();
	setBackground(Color.white);
	setForeground(Color.black);
	addMouseMotionListener(this);
	addMouseListener(this);
    }
    
    public void mouseDragged(MouseEvent e) {
	e.consume();
	colors.addElement(getForeground());
	lines.addElement(new Rectangle(x1, y1, e.getX(), e.getY()));
	x1 = e.getX();
	y1 = e.getY();
	
	repaint();
    }
    
    public void mouseMoved(MouseEvent e) {
	//  	statusBar.setXPosition(e.getX());
	//  	statusBar.setYPosition(e.getY());
    }
    
    public void mousePressed(MouseEvent e) {
	e.consume();
	colors.addElement(getForeground());
	lines.addElement(new Rectangle(e.getX(), e.getY(), -1, -1));
	x1 = e.getX();
	y1 = e.getY();
	repaint();
    }
    
    public void mouseReleased(MouseEvent e) {
	e.consume();
    }
    
    public void mouseEntered(MouseEvent e) {
    }
    
    public void mouseExited(MouseEvent e) {
    }
    
    public void mouseClicked(MouseEvent e) {
    }
    
    /**
     * We have two graphics images to manage.  g draws on the
     * canvas and svg2d is the SVG graphics image that will be
     * drawn afterwards.
     */
    public void paintComponent(Graphics g){
	super.paintComponent(g);
	Graphics2D g2d=(Graphics2D)g;

	int np = lines.size();
	
	/* draw the current lines */
	svg2d.setColor(getForeground());
	svg2d.setPaintMode();
	g2d.setColor(getForeground());
	g2d.setPaintMode();

  	//New stuff
    	GeneralPath path=new GeneralPath();
	if(lines.size()>0) {
	    Rectangle p=(Rectangle)lines.elementAt(0);
	    path.moveTo(p.x,p.y);
	    for(int i=1;i<np;i++) {
		p=(Rectangle)lines.elementAt(i);
		path.lineTo(p.x,p.y);
	    }
	    g2d.draw((Shape)path);
	    svg2d.draw((Shape)path);
	}

	//Original stuff
//    	for (int i=0; i < np; i++) {
//    	    Rectangle p = (Rectangle)lines.elementAt(i);
//    	    svg2d.setColor((Color)colors.elementAt(i));
//    	    g2d.setColor((Color)colors.elementAt(i));
//    	    if (p.width != -1) {
//    		svg2d.drawLine(p.x, p.y, p.width, p.height);
//    		g2d.drawLine(p.x, p.y, p.width, p.height);
//    	    } else {
//    		svg2d.drawLine(p.x, p.y, p.x, p.y);
//    		g2d.drawLine(p.x, p.y, p.x, p.y);
//  	    }
//      }
    }
    
    public void clearpaint(Graphics g) {
	//g.setColor(getForeground());
	lines = new Vector();
	colors = new Vector();
	paintComponent(g);
    }
    
    public Graphics2D getGraphics2D() { return svg2d; } 

}
