/**
 * Program SVGChemistry.java
 * @author Marlon Pierce
 *
 * Sets up the chemistry data I got from Paul.
 */

import org.escience.XSIL.*;
import java.awt.*;
import java.awt.geom.*;
import java.io.*;
import javax.swing.*;
import java.awt.image.*;
import java.util.Vector;
import extensions.generic.*;

//Change the following to the new package names when I make them.
//import org.apache.batik.apps.svgviewer.Application;
//import org.apache.batik.apps.svgviewer.ViewerFrame;
import org.apache.batik.util.awt.svg.SVGGraphics2D;
import org.apache.batik.dom.svg.SVGOMDocument;


public class SVGChemistry extends WhiteBoardComp {
  protected Application application;
  protected Main main;
  protected ViewerFrame vf;
  protected GraphicsManager gm;
  protected Color color;
  protected SVGGraphics2D g2d;
  static extensions.generic.parseXMLList parsexmllist;
  static XSIL root;
  static extensions.generic.SVGChemXSIL svgchemxsil;

  double [][] xydata;
  double [] xydataxsil;
  double xymin,xymax;
    
  //This needs to be collected from some meta data file.
  int xdim,ydim;
  int xpart,ypart;

  int frameXDim,frameYDim;

  public SVGChemistry(Main main) {
    super();
    this.main=main;
  }
    
  /**
   * Initialize local copies of other system components.  Note that
   * we do this here and not in the constructor because their 
   * initialization completes after this particular WhiteBoardComp object.
   */
    public void init() {
	vf=main.getViewerFrame();
//   	frameXDim=vf.thecanvas.getWidth();
//  	frameYDim=vf.thecanvas.getHeight();
    }
    
    public WhiteBoardComp getShape() {
	return this;
    }
    
    /**
     * This loads the data from the file.  This is file specific.
     */
    public void loadDataFile(String fileName){
	System.out.println("Loading data...");
	root = new XSIL(fileName,true);
	XSIL child;
	
	for(int ichild=0;ichild<root.getChildCount();ichild++) {
	    child = root.getChild(ichild);
	    parsexmllist = (extensions.generic.parseXMLList)child;
	}
	
	Vector chemicaldataList = parsexmllist.getParseXMLsvgchemical();
	Vector chemicaldataName = parsexmllist.getParseXMLsvgchemicalName();
	svgchemxsil = (extensions.generic.SVGChemXSIL)
	    chemicaldataList.elementAt(0);
	xdim = Integer.parseInt(svgchemxsil.getXdim());
	System.out.println("XDIM: "+xdim);
	ydim = Integer.parseInt(svgchemxsil.getYdim());
	System.out.println("YDIM: "+ydim);
//  	xpart = Integer.parseInt(svgchemxsil.getXpart());
//  	System.out.println("XPART: "+xpart);
//  	ypart = Integer.parseInt(svgchemxsil.getYpart());
//  	System.out.println("YPART: "+ypart);
	xydataxsil = new double[xdim*ydim];
	xydata = new double[xdim][ydim];
	xydataxsil = svgchemxsil.getChemicaldata();
	
	//Read data from file.
	int k = 0;
	for (int i=0;i<xdim;i++){
	    for (int j=0;j<ydim;j++) {
		xydata[i][j]=xydataxsil[k];
		//System.out.println(xydataxsil[k]);
		k++;
	    }
	}	    
	
	//Determine maximum value.
	xymin=xydata[0][0];
	xymax=xydata[0][0];
	for (int i=0;i<xdim;i++){
	    for (int j=0;j<ydim;j++) {
		if(xydata[i][j]>xymax)
		    xymax=xydata[i][j];
		if(xydata[i][j]<xymin)
		    xymin=xydata[i][j];
	    }
	}    
	System.out.println("Data read");
    }
    
    /**
     * Create the graphics object for the shape.  
     */
    
    //Some hacked up ugly code that I should improve on.
    public void drawShape(SVGGraphics2D g2d, int ipart,int jpart) {    	
	this.g2d=g2d;
	System.out.println("Drawing shape");
	//BufferedImage image=new BufferedImage(vf.graphcanvas.getWidth(),
	//  		       vf.graphcanvas.getHeight(),
	//  		       BufferedImage.TYPE_INT_ARGB);
	
	BufferedImage image=new BufferedImage(vf.thecanvas.getWidth(),
					      vf.thecanvas.getHeight(),
                                          BufferedImage.TYPE_INT_ARGB);
	
	Rectangle rect=vf.getGraphPanel().getGraphRectangle();
	int itrans,jtrans;
	frameXDim=(int)rect.getWidth();
	frameYDim=(int)rect.getHeight();
	itrans=(int)rect.getX();
	jtrans=(int)rect.getY();

	Graphics2D gImage=image.createGraphics();
	
	int red,green,blue,index;
	int vertical_boxes=xdim;
	int horiz_boxes=ydim;
	double xyval;
	
	//The joys of integer division.
	int dx=(frameXDim)/horiz_boxes;
	int dy=(frameYDim)/vertical_boxes;
	
	System.out.println("About to draw shape...");
	long start;
	long finish;
	start=System.currentTimeMillis();
	setYPosition(0);
	
	System.out.println("Test:"+ipart+" "+jpart);
	for(int i=0;i<horiz_boxes;i++) {
	    for(int j=0;j<vertical_boxes;j++) {
		//int ishift=ipart*horiz_boxes+i;
		//int jshift=(jpart+1)*vertical_boxes-1-j;
		int ishift=i;
		int jshift=vertical_boxes-1-j;
		int xstart=ishift*dx +itrans;
		int ystart=jshift*dy+jtrans;
		xyval=xydata[ishift][jshift];
		index=(int)((2.*256.-1.)*(xyval-xymin)/(xymax-xymin));
		if(index<256){
		    blue=255-index;
		    green=index;
		    red=0;
		}
		else if(index==256){
		    blue=0;
		    green=255;
		    red=0;
		}
		else if((index>256)&&(index<=511)){
		    blue=0;
		    green=511-index;
		    red=index-256;
		}
		//Something went wrong, so mark as white.
		else {
		    System.out.println("Invalid index: "+index);
		    blue=255;
		    green=255;
		    red=255;
		}
		float redf=(float)red/(float)255;
		float greenf=(float)green/(float)255;
		float bluef=(float)blue/(float)255;
		
		g2d.setColor(new Color(redf,greenf,bluef));
		g2d.fillRect(xstart,ystart+getYPosition(),dx,dy);
	    }
	}
	
	finish=System.currentTimeMillis();
	System.out.println("Shape drawn.");
	System.out.println(finish-start);
	
	//Now create the new document and load the shape.
	SVGOMDocument chemdoc=writeSVGDocToMemory(g2d);
	
	//Put header information around the document and display it.
	SVGOMDocument chemdoc1=updateBaseDoc(chemdoc,vf.getTheDoc());
	vf.appendFragToDoc(vf.thecanvas,chemdoc1);

	//Store the graphics object in a Vector
	vf.svgObjVec.add(chemdoc);
    }
    
    /**
     * Provide access to the X and Y partitioning sizes.  The data may
     * be partitioned for quicker loading and display.
     */
    public int getXPart() { return xpart; }
    public int getYPart() { return ypart; }
}


