package extensions.generic;
import org.escience.XSIL.*;
import java.util.*;

public class SVGChemXSIL extends XSIL {

  public String xDim;
  public String yDim;
  public String xPart;
  public String yPart;

  public double[] chemicaldata;

  boolean instantiated = false;

  public void construct(){
	
    xDim = null;
    yDim = null;
    xPart = null;
    yPart = null;
    chemicaldata = null;;
    
    for(int ichild=0; ichild < getChildCount(); ichild++){
      XSIL x = getChild(ichild);
      if(x instanceof Param){
        Param p = (Param)x;
        if(p.getName().equals("Xdim"))
          xDim = p.getText();
        if(p.getName().equals("Ydim"))
          yDim = p.getText();
        if(p.getName().equals("Xpart"))
          xPart = p.getText();    		   
        if(p.getName().equals("Ypart"))
          yPart = p.getText();    		   
      }
    }
  }

  // This function does the heavy lifting of reading arrays and so on
  // It is separate from the construction because it is not called unless necessary.

  public void instantiate(){
    
    for(int ichild=0; ichild < getChildCount(); ichild++){
      XSIL x = getChild(ichild);

      if(x instanceof Param){
        Param p = (Param)x;
        if(p.getName().equals("Xdim"))
          xDim = p.getText();
        if(p.getName().equals("Ydim"))
          yDim = p.getText();
        if(p.getName().equals("Xpart"))
          xPart = p.getText();    		   
        if(p.getName().equals("Ypart"))
          yPart = p.getText();    		   
      }
	    
      if(x instanceof Array){
        Array a = (Array)x;
        int xdimint = Integer.parseInt(xDim.trim());
        int ydimint = Integer.parseInt(yDim.trim());

        if(a.getNdata() != xdimint*ydimint) continue;
		
        if(a.getName().equals("data")){
          chemicaldata = a.getPrimArray().getDoubleArray(0, xdimint*ydimint);
          if(chemicaldata.length < xdimint*ydimint) {
            System.out.println("Java3D: Chemicaldata Array size is " + 
               chemicaldata.length+ " (expected " + xdimint*ydimint + ")");
            chemicaldata = null;
          }
        }
      }
    }
  }

  public String getXdim() {
    return xDim.trim();
  }

  public String getYdim() {
    return yDim.trim();
  }

  public String getXpart() {
    return xPart.trim();
  }	

  public String getYpart() {
    return yPart.trim();
  }	
  public double[] getChemicaldata() {	
    if(!instantiated) instantiate();
    return chemicaldata; 
  }
	      
  public String toString(){
    return "SVGChemXSIL [" + xDim + " Dimension]";
  }
}
