/**
 * Program: SVGText.java
 * Writes text onto a screen.
 */

import java.awt.*;
import java.awt.geom.*;
import java.util.*;
import java.awt.event.*;
import java.io.*;
import houseblend.*;
//import org.apache.batik.dom;
//import org.apache.batik.apps.svgviewer.Application;
//import org.apache.batik.apps.svgviewer.ViewerFrame;
import org.apache.batik.dom.svg.SVGDocumentFactory;
import org.xml.sax.InputSource;
import org.apache.batik.util.awt.svg.SVGGraphics2D;
import org.apache.batik.dom.svg.SVGOMDocument;
import org.w3c.dom.*;
import org.apache.batik.util.SVGConstants;

public class SVGWBText extends WhiteBoardComp {    
    protected Main main;
    protected ViewerFrame vf;
    protected GraphicsManager gm;
    protected SVGOMDocument textdoc,newfrag;
    protected DocumentFragment frag;
    
    protected int xpart=1,ypart=1;
    protected String textToWrite=null;
    protected HersheyFont mathlow;
    protected Font f;
    int xposition,yposition;
    int xold,yold;

    int flag;

    public SVGWBText(Main main){
	super();
	this.main=main;
	vf=main.getViewerFrame();
	mathlow=new HersheyFont("HersheyFont/mathupp.jhf");
	f=main.getFont(); //new Font("SansSerif",Font.PLAIN,18);
  	setYPosition(10);
	flag=3;  //Skip the flagged portion.
    }

    public WhiteBoardComp getShape(){
	return this; 
    }
    
    public void test() {
	System.out.println("SVGWBText is available");
    }
    
    /**
     * Loads the text captured from the screen.
     */
    public void loadDataFile(String screenText) {
	textToWrite=screenText;
    }

    public void drawShape(SVGGraphics2D g2d,int i,int j) {
 	xposition=i;  //,yposition=0;
	xold=xposition;
	setYPosition(j);
	yold=getYPosition();
  	int iword,istep,istart,ifinish,wordsize;
	int height=0,width;
	int ystart=15;

	StringBuffer theBuffer=new StringBuffer(textToWrite);
	if(theBuffer.charAt(theBuffer.length()-1)!=' ')
	    theBuffer.append(' ');
	istart=0;
	istep=0;
	ifinish=0;
	
	while(ifinish<theBuffer.length()-1) {
	    istep=0;
	    while(theBuffer.charAt(istart+istep)!=' ') {
		istep++;
	    }
	    istep++;  //Get past blank character.
	    if(istart+istep<theBuffer.length()) {
		ifinish=istart+istep;
	    }
	    else {
		ifinish=istart+istep-1;
	    }
	    
	    String word=theBuffer.substring(istart,ifinish); 

	    //This whole crappy if-else block should be improved.
	    //Integral symbol is "p" in the mathupp font.
	    if(word.trim().equals("<int>")) {
		height=18;  //A hack that will work only with the test font.
		String line="  p  ";
		g2d.setColor(Color.black);
		mathlow.setHeight(.4f);
		mathlow.setWidth(.5f);
		mathlow.setVerticalAlignment(HersheyFont.VERTICAL_TOP);
		mathlow.setHorizontalAlignment(HersheyFont.HORIZONTAL_CENTER);
		mathlow.drawString(line,xposition+3,getYPosition()-5,(Graphics)g2d);
		wordsize=10;
	    }
	    //Sqrt symbol is "b" in the mathupp font.
	    else if(word.trim().equals("<sqr>")){
		height=18; //A hack using the normal word size for this font.
		String line="  b  ";
		g2d.setColor(Color.black);
		mathlow.setHeight(.4f);
		mathlow.setWidth(.5f);
		mathlow.setVerticalAlignment(HersheyFont.VERTICAL_TOP);
		mathlow.setHorizontalAlignment(HersheyFont.HORIZONTAL_CENTER);
  		mathlow.drawString(line,
				   xposition+3,getYPosition()-5,
				   (Graphics)g2d);
		wordsize=10;
		
	    }
	    //Partial symbol is "m" in the mathupp font.
	    else if(word.trim().equals("<par>")){
		height=18; //A hack using the normal word size for this font.
		String line="  m  ";
		g2d.setColor(Color.black);
		mathlow.setHeight(.4f);
		mathlow.setWidth(.5f);
		mathlow.setVerticalAlignment(HersheyFont.VERTICAL_TOP);
		mathlow.setHorizontalAlignment(HersheyFont.HORIZONTAL_CENTER);
  		mathlow.drawString(line,xposition+3,
				   getYPosition()-5,
				   (Graphics)g2d);
		wordsize=10;
		
	    }
	    //Delta symbol is "n" in the mathupp font.
	    else if(word.trim().equals("<del>")){
		height=18; //A hack using the normal word size for this font.
		String line="  n  ";
		g2d.setColor(Color.black);
		mathlow.setHeight(.4f);
		mathlow.setWidth(.5f);
		mathlow.setVerticalAlignment(HersheyFont.VERTICAL_TOP);
		mathlow.setHorizontalAlignment(HersheyFont.HORIZONTAL_CENTER);
  		mathlow.drawString(line,xposition+3,
				   getYPosition()-5,
				   (Graphics)g2d);
		wordsize=10;
		
	    }
	    else {
		g2d.setFont(f);
		g2d.setColor(new Color(0,0,0));
		FontMetrics fm=g2d.getFontMetrics(f);
		Rectangle2D rect=fm.getStringBounds(word,g2d);
		width=(int)rect.getWidth();
		height=(int)rect.getHeight()+1;
		g2d.drawString(word,xposition,ystart+getYPosition());
		wordsize=width;
	    }

	    istart=ifinish;
	    xposition+=wordsize+5;  
	    if(xposition>main.getSize().getWidth()) {
		xposition=0;
		setYPosition(getYPosition()+height);
	    }
	}
	setYPosition(getYPosition()+height);
	System.out.println("Line position:"+getYPosition());
	writeSVG(g2d);
    }
    
    /**
     * Move the SVG document to memory and then fill out the 
     * local SVGOMDocument.
     */
    public void writeSVG(SVGGraphics2D g2d){
	textdoc=writeSVGDocToMemory(g2d);
	//Create a new canvas that is just big enough to hold
	//the text we just created. Translate the SVG so that
	//it appears in the box.
	SVGOMDocument textdoc1=updateBaseDoc(textdoc,vf.makeNewDoc());
	JSVGCanvas localcanvas=new JSVGCanvas(vf);
	localcanvas.setBounds(xold,yold,xposition-xold,
			      getYPosition()-yold+1);
	localcanvas.setOpaque(false);
	textdoc1=addTranslation(xold,yold,textdoc1);
	vf.canvaspane.add(localcanvas,new Integer(10));
	vf.canvaspane.moveToBack(vf.thecanvas);	    
	vf.appendFragToDoc(localcanvas,textdoc1); 
	
	vf.svgObjVec.add(localcanvas);
    }
    
    /**
     * This method translates the text so that it appears in the
     * canvas we just created.
     */
    public SVGOMDocument addTranslation(int xold,int yold,
					SVGOMDocument textdoc1) {
	String transString="translate(-"+xold+",-"+yold+")";
	NodeList childList=textdoc1.getChildNodes();
	NodeList gcList,ggcList;
	Node saveNode;
	for(int index=0;index<childList.getLength();index++) {
	    Node child=childList.item(index);
	    gcList=child.getChildNodes();
	    for(int j=0;j<gcList.getLength();j++) {
		String name=gcList.item(j).getNodeName();
		ggcList=gcList.item(j).getChildNodes();
		if(name.equals("g") && ggcList.getLength()==1) {
		    Element elem=(Element)ggcList.item(0);
		    elem.setAttribute("transform",transString);
		}
		else {
		    System.out.println(name +" is not what we want");
		}
	    }
	    
	}

//  	try {
//    	    Writer stdout=new OutputStreamWriter(System.out,"UTF-8");
//    	    XmlWriter.writeXml(textdoc1,stdout);
//    	    stdout.flush();
//  	}
//  	catch (Exception ex) { ex.printStackTrace(); }
	return textdoc1;
    }

    /**
     * This method initializes various objects.
     */
    public void init(){
	
    }

    public int getXPart() { return xpart; }
    public int getYPart() { return ypart; } 

}

