/**
 * Program: SVGWBDraw.java
 * Writes image onto a screen.
 */

import java.awt.*;
import java.awt.geom.*;
import java.util.*;
import java.awt.event.*;
import java.io.*;
//import org.apache.batik.dom;

//import org.apache.batik.apps.svgviewer.Application;
//import org.apache.batik.apps.svgviewer.ViewerFrame;
import org.apache.batik.dom.svg.SVGDocumentFactory;
import org.xml.sax.InputSource;
import org.apache.batik.util.awt.svg.SVGGraphics2D;
import org.apache.batik.dom.svg.SVGOMDocument;
import org.w3c.dom.*;
import org.apache.batik.util.SVGConstants;
import org.apache.batik.util.gui.resource.*;

public class SVGWBDraw extends WhiteBoardComp {    
  protected Main main;
  protected ViewerFrame vf;
  protected SVGOMDocument drawdoc;

  protected int xpart=1, ypart=1;

  public final static String RESOURCES =
    //        "org.apache.batik.apps.svgviewer.resources.GUI";
    "resources.GUI";
  protected static ResourceBundle bundle;
  protected static ResourceManager resources;
  static {
    bundle    = ResourceBundle.getBundle(RESOURCES, Locale.getDefault());
    resources = new ResourceManager(bundle);
  }

  public SVGWBDraw (Main main){
    super();
    this.main=main;
    vf=main.getViewerFrame();
  }

  public WhiteBoardComp getShape(){
    return this; 
  }
    
  public void test() {
    System.out.println("SVGWBDraw is available");
  }
    
  /**
   * Loads the text captured from the screen.
   */
  public void loadDataFile(String screenText) {
  }

  public void drawShape(SVGGraphics2D g2d,int i,int j) {
    writeSVG(g2d);
  }
    
  /**
   * Move the SVG document to memory and then fill out the 
   * local SVGOMDocument.
   */
  public void writeSVG(SVGGraphics2D g2d){
    drawdoc=writeSVGDocToMemory(g2d);
    SVGOMDocument drawdoc1=updateBaseDoc(drawdoc,vf.getTheDoc());
    //SVGOMDocument drawdoc1=updateBaseDoc(drawdoc,vf.makeNewDoc());
    //JSVGCanvas localcanvasdraw =new JSVGCanvas(vf);
    //localcanvasdraw.setBounds(0,0,resources.getInteger("Frame.width"),
    //                        resources.getInteger("Frame.height")-60);
    //localcanvasdraw.setOpaque(false);
    //drawdoc1=addTranslation(0,0,drawdoc1);
    //vf.canvaspane.add(localcanvasdraw,new Integer(10));
    //vf.canvaspane.moveToBack(vf.thecanvas);	    
    //vf.appendFragToDoc(localcanvasdraw,drawdoc1); 
    vf.appendFragToDoc(vf.thecanvas, drawdoc1); 
	
    //vf.svgObjVec.add(localcanvasdraw);
  }
 
  /**
   * This method translates the drawing so that it appears in the
   * canvas we just created.
   */
  /*
  public SVGOMDocument addTranslation(int xold,int yold,
                                      SVGOMDocument textdoc1) {
    String transString="translate(-"+xold+",-"+yold+")";
    NodeList childList=textdoc1.getChildNodes();
    NodeList gcList,ggcList;
    Node saveNode;
    for(int index=0;index<childList.getLength();index++) {
      Node child=childList.item(index);
      gcList=child.getChildNodes();
      for(int j=0;j<gcList.getLength();j++) {
        String name=gcList.item(j).getNodeName();
        ggcList=gcList.item(j).getChildNodes();
        if(name.equals("g") && ggcList.getLength()==1) {
          Element elem=(Element)ggcList.item(0);
          elem.setAttribute("transform",transString);
        }
        else {
          System.out.println(name +" is not what we want");
        }
      }
      
    }
    
    return textdoc1;
  }
  */   
  /**
   * This method initializes various objects.
   */
  public void init(){
  }

  public int getXPart() { return xpart; }
  public int getYPart() { return ypart; } 

}

