
/*
 * Getting Started with the Java 3D API
 * written in Java 3D
 *
 * This program demonstrates:
 *   1. writing a visual object class
 *      In this program, Axis class defines a visual object
 *      This particular class extends Shape3D
 *      See the text for a discussion.
 *   2. Using LineArray to draw 3D lines.
 */

package extensions.generic;

import javax.media.j3d.*;
import javax.vecmath.*;


    public class AxisObject extends Shape3D{

	// create axis visual object
	public AxisObject() {	
	    this.setGeometry(createGeometry());
/*
    Appearance a = new Appearance();
    a.setCapability( Appearance.ALLOW_COLORING_ATTRIBUTES_READ );
    a.setCapability( Appearance.ALLOW_COLORING_ATTRIBUTES_WRITE );
    a.setCapability( Appearance.ALLOW_LINE_ATTRIBUTES_READ );
    a.setCapability( Appearance.ALLOW_LINE_ATTRIBUTES_WRITE );
	    this.setAppearance(a);

    this.setCapability( Shape3D.ALLOW_APPEARANCE_OVERRIDE_READ );
    this.setCapability( Shape3D.ALLOW_APPEARANCE_OVERRIDE_WRITE );
    this.setCapability( Shape3D.ALLOW_APPEARANCE_READ );
    this.setCapability( Shape3D.ALLOW_APPEARANCE_WRITE );
*/
    this.setCapability( Shape3D.ALLOW_GEOMETRY_READ );
    this.setCapability( Shape3D.ALLOW_GEOMETRY_WRITE );
	}

	public Geometry createGeometry(){
	    // create line for X axis
            IndexedLineArray axisRender = new IndexedLineArray(18, GeometryArray.COORDINATES, 30);

	    axisRender.setCoordinate( 0, new Point3f(-1.4f, 0.0f, 0.0f));
	    axisRender.setCoordinate( 1, new Point3f( 1.4f, 0.0f, 0.0f));
	    axisRender.setCoordinate( 2, new Point3f( 1.3f, 0.1f, 0.1f));
	    axisRender.setCoordinate( 3, new Point3f( 1.3f,-0.1f, 0.1f));
	    axisRender.setCoordinate( 4, new Point3f( 1.3f, 0.1f,-0.1f));
	    axisRender.setCoordinate( 5, new Point3f( 1.3f,-0.1f,-0.1f));
	    axisRender.setCoordinate( 6, new Point3f( 0.0f,-1.4f, 0.0f));
	    axisRender.setCoordinate( 7, new Point3f( 0.0f, 1.4f, 0.0f));
	    axisRender.setCoordinate( 8, new Point3f( 0.1f, 1.3f, 0.1f));
	    axisRender.setCoordinate( 9, new Point3f(-0.1f, 1.3f, 0.1f));
	    axisRender.setCoordinate(10, new Point3f( 0.1f, 1.3f,-0.1f));
	    axisRender.setCoordinate(11, new Point3f(-0.1f, 1.3f,-0.1f));
	    axisRender.setCoordinate(12, new Point3f( 0.0f, 0.0f,-1.4f));
	    axisRender.setCoordinate(13, new Point3f( 0.0f, 0.0f, 1.4f));
	    axisRender.setCoordinate(14, new Point3f( 0.1f, 0.1f, 1.3f));
	    axisRender.setCoordinate(15, new Point3f(-0.1f, 0.1f, 1.3f));
	    axisRender.setCoordinate(16, new Point3f( 0.1f,-0.1f, 1.3f));
	    axisRender.setCoordinate(17, new Point3f(-0.1f,-0.1f, 1.3f));

            axisRender.setCoordinateIndex( 0, 0);
            axisRender.setCoordinateIndex( 1, 1);
            axisRender.setCoordinateIndex( 2, 2);
            axisRender.setCoordinateIndex( 3, 1);
            axisRender.setCoordinateIndex( 4, 3);
            axisRender.setCoordinateIndex( 5, 1);
            axisRender.setCoordinateIndex( 6, 4);
            axisRender.setCoordinateIndex( 7, 1);
            axisRender.setCoordinateIndex( 8, 5);
            axisRender.setCoordinateIndex( 9, 1);
            axisRender.setCoordinateIndex(10, 6);
            axisRender.setCoordinateIndex(11, 7);
            axisRender.setCoordinateIndex(12, 8);
            axisRender.setCoordinateIndex(13, 7);
            axisRender.setCoordinateIndex(14, 9);
            axisRender.setCoordinateIndex(15, 7);
            axisRender.setCoordinateIndex(16,10);
            axisRender.setCoordinateIndex(17, 7);
            axisRender.setCoordinateIndex(18,11);
            axisRender.setCoordinateIndex(19, 7);
            axisRender.setCoordinateIndex(20,12);
            axisRender.setCoordinateIndex(21,13);
            axisRender.setCoordinateIndex(22,14);
            axisRender.setCoordinateIndex(23,13);
            axisRender.setCoordinateIndex(24,15);
            axisRender.setCoordinateIndex(25,13);
            axisRender.setCoordinateIndex(26,16);
            axisRender.setCoordinateIndex(27,13);
            axisRender.setCoordinateIndex(28,17);
            axisRender.setCoordinateIndex(29,13);

            return axisRender;

	} // end of AxisObject createGeometry()

    } // end of class AxisObject
