import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import java.util.Enumeration;
import java.util.HashMap;
import javax.media.j3d.*;
import javax.vecmath.*;
import javax.media.j3d.DirectionalLight;
import javax.media.j3d.PolygonAttributes;
import com.sun.j3d.utils.universe.*;
import com.sun.j3d.utils.applet.MainFrame;
import com.sun.j3d.utils.geometry.Sphere;
import com.sun.j3d.utils.geometry.Box;
import com.sun.j3d.utils.geometry.Cylinder;
import com.sun.j3d.utils.geometry.Cone;


/*
 * Final.java
 *
 * Created on June 2, 2000, 3:13 PM
 */
 


/** 
 *
 * @author  dshahbaz
 * @version 
 */
public class Final extends java.applet.Applet {

  /** Initializes the applet ClassName */
  public void init () {
    initComponents ();
    universe = new VirtualUniverse();
    locale = new Locale( universe );
    shapeTransformGroups = new HashMap();
    shapesMap = new HashMap();

    label1.setText("Mode: Translate");
    XFORM_MODE = XFORM_TRANSLATE;
    cubeCount = sphereCount = cylinderCount = coneCount = lightCount = 0;

    locale.addBranchGraph( 
      createViewplatformGraph( new Vector3f( 0.0f, 0.0f, 20.0f ), canvasXY,
      XY ) );

    locale.addBranchGraph( 
      createViewplatformGraph( new Vector3f( 0.0f, -20.0f, 0.0f), canvasXZ,
      XZ ) );

    locale.addBranchGraph( 
      createViewplatformGraph( new Vector3f( 20.0f, 0.0f, 0.0f), canvasYZ,
      YZ ) );

    perspectiveLoc = new Vector3f( 5f, 5f, 5f );
    locale.addBranchGraph( 
      createViewplatformGraph( perspectiveLoc, canvasPerspective,
                               PERSPECTIVE ) );

    //create some ambience
    BranchGroup bg = new BranchGroup();
    bg.setCapability( BranchGroup.ALLOW_CHILDREN_READ );
    bg.setCapability( BranchGroup.ALLOW_CHILDREN_WRITE );
    AmbientLight al = new AmbientLight( new Color3f(0.6f,0.6f,0.6f) );
    BoundingSphere bounds =
      new BoundingSphere(new Point3d(0.0,0.0,0.0), 1000.0);
    al.setInfluencingBounds( bounds );
    bg.addChild( al );
    locale.addBranchGraph( bg );

    //Create a point light
    createLight( "light1", new Vector3f( 0.0f, -2.0f, 2.0f) );
    list.add( "light1" );
    lightCount++;

    //Create the origin 3-arrow trident thingy
    createOriginArrows();

    Enumeration all = locale.getAllBranchGraphs();
    for( ; all.hasMoreElements() ; ){
      BranchGroup a = (BranchGroup) all.nextElement();
      System.err.println( a );
      Enumeration some = a.getAllChildren();
      for( ; some.hasMoreElements() ; ){
        System.err.println("\t" + some.nextElement() );
      }
    }
  
  }

  /** This method is called from within the init() method to
   * initialize the form.
   * WARNING: Do NOT modify this code. The content of this method is
   * always regenerated by the FormEditor.
   */
        private void initComponents () {//GEN-BEGIN:initComponents
          main = new java.awt.Panel ();
          /*
          canvasXY = new java.awt.Canvas ();
          canvasYZ = new java.awt.Canvas ();
          canvasXZ = new java.awt.Canvas ();
          canvasPerspective = new java.awt.Canvas ();
          */
          GraphicsConfiguration config = SimpleUniverse.getPreferredConfiguration();
          canvasXY = new Canvas3D ( config );
          canvasXY.setBackground( Color.white );
          canvasYZ = new Canvas3D ( config );
          canvasYZ.setBackground( Color.white );
          canvasXZ = new Canvas3D ( config );
          canvasXZ.setBackground( Color.white );
          canvasPerspective = new Canvas3D ( config );
          canvasPerspective.setBackground( Color.white );

          panel2 = new java.awt.Panel ();
          transforms = new java.awt.Panel ();
          button10 = new java.awt.Button ();
          button11 = new java.awt.Button ();
          button12 = new java.awt.Button ();
          button16 = new java.awt.Button ();
          button17 = new java.awt.Button ();
          shapes = new java.awt.Panel ();
          button13 = new java.awt.Button ();
          button14 = new java.awt.Button ();
          button15 = new java.awt.Button ();
          declared = new java.awt.Panel ();
          list = new java.awt.List ();
          renderMode = new java.awt.List ();
          label1 = new java.awt.Label ();
          setLayout (new java.awt.BorderLayout ());

          main.setLayout (new java.awt.GridLayout (2, 2, 2, 2));
          main.setBackground (new java.awt.Color (204, 204, 204));
          main.setForeground (java.awt.Color.black);
          main.setName ("main");
          main.setFont (new java.awt.Font ("Dialog", 0, 11));

            canvasXY.setBackground (java.awt.Color.white);
            canvasXY.setName ("canvasXY");
            canvasXY.addMouseListener (new java.awt.event.MouseAdapter () {
              public void mousePressed (java.awt.event.MouseEvent evt) {
                canvasXYMousePressed (evt);
              }
            }
            );
            canvasXY.addMouseMotionListener (new java.awt.event.MouseMotionAdapter () {
              public void mouseDragged (java.awt.event.MouseEvent evt) {
                canvasXYMouseDragged (evt);
              }
            }
            );
  
            main.add (canvasXY);
  
            canvasYZ.setBackground (java.awt.Color.white);
            canvasYZ.setName ("canvasYZ");
            canvasYZ.addMouseListener (new java.awt.event.MouseAdapter () {
              public void mousePressed (java.awt.event.MouseEvent evt) {
                canvasYZMousePressed (evt);
              }
            }
            );
             canvasYZ.addMouseMotionListener (new java.awt.event.MouseMotionAdapter () {
              public void mouseDragged (java.awt.event.MouseEvent evt) {
                canvasYZMouseDragged (evt);
              }
            }
            );
  
            main.add (canvasYZ);
  
            canvasXZ.setBackground (java.awt.Color.white);
            canvasXZ.setName ("canvasXZ");
            canvasXZ.addMouseListener (new java.awt.event.MouseAdapter () {
              public void mousePressed (java.awt.event.MouseEvent evt) {
                canvasXZMousePressed (evt);
              }
            }
            );
             canvasXZ.addMouseMotionListener (new java.awt.event.MouseMotionAdapter () {
              public void mouseDragged (java.awt.event.MouseEvent evt) {
                canvasXZMouseDragged (evt);
              }
            }
            );
  
            main.add (canvasXZ);
  
            canvasPerspective.setBackground (java.awt.Color.white);
            canvasPerspective.setName ("canvasPerspective");
            canvasPerspective.addMouseListener (new java.awt.event.MouseAdapter () {
              public void mousePressed (java.awt.event.MouseEvent evt) {
                canvasPerspectiveMousePressed (evt);
              }
            }
            );
             canvasPerspective.addMouseMotionListener (new java.awt.event.MouseMotionAdapter () {
              public void mouseDragged (java.awt.event.MouseEvent evt) {
                canvasPerspectiveMouseDragged (evt);
              }
            }
            );
  
            main.add (canvasPerspective);
  

          add (main, java.awt.BorderLayout.CENTER);

          panel2.setLayout (new java.awt.GridLayout (3, 1));
          panel2.setBackground (new java.awt.Color (204, 204, 204));
          panel2.setForeground (java.awt.Color.black);
          panel2.setName ("panel5");
          panel2.setFont (new java.awt.Font ("Dialog", 0, 11));

            transforms.setLayout (new java.awt.GridLayout (3, 1));
            transforms.setBackground (new java.awt.Color (204, 204, 204));
            transforms.setForeground (java.awt.Color.black);
            transforms.setName ("transforms");
            transforms.setFont (new java.awt.Font ("Dialog", 0, 11));
  
              button10.setBackground (new java.awt.Color (212, 208, 200));
              button10.setForeground (java.awt.Color.black);
              button10.setActionCommand ("sphere");
              button10.setLabel ("sphere");
              button10.setName ("button10");
              button10.setFont (new java.awt.Font ("Dialog", 0, 11));
              button10.addMouseListener (new java.awt.event.MouseAdapter () {
                public void mouseClicked (java.awt.event.MouseEvent evt) {
                  sphereMouseClicked (evt);
                }
              }
              );
    
              transforms.add (button10);
    
              button11.setBackground (new java.awt.Color (212, 208, 200));
              button11.setForeground (java.awt.Color.black);
              button11.setActionCommand ("cube");
              button11.setLabel ("cube");
              button11.setName ("cube");
              button11.setFont (new java.awt.Font ("Dialog", 0, 11));
              button11.addMouseListener (new java.awt.event.MouseAdapter () {
                public void mousePressed (java.awt.event.MouseEvent evt) {
                  cubeMousePressed (evt);
                }
              }
              );
    
              transforms.add (button11);
    
              button12.setBackground (new java.awt.Color (212, 208, 200));
              button12.setForeground (java.awt.Color.black);
              button12.setActionCommand ("cylinder");
              button12.setLabel ("cylinder");
              button12.setName ("cylinder");
              button12.setFont (new java.awt.Font ("Dialog", 0, 11));
              button12.addMouseListener (new java.awt.event.MouseAdapter () {
                public void mouseClicked (java.awt.event.MouseEvent evt) {
                  cylinderMouseClicked (evt);
                }
              }
              );
              transforms.add(button12);
    
              button16.setBackground (new java.awt.Color (212, 208, 200));
              button16.setForeground (java.awt.Color.black);
              button16.setActionCommand ("cone");
              button16.setLabel ("cone");
              button16.setName ("cone");
              button16.setFont (new java.awt.Font ("Dialog", 0, 11));
              button16.addMouseListener (new java.awt.event.MouseAdapter () {
                public void mouseClicked (java.awt.event.MouseEvent evt) {
                  coneMouseClicked (evt);
                }
              }
              );
    
              transforms.add (button16);
    
              button17.setBackground (new java.awt.Color (212, 208, 200));
              button17.setForeground (java.awt.Color.black);
              button17.setActionCommand ("light");
              button17.setLabel ("light");
              button17.setName ("light");
              button17.setFont (new java.awt.Font ("Dialog", 0, 11));
              button17.addMouseListener (new java.awt.event.MouseAdapter () {
                public void mouseClicked (java.awt.event.MouseEvent evt) {
                  lightMouseClicked (evt);
                }
              }
              );
    
              transforms.add (button17);
    
            panel2.add (transforms);
  
            shapes.setLayout (new java.awt.GridLayout (3, 1));
            shapes.setBackground (new java.awt.Color (204, 204, 204));
            shapes.setForeground (java.awt.Color.black);
            shapes.setName ("shapes");
            shapes.setFont (new java.awt.Font ("Dialog", 0, 11));
  
              button13.setBackground (new java.awt.Color (212, 208, 200));
              button13.setForeground (java.awt.Color.black);
              button13.setActionCommand ("translate");
              button13.setLabel ("translate");
              button13.setName ("translate");
              button13.setFont (new java.awt.Font ("Dialog", 0, 11));
              button13.addMouseListener (new java.awt.event.MouseAdapter () {
                public void mouseClicked (java.awt.event.MouseEvent evt) {
                  translateMouseClicked (evt);
                }
              }
              );
    
              shapes.add (button13);
    
              button14.setBackground (new java.awt.Color (212, 208, 200));
              button14.setForeground (java.awt.Color.black);
              button14.setActionCommand ("rotate");
              button14.setLabel ("rotate");
              button14.setName ("rotate");
              button14.setFont (new java.awt.Font ("Dialog", 0, 11));
              button14.addMouseListener (new java.awt.event.MouseAdapter () {
                public void mouseClicked (java.awt.event.MouseEvent evt) {
                  rotateMouseClicked (evt);
                }
              }
              );
    
              shapes.add (button14);
    
              button15.setBackground (new java.awt.Color (212, 208, 200));
              button15.setForeground (java.awt.Color.black);
              button15.setActionCommand ("scale");
              button15.setLabel ("scale");
              button15.setName ("scale");
              button15.setFont (new java.awt.Font ("Dialog", 0, 11));
              button15.addMouseListener (new java.awt.event.MouseAdapter () {
                public void mouseClicked (java.awt.event.MouseEvent evt) {
                  scaleMouseClicked (evt);
                }
              }
              );
    
              shapes.add (button15);
    
            panel2.add (shapes);
  
            declared.setBackground (new java.awt.Color (204, 204, 204));
            declared.setForeground (java.awt.Color.black);
            declared.setName ("panel7");
            declared.setFont (new java.awt.Font ("Dialog", 0, 11));
  
              list.setBackground (java.awt.Color.white);
              list.setForeground (java.awt.Color.black);
              list.setName ("list1");
              list.setFont (new java.awt.Font ("Dialog", 0, 11));
              //allow multiple selections:
              list.setMultipleMode( true );
              list.addMouseListener (new java.awt.event.MouseAdapter () {
                public void mouseClicked (java.awt.event.MouseEvent evt) {
                  listMouseClicked (evt);
                }
              }
              );
    
              declared.add (list);
               
              renderMode.setBackground (java.awt.Color.white);
              renderMode.setForeground (java.awt.Color.black);
              renderMode.setName ("renderMode1");
              renderMode.setFont (new java.awt.Font ("Dialog", 0, 11));
              renderMode.add( "Line" );
              renderMode.select( 0 );
              renderMode.add( "Flat" );
              renderMode.addMouseListener (new java.awt.event.MouseAdapter () {
                public void mouseClicked (java.awt.event.MouseEvent evt) {
                  renderModeMouseClicked (evt);
                }
              }
              );
    
              declared.add (renderMode);
    
            panel2.add (declared);
  

          add (panel2, java.awt.BorderLayout.EAST);

          label1.setBackground (new java.awt.Color (204, 204, 204));
          label1.setText ("Mode:");
          label1.setForeground (java.awt.Color.black);
          label1.setName ("xfrom_mode");
          label1.setFont (new java.awt.Font ("Dialog", 0, 11));


          add (label1, java.awt.BorderLayout.SOUTH);

        }//GEN-END:initComponents

  /** This method creates a white PointLight with the given name and position.
   * It also creates a BranchGroup for the light and inserts it into the locale
   * object to make it "alive"
   */
  private void createLight( String name, Vector3f position ){
    BranchGroup objRoot = new BranchGroup();
    objRoot.setCapability( BranchGroup.ALLOW_CHILDREN_READ );
    objRoot.setCapability( BranchGroup.ALLOW_CHILDREN_WRITE );

    Transform3D t = new Transform3D();
    //t.set( new Vector3f( 1.0f, 0.0f, 0.0f ) );
    t.set( position );
    TransformGroup objTrans = new TransformGroup( t );
    objTrans.setCapability( TransformGroup.ALLOW_TRANSFORM_READ );
    objTrans.setCapability( TransformGroup.ALLOW_TRANSFORM_WRITE );
    //Hold on to the TransformGroup for this shape so we can transform it later
    shapeTransformGroups.put( name, objTrans );

    objRoot.addChild( objTrans );

    //Light Color:
    Color3f lColor = new Color3f( 1.0f, 1.0f, 1.0f );
    
    //Make the direction point toward the origin by reversing the vector
    //position.scale(-1.0f);
    BoundingSphere bounds =
      new BoundingSphere(new Point3d(0.0,0.0,0.0), 100.0);

    //DirectionalLight l1 = new DirectionalLight( lColor, position );
    PointLight l1 = new PointLight( lColor, 
        new Point3f( position.x, position.y, position.z ),
        new Point3f( 1.0f, 1.0f, 0.0f) ); //attenuation
    l1.setInfluencingBounds( bounds );
    shapesMap.put( name, l1 );

    //Make a tiny sphere to represent the light source
    Color3f white = new Color3f( 1.0f, 1.0f, 1.0f );
    Material m = new Material( white, white, white, white, 100.0f );
    Appearance a = new Appearance();
    Sphere s = new Sphere(0.2f, Sphere.GENERATE_NORMALS, 10, a);
  
    objTrans.addChild( l1 );
    objTrans.addChild( s );

    locale.addBranchGraph( objRoot );
  }
  
  /** This method creates a shape with passed name and positioned at the passed
   * Vector3f position.  The type of the shape is determined by the first part
   * of the name variable (eg, cube, sphere, cylinder, cone)
   */
  private void createShape( String name, Vector3f position ){
    BranchGroup objRoot = new BranchGroup();
    objRoot.setCapability( BranchGroup.ALLOW_CHILDREN_READ );
    objRoot.setCapability( BranchGroup.ALLOW_CHILDREN_WRITE );

    Transform3D upright = null;
    TransformGroup uprightTG = null;

    Transform3D t = new Transform3D();
    //t.set( new Vector3f( 1.0f, 0.0f, 0.0f ) );
    t.set( position );
    TransformGroup objTrans = new TransformGroup( t );
    objTrans.setCapability( TransformGroup.ALLOW_TRANSFORM_READ );
    objTrans.setCapability( TransformGroup.ALLOW_TRANSFORM_WRITE );
    //Hold on to the TransformGroup for this shape so we can transform it later
    shapeTransformGroups.put( name, objTrans );

    objRoot.addChild( objTrans );

    //Object Color:
    Color3f objColor = new Color3f( 0.0f, 0.2f, 0.9f );

    //Object Color:
    Color3f ambientobjColor = new Color3f( 0.0f, 0.1f, 0.3f );

    //emissive color:
    Color3f eColor = new Color3f( 0.0f, 0.0f, 0.0f ); //black
    
    //specular color:
    Color3f sColor = new Color3f( 1.0f, 1.0f, 1.0f );
    
    Material m = new Material(objColor, eColor, ambientobjColor, sColor, 75.0f);
    PolygonAttributes pa = new PolygonAttributes();
    pa.setCapability( PolygonAttributes.ALLOW_MODE_WRITE );
    pa.setCapability( PolygonAttributes.ALLOW_MODE_READ );
    if( renderMode.getSelectedItem().startsWith("Line") ){
      pa.setPolygonMode( pa.POLYGON_LINE );
    } else /* renderMode.getSelectedItem().startsWith("Fill") */{
      pa.setPolygonMode( pa.POLYGON_FILL );
    }
    pa.setCullFace( pa.CULL_NONE );
    
    Appearance a = new Appearance();
    a.setCapability( Appearance.ALLOW_POLYGON_ATTRIBUTES_READ );
    a.setCapability( Appearance.ALLOW_POLYGON_ATTRIBUTES_WRITE );
    a.setPolygonAttributes( pa );
    m.setLightingEnable(true);
    a.setMaterial(m);

    //Sphere s1 = new Sphere(1.0f, Sphere.GENERATE_NORMALS, 80, a);
    if( name.startsWith("cube") ){
      Box s1 = new Box( 1.0f, 1.0f, 1.0f,
        Box.ENABLE_APPEARANCE_MODIFY|Box.GENERATE_NORMALS, a );
      //Hang on to this shape so we can screw with it later
      shapesMap.put( name, s1 );
  
      objTrans.addChild( s1 );
    } else if( name.startsWith("sphere") ){
      Sphere s1 = new Sphere( 1.0f,
        Sphere.ENABLE_APPEARANCE_MODIFY|Sphere.GENERATE_NORMALS, 16, a );
      //Hang on to this shape so we can screw with it later
      shapesMap.put( name, s1 );
  
      objTrans.addChild( s1 );
    } else if( name.startsWith("cylinder") ){
      Cylinder s1 = new Cylinder( 1.0f, 1.0f, 
        Cylinder.ENABLE_APPEARANCE_MODIFY|Cylinder.GENERATE_NORMALS, a );
      //Hang on to this shape so we can screw with it later
      shapesMap.put( name, s1 );

      //Turn the cylinder upright, so that the base points towards the origin
      upright = new Transform3D();
      upright.rotX( Math.PI / 2.0 );
      uprightTG = new TransformGroup( upright );
      uprightTG.addChild( s1 );
  
      objTrans.addChild( uprightTG );
    } else if( name.startsWith("cone") ){
      Cone s1 = new Cone( 1.0f, 1.0f,
        Cone.ENABLE_APPEARANCE_MODIFY|Cone.GENERATE_NORMALS, a );
      //Hang on to this shape so we can screw with it later
      shapesMap.put( name, s1 );

      //Turn the cylinder upright, so that the base points towards the origin
      upright = new Transform3D();
      upright.rotX( Math.PI / 2.0 );
      uprightTG = new TransformGroup( upright );
      uprightTG.addChild( s1 );
    
      objTrans.addChild( uprightTG );
    }

    locale.addBranchGraph( objRoot );
  }
  
  private void canvasXYMousePressed (java.awt.event.MouseEvent evt) {//GEN-FIRST:event_canvasXYMousePressed
// Add your handling code here:
    System.err.println( "pressed X: " + evt.getX() + " Y: " + evt.getY() );
    lastX = evt.getX();
    lastY = evt.getY();
  }//GEN-LAST:event_canvasXYMousePressed

  private void canvasYZMousePressed (java.awt.event.MouseEvent evt) {//GEN-FIRST:event_canvasYZMousePressed
// Add your handling code here:
    System.err.println( "pressed X: " + evt.getX() + " Y: " + evt.getY() );
    lastX = evt.getX();
    lastY = evt.getY();
  }//GEN-LAST:event_canvasYZMousePressed

  private void canvasXZMousePressed (java.awt.event.MouseEvent evt) {//GEN-FIRST:event_canvasXZMousePressed
// Add your handling code here:
    System.err.println( "pressed X: " + evt.getX() + " Y: " + evt.getY() );
    lastX = evt.getX();
    lastY = evt.getY();
  }//GEN-LAST:event_canvasXZMousePressed

  private void canvasPerspectiveMousePressed (java.awt.event.MouseEvent evt) {//GEN-FIRST:event_canvasPerspectiveMousePressed
// Add your handling code here:
    System.err.println( "pressed X: " + evt.getX() + " Y: " + evt.getY() );
    lastX = evt.getX();
    lastY = evt.getY();
  }//GEN-LAST:event_canvasPerspectiveMousePressed

  private void canvasXYMouseDragged (java.awt.event.MouseEvent evt) {//GEN-FIRST:event_canvasXYMouseDragged
    //System.err.println( "X: " + evt.getX() + " Y: " + evt.getY() );
    System.err.print( "dX: ");
    System.err.print( evt.getX() - lastX );
    System.err.print( " dY: ");
    System.err.print( evt.getY() - lastY );
    System.err.println();
    String items[] = list.getSelectedItems();
    int i;
    for( i = 0; i < items.length; i++ ){
      System.err.println("item: " + items[i]);
      doTransform( XY, evt.getX() - lastX, evt.getY() - lastY, items[i]);
    }
    lastX = evt.getX();
    lastY = evt.getY();
  }//GEN-LAST:event_canvasXYMouseDragged

  private void canvasXZMouseDragged (java.awt.event.MouseEvent evt) {//GEN-FIRST:event_canvasXZMouseDragged
    //System.err.println( "X: " + evt.getX() + " Y: " + evt.getY() );
    System.err.print( "dX: ");
    System.err.print( evt.getX() - lastX );
    System.err.print( " dY: ");
    System.err.print( evt.getY() - lastY );
    System.err.println();
    String items[] = list.getSelectedItems();
    int i;
    for( i = 0; i < items.length; i++ ){
      doTransform( XZ, evt.getX() - lastX, evt.getY() - lastY, items[i]);
    }
    lastX = evt.getX();
    lastY = evt.getY();
   }//GEN-LAST:event_canvasXZMouseDragged

  private void canvasYZMouseDragged (java.awt.event.MouseEvent evt) {//GEN-FIRST:event_canvasYZMouseDragged
    //System.err.println( "X: " + evt.getX() + " Y: " + evt.getY() );
    System.err.print( "dX: ");
    System.err.print( evt.getX() - lastX );
    System.err.print( " dY: ");
    System.err.print( evt.getY() - lastY );
    System.err.println();
    String items[] = list.getSelectedItems();
    int i;
    for( i = 0; i < items.length; i++ ){
      doTransform( YZ, evt.getX() - lastX, evt.getY() - lastY, items[i]);
    }
    lastX = evt.getX();
    lastY = evt.getY();
   }//GEN-LAST:event_canvasYZMouseDragged

  private void canvasPerspectiveMouseDragged (java.awt.event.MouseEvent evt) {//GEN-FIRST:event_canvasPerspectiveMouseDragged
  }//GEN-LAST:event_canvasPerspectiveMouseDragged



  private void renderModeMouseClicked (java.awt.event.MouseEvent evt) {//GEN-FIRST:event_renderModeMouseClicked
    String items[] = list.getItems();
    int i;
    for( i = 0; i < items.length; i++ ){
      Appearance a = null;
      PolygonAttributes pa = new PolygonAttributes();
      pa.setCapability( PolygonAttributes.ALLOW_MODE_WRITE );
      pa.setCapability( PolygonAttributes.ALLOW_MODE_READ );
      pa.setCullFace( pa.CULL_NONE );
      
      if( renderMode.getSelectedItem().startsWith("Line") ){
        pa.setPolygonMode( pa.POLYGON_LINE );
      } else /* renderMode.getSelectedItem().startsWith("Fill") */{
        pa.setPolygonMode( pa.POLYGON_FILL );
      }
      
      if( items[i].startsWith("cone") ){
        Cone c = (Cone)shapesMap.get(items[i]);
        a = c.getAppearance();
        a.setPolygonAttributes( pa );
      } else if ( items[i].startsWith("cube") ){
        Box b = (Box)shapesMap.get(items[i]);
        a = b.getAppearance();
        a.setPolygonAttributes( pa );
        
      } else if ( items[i].startsWith("cylinder") ){
        Cylinder cyl = (Cylinder)shapesMap.get(items[i]);
        a = cyl.getAppearance();
        a.setPolygonAttributes( pa );

      } else if ( items[i].startsWith("sphere") ){
        Sphere s = (Sphere)shapesMap.get(items[i]);
        a = s.getAppearance();
        a.setPolygonAttributes( pa );

      }
    }
  }//GEN-LAST:event_renderModeMouseClicked

  private void listMouseClicked (java.awt.event.MouseEvent evt) {//GEN-FIRST:event_listMouseClicked
// Add your handling code here:
  }//GEN-LAST:event_listMouseClicked

  private void scaleMouseClicked (java.awt.event.MouseEvent evt) {//GEN-FIRST:event_scaleMouseClicked
// Add your handling code here:
    label1.setText("Mode: Scale");
    XFORM_MODE = XFORM_SCALE;
  }//GEN-LAST:event_scaleMouseClicked

  private void rotateMouseClicked (java.awt.event.MouseEvent evt) {//GEN-FIRST:event_rotateMouseClicked
// Add your handling code here:
    label1.setText("Mode: Rotate");
    XFORM_MODE = XFORM_ROTATE;
  }//GEN-LAST:event_rotateMouseClicked

  private void translateMouseClicked (java.awt.event.MouseEvent evt) {//GEN-FIRST:event_translateMouseClicked
    // Add your handling code here:
    label1.setText("Mode: Translate");
    XFORM_MODE = XFORM_TRANSLATE;
    /*
    TransformGroup tg = (TransformGroup) shapeTransformGroups.get( "cube1" );
    Transform3D t3d = new Transform3D();
    System.err.println("t3d: " + t3d);
    tg.getTransform( t3d );
    System.err.println("t3d: " + t3d);
    t3d.rotZ( 1.5 );
    System.err.println("t3d: " + t3d);
    tg.setTransform( t3d );
    */

  }//GEN-LAST:event_translateMouseClicked

  private void coneMouseClicked (java.awt.event.MouseEvent evt) {//GEN-FIRST:event_coneMouseClicked
    coneCount++;
    String name = "cone" + coneCount;
    createShape( name, new Vector3f( 0.0f, 0.0f, 0.0f ) );

    list.add( name );
   }//GEN-LAST:event_coneMouseClicked

  private void lightMouseClicked (java.awt.event.MouseEvent evt) {//GEN-FIRST:event_lightMouseClicked
    lightCount++;
    String name = "light" + lightCount;
    createLight( name, new Vector3f( 0.0f, 0.0f, 0.0f ) );

    list.add( name );
   }//GEN-LAST:event_lightMouseClicked

  private void cylinderMouseClicked (java.awt.event.MouseEvent evt) {//GEN-FIRST:event_cylinderMouseClicked
    cylinderCount++;
    String name = "cylinder" + cylinderCount;
    createShape( name, new Vector3f( 0.0f, 0.0f, 0.0f ) );

    list.add( name );
   }//GEN-LAST:event_cylinderMouseClicked

  private void cubeMousePressed (java.awt.event.MouseEvent evt) {//GEN-FIRST:event_cubeMousePressed
    cubeCount++;
    String name = "cube" + cubeCount;
    createShape( name, new Vector3f( 0.0f, 0.0f, 0.0f ) );

    list.add( name );
  
  }//GEN-LAST:event_cubeMousePressed

  private void sphereMouseClicked (java.awt.event.MouseEvent evt) {//GEN-FIRST:event_sphereMouseClicked
    sphereCount++;
    String name = "sphere" + sphereCount;
    createShape( name, new Vector3f( 0.0f, 0.0f, 0.0f ) );

    list.add( name );
  
    /*
    perspectiveLoc.add( new Vector3f( -1.0f, -1.0f, 1.0f ) );
    Transform3D t = new Transform3D();
    t.set( perspectiveLoc );    
    Vector3f cross = new Vector3f();
    cross.cross( new Vector3f( 0.0f, 0.0f, 1.0f ), perspectiveLoc );
    System.err.println( "cross " + cross );
    t.setRotation( new AxisAngle4f( cross.x,
                                    cross.y,
                                    cross.z,
                                    //(float) Math.PI - 
                                    perspectiveLoc.angle( new Vector3f( 0.0f, 0.0f, 1.0f) ) ));
  
    perspectiveVPTrans.setTransform( t );
    System.err.println(perspectiveLoc);
    */

  }//GEN-LAST:event_sphereMouseClicked

  
  /** This method creates a sample scenegraph. Unused, mostly.
    */
  public BranchGroup createSceneGraph() { 
  
    // Create the root of the subgraph 
    BranchGroup objRoot = new BranchGroup();
    objRoot.setCapability( BranchGroup.ALLOW_CHILDREN_READ );
    // Create the transform group node and initialize it to the 
    // identity. Enable the TRANSFORM_WRITE capability so that 
    // our behavior code can modify it at runtime. Add it to the 
    // root of the subgraph. 
    TransformGroup objTrans = new TransformGroup(); 
    objTrans.setCapability( TransformGroup.ALLOW_TRANSFORM_WRITE ); 
    
    objRoot.addChild(objTrans); 
    // Create a simple shape leaf node, add it to the scene graph. 
    //objTrans.addChild(new ColorCube().getShape());

    //Object Color:
    Color3f objColor = new Color3f( 0.2f, 0.6f, 0.8f );

    //emissive color:
    Color3f eColor = new Color3f( 0.0f, 0.0f, 0.0f );
    
    //specular color:
    Color3f sColor = new Color3f( 1.0f, 1.0f, 1.0f );
    
    Material m = new Material(objColor, eColor, objColor, sColor, 100.0f);
    Appearance a = new Appearance();
    //m.setLightingEnable(true);
    a.setMaterial(m);
    //Sphere s1 = new Sphere(1.0f, Sphere.GENERATE_NORMALS, 80, a);
    Box s1 = new Box( 1.0f, 4.0f, 9.0f, a );
    objTrans.addChild( s1 );
    
    // Create a new Behavior object that will perform the desired 
    // operation on the specified transform object and add it into 
    // the scene graph. 
    Transform3D yAxis = new Transform3D(); 
    Alpha rotationAlpha = new Alpha( -1, Alpha.INCREASING_ENABLE, 
                                  0, 0, 4000, 0, 0, 0, 0, 0); 
    
    RotationInterpolator rotator = new RotationInterpolator( 
      rotationAlpha, objTrans, yAxis, 
      0.0f, (float) Math.PI*2.0f); 
    
    BoundingSphere bounds = new BoundingSphere(new Point3d(0.0,0.0,0.0), 1000.0); 
    
    rotator.setSchedulingBounds(bounds); 
    objTrans.addChild(rotator);
    
    return objRoot; 
    
  }

  /** This method performs the currently selected transform (as determined by
   * XFORM_MODE) on the currently selected scene object.
   * dx and dy are the mouse increment movements.  plane is one of XY, YZ, or
   * XZ that determines where this transform takes place.
   */
  public void doTransform( int plane, int dx, int dy , String name){
    if( name == null )
      return;

    if( name.startsWith("Camera") //Camera cannot be scaled, rotated
            && XFORM_MODE != XFORM_TRANSLATE ){
      return;
    }

    TransformGroup tg = 
      (TransformGroup) shapeTransformGroups.get( name );
    Transform3D t3d = new Transform3D();
    tg.getTransform( t3d );
    System.err.println( "transforming shape: " + name );

    Transform3D delta = new Transform3D();

    float TRANSLATE_SCALE = 20f;
    switch(XFORM_MODE){
      case XFORM_TRANSLATE:
        Vector3f v = new Vector3f();
        switch(plane){
          case XY:
            t3d.get( v );
            t3d.setTranslation( 
              new Vector3f( v.x + (float)dx / TRANSLATE_SCALE, v.y - (float)dy / TRANSLATE_SCALE, v.z ) );
          break;
          case XZ:
            t3d.get( v );
            t3d.setTranslation( 
              new Vector3f( v.x + (float)dx / TRANSLATE_SCALE, v.y, v.z - (float)dy / TRANSLATE_SCALE ) );
          break;
          case YZ:
            t3d.get( v );
            t3d.setTranslation( 
              new Vector3f( v.x, v.y + (float)dx / TRANSLATE_SCALE, v.z - (float)dy / TRANSLATE_SCALE) );
          break;
        }

      break;
      case XFORM_ROTATE:
        Matrix4f m = new Matrix4f();
        Vector3f axis = new Vector3f();
        AxisAngle4f aa = new AxisAngle4f();
        float newangle;
        switch(plane){
          case XY:
            axis.set( 0.0f, 0.0f, 1.0f );
            
            t3d.get( m );
            aa.set( m );

            newangle =  (float) aa.angle + (float)Math.toRadians((float)dy);
            if( newangle > Math.PI ){
              newangle = 0.0f;
            } else if ( newangle <= 0.0f ){
              newangle = (float)Math.PI;
            }
            System.err.println("angle: " + newangle );
            aa.set( axis.x, axis.y, axis.z, newangle );
            t3d.setRotation( aa );

          break;
          case XZ:
            axis.set( 0.0f, 1.0f, 0.0f );

            t3d.get( m );
            aa.set( m );

            newangle =  (float) aa.angle + (float)Math.toRadians((float)dy);
            if( newangle > Math.PI ){
              newangle = 0.0f;
            } else if ( newangle <= 0.0f ){
              newangle = (float)Math.PI;
            }
            System.err.println("angle: " + newangle );
            aa.set( axis.x, axis.y, axis.z, newangle );
            t3d.setRotation( aa );
            
            break;
            
          case YZ:
            axis.set( 1.0f, 0.0f, 0.0f );

            t3d.get( m );
            aa.set( m );

            newangle =  (float) aa.angle + (float)Math.toRadians((float)dy);
            if( newangle > Math.PI ){
              newangle = 0.0f;
            } else if ( newangle <= 0.0f ){
              newangle = (float)Math.PI;
            }
            System.err.println("angle: " + newangle );
            aa.set( axis.x, axis.y, axis.z, newangle );
            t3d.setRotation( aa );
            break;
        }
      break;
      case XFORM_SCALE:
        Vector3d scale = new Vector3d();
        switch(plane){
          case XY:
            t3d.getScale( scale );

            if( scale.x + dx <= 0 ){
              dx = 0;
            }
            if( scale.y + dy <= 0 ){
              dy = 0;
            }
            scale.set( scale.x + dx, scale.y + dy, scale.z );
            t3d.setScale( scale );
          break;
          case XZ:
            t3d.getScale( scale );

            if( scale.x + dx <= 0 ){
              dx = 0;
            }
            if( scale.z + dy <= 0 ){
              dy = 0;
            }
            scale.set( scale.x + dx, scale.y, scale.z + dy );
            t3d.setScale( scale );
            break;
          case YZ:
            t3d.getScale( scale );

            if( scale.y + dx <= 0 ){
              dx = 0;
            }
            if( scale.z + dy <= 0 ){
              dy = 0;
            }
            scale.set( scale.x, scale.y + dx, scale.z + dy );
            t3d.setScale( scale );
            break;
        }
      break;
    }

    //Make sure the camera continues to "look at" the origin
    if( name.startsWith("Camera") ){
      Vector3f cross = new Vector3f();
      Vector3f v = new Vector3f();
      t3d.get( v ); //get the translational (position) component

      cross.cross( new Vector3f( 0.0f, 0.0f, 1.0f ), v );
      t3d.setRotation( new AxisAngle4f( cross.x,
                                        cross.y,
                                        cross.z,
                                        v.angle( new Vector3f( 0.0f, 0.0f, 1.0f) ) ));
      /*
      Transform3D cam = new Transform3D();
      Vector3d up = new Vector3d( 0, 0, 1 );
      Point3d center = new Point3d( 0, 0, 0 ); //where to look (origin)
      
      Vector3d v = new Vector3d();
      t3d.get( v ); //get the translational (position) component

      cam.lookAt( new Point3d( v.x, v.y, v.z ), center, up );
      t3d = cam;
      */
    }

    System.err.println("t3d: " + t3d); 
    //t3d.normalize();
    //System.err.println("t3d normalized: " + t3d); 
    tg.setTransform( t3d );
    shapeTransformGroups.put( name, tg );

  }
  
  /** This method creates the little arrows representing X, Y, and Z and places
   * it at the origin of the scene.
   */
  public void createOriginArrows( ){
    BranchGroup objRoot = new BranchGroup();
    objRoot.setCapability( BranchGroup.ALLOW_CHILDREN_READ );
    objRoot.setCapability( BranchGroup.ALLOW_CHILDREN_WRITE );

    Color3f red = new Color3f( 1.0f, 0.0f, 0.0f );
    Color3f green = new Color3f( 0.0f, 1.0f, 0.0f );
    Color3f blue = new Color3f( 0.0f, 0.0f, 1.0f );
    Color3f black = new Color3f( 0.0f, 0.0f, 0.0f );
    Color3f white = new Color3f( 1.0f, 1.0f, 1.0f );

    Material mRed = new Material(red, black, red, white, 75.0f);
    Material mGreen = new Material(green, black, green, white, 75.0f);
    Material mBlue = new Material(blue, black, blue, white, 75.0f);
    
    //The arrow pointing in the +X direction:
    Appearance a = new Appearance();
    a.setMaterial( mRed );
    Transform3D tX = new Transform3D();
    tX.rotZ( - Math.PI / 2.0 );
    TransformGroup tgX = new TransformGroup( tX );
    tgX.addChild( createArrow( a ) );
    objRoot.addChild( tgX );
    
    //The arrow pointing in the +Y direction:
    Appearance b = new Appearance();
    b.setMaterial( mBlue );
    Transform3D tY = new Transform3D();
    //tY.rotZ( - Math.PI / 2.0 ); //do not need to rotate this one; it comes pre-built
    TransformGroup tgY = new TransformGroup( tY );
    tgY.addChild( createArrow( b ) );
    objRoot.addChild( tgY );
      
    //The arrow pointing in the +Z direction:
    Appearance c = new Appearance();
    c.setMaterial( mGreen );
    Transform3D tZ = new Transform3D();
    tZ.rotX( Math.PI / 2.0 );
    TransformGroup tgZ = new TransformGroup( tZ );
    tgZ.addChild( createArrow( c ) );
    objRoot.addChild( tgZ );
      
    locale.addBranchGraph( objRoot );
  }

  private BranchGroup createArrow( Appearance a ){
    Cone cone;
    Cylinder cyl;
    BranchGroup objRoot = new BranchGroup();
    objRoot.setCapability( BranchGroup.ALLOW_CHILDREN_READ );
    objRoot.setCapability( BranchGroup.ALLOW_CHILDREN_WRITE );

    cone = new Cone( 0.2f, 0.5f, Cone.GENERATE_NORMALS, a);
    cyl = new Cylinder( 0.1f, 0.5f, Cylinder.GENERATE_NORMALS, a);

    Transform3D t = new Transform3D();
    t.set( new Vector3f( 0.0f, 0.5f, 0.0f ) );
    TransformGroup coneTg = new TransformGroup( t );

    coneTg.addChild( cone );

    TransformGroup tg = new TransformGroup( );
    tg.setCapability( TransformGroup.ALLOW_TRANSFORM_WRITE );
    tg.setCapability( TransformGroup.ALLOW_TRANSFORM_READ );
    tg.addChild( cyl );

    Transform3D base = new Transform3D();
    base.set( new Vector3f( 0.0f, .25f, 0.0f ) );
    TransformGroup objTrans = new TransformGroup( base );
    objTrans.addChild( tg );
    objTrans.addChild( coneTg );
    objRoot.addChild( objTrans );
    
    return objRoot;
  }
    

  /** This method creates and returns a BranchGroup with a view platform.
   * viewLoc is the location of the "camera", canvas is the Canvas3D object
   * that this view port should be attached to, and plane is used to
   * differentiate between the PERSPECTIVE viewport and the others.
   */
  public BranchGroup createViewplatformGraph(Vector3f viewLoc, Canvas3D canvas,
                                             int plane ){
    TransformGroup vpTrans;
    View view;
    BranchGroup vpRoot;
    ViewPlatform vp;
    PhysicalBody body = new PhysicalBody();
    PhysicalEnvironment environment = new PhysicalEnvironment ();

    view = new View();
    view.addCanvas3D( canvas );
    view.setPhysicalBody( body );
    view.setPhysicalEnvironment( environment );

    vpRoot = new BranchGroup();
    vpRoot.setCapability( BranchGroup.ALLOW_CHILDREN_READ );

    Vector3d up = null;
    Point3d center, v;
    Transform3D t = new Transform3D();
    t.set( viewLoc ); //set the vp location to the viewLocation
    if( plane == XY ) {
      //the default translation is correct for XY plane
    } else if ( plane == XZ ){
      center = new Point3d( 0, 0, 0 );
      up = new Vector3d( 0, 0, 1 );
      v = new Point3d( viewLoc.x, viewLoc.y, viewLoc.z );
      t.lookAt( v, center, up );
      t.invert();
      //t.setRotation( new AxisAngle4f( 1.0f, 0.0f, 0.0f, (float)Math.PI / 2.0f ) );
    } else if ( plane == YZ ){
      center = new Point3d( 0, 0, 0 );
      up = null;
      up = new Vector3d( 0, 0, 1 );
      v = new Point3d( viewLoc.x, viewLoc.y, viewLoc.z );
      t.lookAt( v, center, up );
      t.invert();
      //t.setRotation( new AxisAngle4f( 0.0f, 1.0f, 0.0f, (float)Math.PI / 2.0f ) );
    } else /* if (plane == PERSPECTIVE) */ {
      System.err.println( "angle"+viewLoc.angle(new Vector3f( 0.0f, 0.0f, 1.0f ) ) );
      Vector3f cross = new Vector3f();
      cross.cross( new Vector3f( 0.0f, 0.0f, 1.0f ), viewLoc );
      System.err.println( "cross " + cross );
      t.setRotation( new AxisAngle4f( cross.x,
                                      cross.y,
                                      cross.z,
                                      //(float) Math.PI - 
                                      viewLoc.angle( new Vector3f( 0.0f, 0.0f, 1.0f) ) ));
      System.err.println(t);
      /*
      Point3d center = new Point3d( 0, 0, 0 );
      Vector3d up = null;
      if( plane == PERSPECTIVE ){
        up = new Vector3d( 0, 0, 1 );
      } else if( plane == XY ){
        up = new Vector3d( 0, 1, 0 );
      } else if( plane == XZ ){
        up = new Vector3d( 0, 0, 1 );
      } else if( plane == YZ ){
        up = new Vector3d( 0, 0, 1 );
      }
      Point3d v = new Point3d( viewLoc.x, viewLoc.y, viewLoc.z );
      t.lookAt( v, center, up );
      t.invert();
      */
    }
  
    System.err.println(t);
    vp = new ViewPlatform();

    if( plane == PERSPECTIVE ){
      perspectiveVPTrans = new TransformGroup( t );
      perspectiveVPTrans.setCapability( TransformGroup.ALLOW_TRANSFORM_WRITE );
      perspectiveVPTrans.setCapability( TransformGroup.ALLOW_TRANSFORM_READ );
      vpTrans = perspectiveVPTrans;
      //hang on to this transform in our global hashmap
      list.add("Camera");
      shapeTransformGroups.put( "Camera", vpTrans );

      //create a little cone to represent the camera:
      Color3f white = new Color3f( 1.0f, 1.0f, 1.0f );
      Color3f black = new Color3f( 0.0f, 0.0f, 0.0f ); //black
      Color3f gray = new Color3f( 0.3f, 0.3f, 0.3f ); //grey
      Material m = new Material(gray, black, white, white, 100.0f);
      Appearance a = new Appearance();
      m.setLightingEnable(true);
      a.setMaterial(m);
      Cone c = new Cone(0.5f, 1.0f, Cone.GENERATE_NORMALS, a); 

      //create a little cube to represent the base of the camera
      Color3f red = new Color3f( 1.0f, 0.0f, 0.0f ); //red
      m = new Material(red, black, white, white, 100.0f);
      a = new Appearance();
      m.setLightingEnable(true);
      a.setMaterial(m);
      Box b = new Box(0.4f, 0.4f, 0.2f, Box.GENERATE_NORMALS, a); 

      //Turn the cones upright, so that the base points towards the origin
      Transform3D upright = new Transform3D();
      upright.rotX( Math.PI / 2.0 );
      TransformGroup uprightTG = new TransformGroup( upright );
      uprightTG.addChild( c );
      
      vpTrans.addChild( uprightTG );
      vpTrans.addChild( b );

    } else {
      vpTrans = new TransformGroup( t );
    }

    vpTrans.addChild( vp );
    vpRoot.addChild( vpTrans );

    view.attachViewPlatform( vp );
    return vpRoot;
  }
  

        // Variables declaration - do not modify//GEN-BEGIN:variables
        private java.awt.Panel main;
        /*
        private java.awt.Canvas canvasXY;
        private java.awt.Canvas canvasYZ;
        private java.awt.Canvas canvasXZ;
        private java.awt.Canvas canvasPerspective;
        */
        private Canvas3D canvasXY;
        private Canvas3D canvasYZ;
        private Canvas3D canvasXZ;
        private Canvas3D canvasPerspective;

        private java.awt.Panel panel2;
        private java.awt.Panel transforms;
        private java.awt.Button button10;
        private java.awt.Button button11;
        private java.awt.Button button12;
        private java.awt.Button button16;
        private java.awt.Button button17;
        private java.awt.Panel shapes;
        private java.awt.Button button13;
        private java.awt.Button button14;
        private java.awt.Button button15;
        private java.awt.Panel declared;
        private java.awt.List list;
        private java.awt.List renderMode;
        private java.awt.Label label1;
        // End of variables declaration//GEN-END:variables
        //The globally used VirtualUniverse and Locale classes
        private VirtualUniverse universe;
        private Locale locale;

        //Planes of transformations
        private static final int XY = 1,
                                 XZ = 2,
                                 YZ = 3,
                                 PERSPECTIVE = 4;
        //The transform types
        private static final int XFORM_TRANSLATE = 1,
                           XFORM_ROTATE = 2,
                           XFORM_SCALE = 3;
        private int XFORM_MODE; //the current transform mode

        private int lastX = 0, lastY = 0;

        //The current count of cubes, spheres, cylinders
        private int cubeCount, sphereCount, cylinderCount, coneCount, lightCount;

        //The TransformGroup of the perspective viewport must be declared and
        //maintained seperately.
        private TransformGroup perspectiveVPTrans; 
        //The location of the perspetive viewport camera must be maintained
        //seperately.
        private Vector3f perspectiveLoc;

        private HashMap shapeTransformGroups;
        private HashMap shapesMap;

  public static void main(String[] args){
    Frame f = new Frame();
    Final a = new Final();
    f.add(a, "Center");
    a.init();
    f.setSize(800,600);
    f.show();
    a.start();
    f.addWindowListener(new WindowAdapter() {
      public void windowClosing(WindowEvent e) {System.exit(0); }
    });
  }

  /*
  public float sqr( float a ) {
    return a * a;
  }
  */


}

