import com.ibm.xml.*;
import com.ibm.xml.parser.*;
import com.ibm.xml.parsers.*;
import java.io.*;
import java.util.*;
import java.text.*;
import org.w3c.dom.*;
import com.ibm.xml.framework.*;

public class parseGOWtest {

    static Vector nVec = new Vector(); // nVec is the key vector.
    static Vector vVec = new Vector(); // vVec is the value vector.
    static String value = null;
    static Hashtable hash = new Hashtable();
    static Element item, itemA, itemB;

    public static void main(String args[]) throws IOException {
	if (args.length != 1) {
	    System.err.print("Usage: java extensions.Transform.listParam file.xml\n");
	    System.exit(1);
	}
	int nXSIL = doParse(args[0], hash);
	System.out.println("XSIL number: "+nXSIL);
	//removeUser(args[0],"aa");
	//addUser(args[0],hash);
	removeHostname(args[0],"Gamess");

    }
    
    public static int doParse(String name, Hashtable hash){
	String key = null, value = null;
	String hName = null;
	String lup = null;
	int nUsers = 0;

        if (name == null) {
            System.err.println("Missing filename.");
            return nUsers;
        }
        try {
            // Open XML file
            FileInputStream is = new FileInputStream(name);

            // Start parsing
            Parser parser = new Parser(name);

            // Check if there is errors
            if (parser.getNumberOfErrors() > 0) {
		System.out.println("Errors > zero");
                return(2);
            }
            // Document is well-formed

            Document doc = parser.readStream(is);
            Element r = doc.getDocumentElement();
            //lup = r.getAttribute("lastUpdate");
            // System.out.println("doParse lup = " + lup);
            Vector aTags = getAllTags(r, "XSIL");
	    nUsers = aTags.size();
	    removeWhiteSpaceNodes(r);
	    
	    Node rr = r.getFirstChild();
	    Vector aaTags = getAllTags(rr, "XSIL");
	    nUsers = aaTags.size();
	    removeWhiteSpaceNodes((Element)rr);
	    
	    NodeList nl0 = r.getChildNodes();
	    buildNodes(nl0, hName);
        } catch (Exception e) {
            e.printStackTrace();
        }
	// Make the hash table from the name/value pairs.
	//hash.put("lastUpdate", lup);
	for(int l = 0; l < nVec.size(); l++){
	    hash.put(nVec.get(l), (vVec.get(l) + "::"));
	}
	System.out.println("Hash Table = " + hash.toString());
	return nUsers;
    }

    public static void removeWhiteSpaceNodes(Element parent) {
	Node nextNode = parent.getFirstChild();
        for (Node child = parent.getFirstChild();
	     nextNode != null;) {
	    child = nextNode;
	    nextNode = child.getNextSibling();
	    
            if (child instanceof TXText){
		if(((TXText)child).getIsIgnorableWhitespace()){
		    parent.removeChild(child);
		}
            } else if(child instanceof TXElement){
		removeWhiteSpaceNodes((Element)child);
	    }
	}
    }

    public static void buildNodes(NodeList nl, String hName){
	int inl = 0;
	int inl2 = 0;
	int l;
	boolean found = false;
	//System.out.println("Node Length: "+nl.getLength());

	while(inl < (nl.getLength())){
	    Node childNL = nl.item(inl);
	    String chName = childNL.getNodeName();
	    System.out.println("Node Name: "+chName);
	    if(chName != "#text") {
		//System.out.println("Attribute Name: "+((Element)childNL).getAttribute("Name"));
		//System.out.println("Attribute Type: "+((Element)childNL).getAttribute("Type"));
		hName = chName;
	    }
	    String chValue = childNL.getNodeValue();
	    if (childNL instanceof TXText) {
		chValue = childNL.getNodeValue();
		System.out.println("Node Value: "+chValue);
	    } else if (childNL.hasChildNodes()){
		NodeList nl2 = childNL.getChildNodes();
		buildNodes(nl2, hName);
	    }
	    inl++;
	    if((hName != null) && (chValue != null)) {
		if(nVec.isEmpty() == true){
		    nVec.addElement(hName);
		    vVec.addElement(chValue);
		    found = false;
		} else if(nVec.isEmpty() != true){
		    for(l = 0; l < nVec.size(); l++){
			if (hName.equals(nVec.get(l))){
			    found = true;
			    value = (String)vVec.get(l);
			    value = value + "::" + chValue;
			    vVec.setElementAt(value, l);
			    break;
			}
		    }
		    if(found == false) {
			nVec.addElement(hName);
			vVec.addElement(chValue);
			found = false;
		    }
		}
	    }
	}
    }

    public static boolean removeUser(String name, String uidF) {
	String hName = null;
	boolean status = false;
	Document doc = null;

        try {
            // Open XML file
            FileInputStream is = new FileInputStream(name);

            // Start parsing
            Parser parser = new Parser(name);

            // Check if there is errors
            if (parser.getNumberOfErrors() > 0) {
		System.out.println("Errors > zero");
		status = false;
                return status;
            }
            // Document is well-formed
	    
            doc = parser.readStream(is);
            Element r = doc.getDocumentElement();
	    removeWhiteSpaceNodes(r);

	    NodeList nl0 = r.getChildNodes();
	    buildNodes(nl0, hName);

	    Node rr = r.getFirstChild();
	    removeWhiteSpaceNodes((Element)rr);

	    Vector aaTags = getAllTags(rr, "XSIL");

	    int m = aaTags.size();
	    for (int j = 0; j < m; j++) {
		Node a = (Node)aaTags.elementAt(j);
		if( ((Element)a).getAttribute("Name").equals(uidF)) {
		    rr.removeChild(a);
		    status = true;
		}
	    }
	} catch (Exception e) {
	    System.out.println(e+" while removing user" );
	    status = false;
	}
	// Save the XML document
	// System.out.println("ruFile = " + name);
	try{
	    PrintWriter ruFileOut = new PrintWriter(
			    new FileWriter(name, false));
	    ((TXDocument)doc).printWithFormat(ruFileOut);
	} catch(IOException e){
	    System.out.println("Error opening ruFileOut.");
	    System.exit(0);
	}
	return status;
    }
    
    public static boolean addUser(String name, Hashtable uData) {
	String hName = null;
	boolean status = false;
	Document doc = null; //new TXDocument();
	// Document doc = new Document();
        try {
            // Open XML file
            FileInputStream is = new FileInputStream(name);

            // Start parsing
            Parser parser = new Parser(name);

            // Check if there is errors
            if (parser.getNumberOfErrors() > 0) {
		System.out.println("Errors > zero");
		status = false;
                return status;
            }
            // Document is well-formed

            doc = parser.readStream(is);
            Element r = doc.getDocumentElement();
	    removeWhiteSpaceNodes(r);

	    NodeList nl0 = r.getChildNodes();
	    buildNodes(nl0, hName);

	    Node rr = r.getFirstChild();
	    removeWhiteSpaceNodes((Element)rr);

	    //  Make <User> element and add it
	    //  as a child of root
	    item = doc.createElement("XSIL");
	    item.setAttribute("Name","CYOUN");
	    item.setAttribute("Type","generic.parseXMLDesc");
	    
	    // Make <userID> element and add it
	    // as a child of User
	    itemA = doc.createElement("Param");
	    itemA.setAttribute("Name","NumberOfInParams");

	    itemA.appendChild(doc.createTextNode("10"));
	    item.appendChild(itemA);

	    itemA = doc.createElement("Param");
	    itemA.setAttribute("Name","NumberOfOutFiles");

	    itemA.appendChild(doc.createTextNode("5"));
	    item.appendChild(itemA);

	    itemA = doc.createElement("Param");
	    itemA.setAttribute("Name","IOStyle");

	    itemA.appendChild(doc.createTextNode("CArgument"));
	    item.appendChild(itemA);

	    // Make <primaryArea> element and add it
	    // as a child of User
	    itemA = doc.createElement("Table");
	    itemA.setAttribute("Name","HostList");

	    //  Make <title> element and add it
	    //  as a child of Person
	    itemB = doc.createElement("Column");
	    itemB.setAttribute("Name","HostName");
	    itemB.setAttribute("Type","string");
	    itemA.appendChild(itemB);

	    itemB = doc.createElement("Column");
	    itemB.setAttribute("Name","QueuType");
	    itemB.setAttribute("Type","string");
	    itemA.appendChild(itemB);

	    itemB = doc.createElement("Column");
	    itemB.setAttribute("Name","ExecPath");
	    itemB.setAttribute("Type","string");
	    itemA.appendChild(itemB);

	    itemB = doc.createElement("Column");
	    itemB.setAttribute("Name","WorkDir");
	    itemB.setAttribute("Type","string");
	    itemA.appendChild(itemB);

	    itemB = doc.createElement("Column");
	    itemB.setAttribute("Name","QsubPath");
	    itemB.setAttribute("Type","string");
	    itemA.appendChild(itemB);

	    itemB = doc.createElement("Stream");
	    itemB.setAttribute("Delimiter",",");
	    itemB.appendChild(doc.createTextNode("dirac.csit.fsu.edu,PBS,/app/,/tmp,/qsub"+"\n"+"birch.csit.fsu.edu,DQS,/appp/,/tmp,/qsub/qsub"));
	    itemA.appendChild(itemB);

	    //  Add <Person> as a child of <user>
	    item.appendChild(itemA);

	    //  Add <contact> as a child of <user>
	    rr.insertBefore((Node)item, null);
	} catch (Exception e) {
	    System.out.println(e+" while removing user" );
	    status = false;
	}
	// Save the XML document
	// System.out.println("ruFile = " + name);
	try{
	    PrintWriter ruFileOut = new PrintWriter(
			   new FileWriter(name, false));
	    ((TXDocument)doc).printWithFormat(ruFileOut);
	} catch(IOException e){
	    System.out.println("Error opening ruFileOut.");
	    System.exit(0);
	}
	return status;
    }

    public static boolean removeHostname(String xmlfilename, String applName) {
	boolean status = false;
	Document doc = null;

        try {
            // Open XML file
            FileInputStream is = new FileInputStream(xmlfilename);

            // Start parsing
            Parser parser = new Parser(xmlfilename);

            // Check if there is errors
            if (parser.getNumberOfErrors() > 0) {
		System.out.println("Errors > zero");
		status = false;
                return status;
            }
            
	    // Document is well-formed	    
            doc = parser.readStream(is);
            Element elem = doc.getDocumentElement();
	    removeWhiteSpaceNodes(elem);

	    Node nextnode = elem.getFirstChild();    //XSIL application list
	    removeWhiteSpaceNodes((Element)nextnode);

	    //find "applicatin" node
	    Node applNode = null;
	    for(applNode = nextnode.getFirstChild(); applNode!=null;
	    applNode = applNode.getNextSibling()) {
	    if(applNode instanceof Element) {
		if(((Element)applNode).getAttribute("Name").equals(applName)) {
		    System.out.println("Node Name Tag: "+applNode.getNodeName());
		    System.out.println("Attribute: "+((Element)applNode).getAttribute("Name"));
		    break;
		}
	    }
	    }
	    removeWhiteSpaceNodes((Element)applNode);

	    //find "Table" node
	    Node tableNode = null;
	    for(tableNode = applNode.getFirstChild(); tableNode!=null;
	    tableNode = tableNode.getNextSibling()) {
	    if(tableNode instanceof Element) {
		if(tableNode.getNodeName().equals("Table")) {
		    System.out.println("Node Name Tag: "+tableNode.getNodeName());
		    System.out.println("Attribute: "+((Element)tableNode).getAttribute("Name"));
		    break;
		}
	    }
	    }
	    removeWhiteSpaceNodes((Element)tableNode);

	    //find "Stream" node
	    Node streamNode = null;
	    for(streamNode = tableNode.getFirstChild(); streamNode!=null;
	    streamNode = streamNode.getNextSibling()) {
	    if(streamNode instanceof Element) {
		if(streamNode.getNodeName().equals("Stream")) {
		    System.out.println("Node Name Tag: "+streamNode.getNodeName());
		    System.out.println("Attribute: "+((Element)streamNode).getAttribute("Delimiter"));
		    break;
		}
	    }
	    }
	    removeWhiteSpaceNodes((Element)streamNode);

	    tableNode.removeChild(streamNode);
	    Element itemB = doc.createElement("Stream");
	    itemB.setAttribute("Delimiter",",");
	    itemB.appendChild(doc.createTextNode("dirac.csit.fsu.edu,PBS,/app/,/tmp,/qsub"+"\n"+"birch.csit.fsu.edu,DQS,/appp/,/tmp,/qsub/qsub"));

	    //streamNode.appendChild(doc.createTextNode("dirac.csit.fsu.edu,PBS,/app/,/tmp,/qsub"+"\n"+"birch.csit.fsu.edu,DQS,/appp/,/tmp,/qsub/qsub"));
	    tableNode.insertBefore((Node)itemB, null);
	    //streamNode.setNodeValue("dirac.csit.fsu.edu,PBS,/app/,/tmp,/qsub"+"\n"+"birch.csit.fsu.edu,DQS,/appp/,/tmp,/qsub/qsub");

	} catch (Exception e) {
	    System.out.println(e+" while removing the application" );
	    status = false;
	}

	// Save the XML document
	try{
	    PrintWriter xmlFileOut = new PrintWriter(
			  new FileWriter(xmlfilename, false));
	    ((TXDocument)doc).printWithFormat(xmlFileOut);
	} catch(IOException e){
	    System.out.println("Error opening xmlFileOut.");
	    System.exit(0);
	}
	
	return status;
    }


    private static Vector getAllTags(Node node, String tag) {
	Vector result=new Vector();
	
	for(Node ch = node.getFirstChild(); ch!=null;
	    ch = ch.getNextSibling()) {
	    if(ch instanceof Element) {
		if(ch.getNodeName().equals(tag)) {
		    result.addElement(ch);
		    System.out.println("Node Name Tag: "+ch.getNodeName());
		    System.out.println("Attribute: "+((Element)ch).getAttribute("Name"));
		}
	    }
	}
	return result;
    }
}


