import java.io.*;
import java.net.*;
import java.util.*;

public class RecvChannel extends Thread {

    private ServerSocket serversocket = null;
    private CollServer server;

    private boolean listening = true;
 
    public RecvChannel(int port, CollServer server) {
	this.server = server;
	
	try {
	    serversocket = new ServerSocket(port);
	} catch(Exception e) { 
	    System.err.println("Can't create server socket:"+e);
	    System.exit(1);
	}  
    }

    /**
     * waits for a connection 
     */
    public void run() {
	Vector convec = new Vector();
     
	//listen the socket
	while (listening) {
	    try {
		Socket incoming = serversocket.accept();
	
		RecvHandler handler = new RecvHandler(incoming,server);
		handler.start();
		convec.addElement(handler);
	    } catch (Exception e) {
		System.out.println("Connection failed ...");
	    }

	    //clean up the vector if needed
	    for (int i=0; i<convec.size(); i++)
		if (!((RecvHandler)(convec.elementAt(i))).isAlive())
		    convec.removeElementAt(i);
	}

	for (int i=0; i<convec.size(); i++) {
	    RecvHandler handler = (RecvHandler)convec.elementAt(i);
	    try {
		handler.closeConnection();
	    } catch (Exception e) {
		System.out.println("Channel closing exception...");
	    }
	}
	convec.removeAllElements();

	try { serversocket.close(); 
	} catch (Exception e) { }
    }

    /**
     * close the connection
     */
    public void closeConnection() {
	listening = false;
      
    }   
}
