package EDU.auburn.VGJ.gui;

import java.awt.*;
import java.awt.event.*;
import java.util.*;
//import webflow.frontend.ModuleControls.CPanel;
import EDU.syr.npac.frontend.CPanel;
import EDU.auburn.VGJ.frontend.*;

//Erol
import javax.swing.*;
import java.net.*;
import java.io.*;
//Erol

//Alexey
import EDU.auburn.VGJ.Config;
//Alexey


public class CardPanel extends JPanel implements ActionListener, ItemListener {

   GraphWindow GWindow;
   GraphCanvas GraphCanvas_;
   CardLayout card = new CardLayout();
   CardLayout Acard = new CardLayout();
   Checkbox LoadIt, EditIt, SaveIt, RunIt, StopIt, ExitIt;
   JPanel Modules, ActionCards;
   public CPanel Executor;
   //Erol
   public Modules currModules;
  //Erol
   String sm_URL;
   compgraph compgraph_;

   private int i,ii;
   private String moduleName;
   String dirName;   
   String hostName;

  CardPanel(GraphWindow GraphWindow_,GraphCanvas GCanvas, String SM_URL) {
      super();
      sm_URL = SM_URL; 

      //Erol
      //SM_URL, ClientID, hostName, moduleListURL,portNumber comes from
      //GraphWindow_;

      currModules = Config.getModules();
      //Erol

      System.out.println("... Modules done ...");

      GWindow = GraphWindow_;
      hostName = GWindow.hostName;
      GraphCanvas_ = GCanvas;
      setLayout(new BorderLayout());

      JPanel Action = new JPanel();
      Action.setLayout(new GridLayout(2,3));
      Action.setBackground(Color.blue);
      Action.setForeground(Color.yellow);
      CheckboxGroup actiongroup = new CheckboxGroup();
      LoadIt = new Checkbox("Load", false, actiongroup);
      EditIt = new Checkbox("Edit", true, actiongroup);
      SaveIt = new Checkbox("Save", false, actiongroup);
      RunIt  = new Checkbox("Run", false, actiongroup);
      StopIt = new Checkbox("Stop", false, actiongroup);
      ExitIt = new Checkbox("Exit", false, actiongroup);

      ItemListener ActBox = new ItemListener() {
         public void itemStateChanged(ItemEvent e) {
	    String what = e.getItem().toString();
            System.err.println("checkbox selected: "+what);
            if(what.equals("Run")) {
                compgraph_ = 
                  new compgraph(GWindow,GraphCanvas_.graph_.nodeList_,
                    GraphCanvas_.graph_.edges_,sm_URL);
                compgraph_.tomnodelist();
	    }
            if(what.equals("Stop")) {
                RemoveObjectReferences();
            }
            if(what.equals("Exit")) {
              RemoveObjectReferences();
              GWindow.dispose();
            }
            showActionCard(what);
         }
      };


      System.out.println("... (1) ...");

      LoadIt.addItemListener(ActBox); 
      EditIt.addItemListener(ActBox); 
      SaveIt.addItemListener(ActBox); 
      RunIt.addItemListener(ActBox); 
      StopIt.addItemListener(ActBox); 
      ExitIt.addItemListener(ActBox); 

      Action.add(LoadIt); Action.add(EditIt); Action.add(SaveIt);
      Action.add(RunIt); Action.add(StopIt); Action.add(ExitIt);
      add(BorderLayout.NORTH,Action);

      ActionCards = new JPanel();
      ActionCards.setLayout(Acard);

      JPanel Creator = new JPanel();
      Creator.setLayout(new BorderLayout());

      JPanel superApp = new JPanel();
      superApp.setBackground(Color.cyan);
      superApp.setLayout(new GridLayout(3,1));
      Font titleFont = new Font("Serif",Font.BOLD,14);
      JLabel AAA = new JLabel("Applications", JLabel.CENTER);
      JLabel BBB = new JLabel("Modules", JLabel.CENTER);
      JLabel CCC = new JLabel("Hosts", JLabel.CENTER);
      AAA.setFont(titleFont);
      BBB.setFont(titleFont);
      CCC.setFont(titleFont);

      System.out.println("... (2) ...");

      JPanel Applications = new JPanel();

      System.out.println("... (3) ...");

      int nd = currModules.getNumberOfDir();

      if(nd<5) {
        Applications.setLayout(new GridLayout(1,nd));
      }
      else if(nd<9) {
        Applications.setLayout(new GridLayout(2,4));
      }
      else {
        Applications.setLayout(new GridLayout(3,4));
      }

      JButton[] ButtonsA;
      ButtonsA = new JButton[nd]; 

      ActionListener AppButList = new ActionListener() {
         public void actionPerformed(ActionEvent e) {
            String what = e.getActionCommand().toString();
            dirName = what;
            showContents(what);
         }
      };

      System.out.println("... (4) ...");

      for(i=0;i<nd;i++) {
        ButtonsA[i] = new JButton(currModules.getDirName(i));
        ButtonsA[i].addActionListener(AppButList);
        Applications.add(ButtonsA[i]);
      }

      superApp.add(AAA);
      superApp.add(Applications);
      superApp.add(BBB);
      
      Creator.add(BorderLayout.NORTH,superApp);

      System.out.println("... (5) ...");


       // Changes are done by Alexey to add multi host functionality
      // ----------------------------------------------------------

      Vector host_names = currModules.getHostList();
     
      Modules = new JPanel();
      Modules.setLayout(card);
      InitModulesPanel((String)host_names.elementAt(0));
      Creator.add(BorderLayout.CENTER,Modules);

      JPanel hosts = new JPanel();
      hosts.setLayout(new GridLayout(host_names.size(), 1));
      hosts.setBackground(Color.blue);
      hosts.setForeground(Color.yellow);

      CheckboxGroup options = new CheckboxGroup();

      ItemListener HostListener = new ItemListener() {
         public void itemStateChanged(ItemEvent e) {
	    String what = e.getItem().toString();
            System.err.println("checkbox selected: " + what);
	    InitModulesPanel(what);
         }
      };

      for(int i = 0; i < host_names.size(); ++i) {
	  Checkbox box = new Checkbox((String)host_names.elementAt(i), false, options);
	  box.addItemListener(HostListener);
	  hosts.add(box);
	  if(i == 0)
	      box.setState(true);
      }

      

      Creator.add(BorderLayout.SOUTH, hosts);

      // end of Alexey changes
      // -----------------------------------------------------------


      ActionCards.add("Edit", Creator); 

      // Executor = new CPanel(20, hostName);

//changed part
      System.out.println("... (71) ...");

      Executor = new CPanel(GWindow, 10);

      System.out.println("... (72) ...");

//kangseok

      ActionCards.add("Run", Executor);

      //Erol additions
      System.out.println("... (73) ...");

      setDocumentRootAtServer();

      System.out.println("... (730) ...");

      // SAVE
      //JPanel sSRGML    = new saveReadGML ("saved\\", GWindow); 
      //JPanel Savior   = sSRGML;
      //ActionCards.add("Save", Savior);

      System.out.println("... (731) ...");
      // LOAD 
      //JPanel SRGML    = new saveReadGML ("saved\\", GWindow);   
      //JPanel Loader = SRGML;
      //ActionCards.add("Load", Loader);
      //System.out.println("... (74) ...");

      //Erol

      JPanel Exitor = new JPanel();
      Exitor.add(new JLabel("Exitor Panel goes here"));

      ActionCards.add("Exit", Exitor);
      System.out.println("... (75) ...");

      JPanel Stopper = new JPanel();
      Stopper.add(new JLabel("Stopper Panel goes here"));

      ActionCards.add("Stop", Stopper);
      System.out.println("... (8) ...");

      add(BorderLayout.CENTER, ActionCards);
   }


    // Added by Alexey to support multiple hosts
    private void InitModulesPanel(String host)
    {
	int nd = currModules.getNumberOfDir();
	
	Modules.removeAll();
    
	//cards with modules (one card for each directory=ButtonA[i])	
	JPanel[] PanelM = new JPanel[nd];
	
	for(i = 0; i < nd; i++) {
	    PanelM[i] = new JPanel();
	    String dname = currModules.getDirName(i);
	    dirName = dname;

	    Vector ModList = currModules.getModuleList(dname, host);
	    int nbuttons = ModList.size();

	    if(nbuttons <= 5) 
		PanelM[i].setLayout(new GridLayout(5, 1));
	    else  PanelM[i].setLayout(new GridLayout((nbuttons-1)/2+1,2));
	    
	    JButton[] buttonsM = new JButton[nbuttons];
	    String[] buMnames = new String[nbuttons];	    	    
	    
	    ActionListener QSlistener = new ActionListener() {
		public void actionPerformed(ActionEvent e){
		    String what = e.getActionCommand().toString();
		    System.err.println("you pressed button "+what);
		    GraphCanvas_.setCurrentLabel(what);
		    GraphCanvas_.setCurrentShape(currModules.getShape(what,dirName));
		    GraphCanvas_.setCurrentDir(dirName);
		    GraphCanvas_.setCurrentHost(Config.getContext());
		    Event ee = new Event(this,0,Event.MOUSE_DOWN,-100,-100,0,0);
		    GraphCanvas_.mouseDown(ee,-100,-100);    
		}
	    };
	    
	    for (ii=0;ii<nbuttons;ii++) {
		moduleName = (String)ModList.elementAt(ii);
		buttonsM[ii]=new JButton(moduleName);
		buttonsM[ii].addActionListener(QSlistener);
		PanelM[i].add(buttonsM[ii]);           
	    } 	    
	    Modules.add(dname,PanelM[i]);
	}	
	dirName = currModules.getDirName(0);
	Modules.doLayout();
	Modules.validate();
	Modules.repaint();
	Config.setContext(host);
    }
    
    //Erol additions
public void setDocumentRootAtServer()
  {
    String sin;
    
    try{
      System.out.println(GWindow.moduleListURL);
      URL url = new URL(GWindow.moduleListURL);
      String Host    = url.getHost();
      int Port    = url.getPort();
      String portReq = "http://"+Host+":"+Port+"/servlet/portservlet";
      System.out.println("CardPanel: http="+portReq);
      url = new URL(portReq);
      DataInputStream dis = new DataInputStream( url.openStream() );
      /*
      while((sin = dis.readLine()) != null)
	System.out.println("sin :"+sin);
	*/
    }catch(MalformedURLException e){  
      System.out.println("Malformed URL. Exception " + e + " raised!");
    }
    catch(IOException e) {  
	System.out.println("IO exception occured. " + e);
    }
    
  }
  
  //Erol



   public void showContents() {
      card.last(Modules);
   }
   public void showContents(String what) {
      card.show(Modules,what);
   }
  
   public void showActionCard (String what) {
      Acard.show(ActionCards,what);
   }

   public void actionPerformed(ActionEvent e) {;}
   public void itemStateChanged(ItemEvent e) {;}

    public void RemoveObjectReferences(){
     compgraph_.rmReferences();
    }

}















