package EDU.syr.npac.frontend;
import EDU.auburn.VGJ.gui.*;
import java.lang.reflect.*;


abstract class ControlFactory
{
    protected int k;

    private static ControlFactory instance = null;

    static ControlFactory Instance() {
	if(instance == null)
	    instance = new DynamicLoadFactory();
	return instance;
    }

    public void init(int aK) { k = aK; }

    abstract public controls CreateControl(int n, String name, String context, GraphWindow window);
}

class DynamicLoadFactory extends ControlFactory
{
    private static int PARAMETER_COUNT = 4;
    private static String CONTROL_PKG = new String("EDU.syr.npac.frontend");
    private static String WINDOW_PKG = new String("EDU.auburn.VGJ.gui");

    public controls CreateControl(int n, String name, String context, GraphWindow window) {
	int port = 666;

	System.out.println("DynamicLoadFactory creates control: " + name);
	Class Control = null;
	Class params[] = new Class[PARAMETER_COUNT];
	try {
	    Control = Class.forName(CONTROL_PKG + "." + name + "Ctr");
	    params[0] = Class.forName("java.lang.String");
	    params[1] = Class.forName("int");
	    params[2] = Class.forName(WINDOW_PKG + "." + "GraphWindow");
	    params[3] = Class.forName("int");
	} catch (ClassNotFoundException cnfe) {
	    System.out.println("DynamicLoadFactory: can't load " + name + "Ctr" + " -> " + cnfe.getMessage());
	}
	Object result = null;
	try {
	    Constructor constr = Control.getConstructor(params);
	    Object param_values[] = new Object[PARAMETER_COUNT];
	    param_values[0] = context;
	    param_values[1] = new Integer(port);
	    param_values[2] = window;
	    param_values[3] = new Integer(n);
	    result = constr.newInstance(param_values);
	}
	catch(Exception ex) {
	    System.err.println("DynamicLoadFactory: cannot instantiate control -> " + ex.getMessage());
	}
	return (controls)result;
    }
}
