package EDU.syr.npac.frontend;

import WebFlow.*;
import WebFlow.QS.*;
import java.util.*;
import WebFlow.event.*;
import EDU.auburn.VGJ.gui.GraphWindow;
import EDU.auburn.VGJ.*;
import javax.swing.*;
import javax.swing.event.*;
import javax.swing.tree.*;
import java.awt.*;
import java.awt.event.*;
import java.lang.*;
import java.io.*;
import java.net.*;   

import org.omg.CORBA.*;

public class controls9 extends controls
{
 String message = null;
 String what = null;
 String[] args;
 String user;
 String ref;
 ORB orb;
 boolean URLready;
 int mversion;  
 PBS pbs;

 Checkbox abort, begin, termi;
  
 public controls9(String host, int port, GraphWindow GWindow, int n)
 {
  super(host,port,GWindow);
  mversion = n+1;
  System.out.println("start controls9");   
  
  pbsControl();
 }
    
 public void pbsControl() 
 {
  setLayout(new GridLayout(9,1));
  setBackground(Color.cyan);

  JLabel l1 = new JLabel("PBS interface",JLabel.CENTER);
  l1.setFont(new Font("Serif",Font.BOLD,14));
  add(l1); 
  add(new JLabel(" "));

  add(new JLabel("Notify when ", JLabel.CENTER));

  JPanel mailPanel = new JPanel();
  mailPanel.setLayout(new GridLayout(3, 1));
  abort = new Checkbox("job aborts");
  begin = new Checkbox("job begins execution");
  termi = new Checkbox("job terminates", null, true);

  ItemListener maillistener =  new ItemListener() 
  {
   public void itemStateChanged(ItemEvent e) 
   {
    if(e.getSource() == abort) what = "abort";
    else if(e.getSource() == begin) what = "begin";
    else if(e.getSource() == termi) what = "terminate";
    System.out.println("mail when "+what);
    pbs.setAction(what);
   }             
  };

  abort.addItemListener(maillistener);
  begin.addItemListener(maillistener);
  termi.addItemListener(maillistener);
  mailPanel.add(abort);
  mailPanel.add(begin);
  mailPanel.add(termi);
  add(mailPanel);

  add(new JLabel(" "));

  add(new JLabel("Output"));
  JPanel outputPanel = new JPanel();
  outputPanel.setLayout(new GridLayout(2, 2));
  JLabel outputLabel = new JLabel("output file name", JLabel.CENTER);
  JTextField outputField = new JTextField();
  outputField.setEditable(true);
  JLabel stderrLabel = new JLabel("stderr file name", JLabel.CENTER);
  JTextField stderrField = new JTextField();
  stderrField.setEditable(true);
  outputPanel.add(outputLabel);
  outputPanel.add(outputField);
  outputPanel.add(stderrLabel);
  outputPanel.add(stderrField);
  add(outputPanel);

  add(new JLabel("executable"));

  JTextField textfield1 = new JTextField(10); 
  textfield1.setText("TEST");
  textfield1.addActionListener(new ActionListener() 
  {
   public void actionPerformed(ActionEvent e) 
   {
    message = ((JTextField)e.getSource()).getText();
    System.out.println("PBS exec: "+message);
    //    setValue("EXEC"+message);
    pbs.setExecutable(message);
   }
  });

  add(textfield1);
  JButton sButton = new JButton("do it");
  sButton.addActionListener(new ActionListener() {
    public void actionPerformed(ActionEvent ev) {
    System.out.println("button pressed");
    pbs.run();
    }
   }
  );
  add(sButton);



  }

  public void run() 
  {
   /* get access to ORB */
   args = new String[1];
   args[0]="http://osprey4.npac.syr.edu:8001/IOR/master.txt";
   System.out.println(args[0]);
   try {
    VGJ a = GWindow.applet;
    orb = a.getORB();
    user = a.getUserContext();

   String webIOR = "http://osprey4.npac.syr.edu:8001/IOR/QS/"+user+"PBS"+mversion+".txt";
   System.out.println(webIOR);
   // must wait till the file is written...
   // remember to delete it on exit!

   URLready = false;
   java.net.URL url = new java.net.URL(webIOR);
   InputStream istream;
   int timeOut=0;

   while(!URLready) 
   {
    try {
      istream = url.openStream();
      BufferedReader in = new BufferedReader(new InputStreamReader(istream));
      ref = in.readLine();
      istream.close();
      URLready = true;
    }
    catch(IOException e) {
     waitForURL();
     timeOut++;
     if(timeOut>20) URLready=true;
    }
   }
    
   org.omg.CORBA.Object m_obj=orb.string_to_object(ref);
   if(m_obj == null) 
   {
    System.out.println("m_obj is null ??????");
   }
   else 
   {
    System.out.println("m_obj is OK");
   }
   
   pbs = PBSHelper.narrow(m_obj);
   if(pbs == null) throw new RuntimeException();
   System.out.println("controls9: PBS OK");
   }
   catch(Exception e) {
    System.out.println(e);
   }
   
   }
   public synchronized void waitForURL()
   {
    System.err.println("waiting... "+mversion);
    try {
     wait(2000);
    } 
    catch(InterruptedException e){
     System.out.println("Intrrupted exc :"+e);
    }
   }
}

/**************************************************************************
 *                               The End
 **************************************************************************/





