package LMS.backend;

import java.util.*;
import java.lang.*;
import webflow.backend.*;
import java.net.*;
import java.io.*;
import java.util.zip.*;
import webflow.modules.Templates.*;
import webflow.modules.LMS.WFurl;
import webflow.modules.QuantumSimulations.WFFileDescriptor;

public class ReceiveFile extends Template {

  String command;
  InputPort inport;
  OutputPort outport;
  String inFile, outFile, newFileName;
  boolean flag;

  public MetaModule initialize() {
    
    System.err.println("initialize ReceiveFile");
    MetaModule mm = new MetaModule("mm");

    //outport = new OutputPort("WFFileDescriptor");
    //ID outputID = outport.getPortID();
    //mm.putPortID(outport.getPortID());

    inport = new InputPort("WFFileDescriptor");
    ID inputID = inport.getPortID();
    mm.putPortID(inport.getPortID());
 
    System.err.println("about to end init ReceiveFile");
    return(mm);
    }



  public synchronized void run() {

    CreateServerSocket();

    System.err.println("ReceiveFile started");
    flag=true;

    while(flag) {
       if(inport.isConnected()) {
           System.err.println("ReceiveFile: wait for input...");
           newFileName=(String)inport.receive();
           if(newFileName.equals("done")) {
               System.err.println("ReceiveFile: ready to send <done> sygnal");
               socket.send(newFileName);
               flag=false;
           }
           else {
             System.err.println("ReceiveFile: got filename: "+newFileName); 
             inFile = (String)inport.receive();
             System.err.println("ReceiveFile: contents received");              
             writeFile(newFileName,inFile);    
	   }
       }
       else {
           System.err.println("ReceiveFile input port not connected");
       }
    } 

  }
    public void destroy() {

    inport.destroyPort();
    //outport.destroyPort();
    socket.stop();
    }
    
    public void stop() {}


    public void update_value(String s) 
    {
      
      System.err.println("ReceiveFile: I received message s="+s);
    }

  /** Reading file with name "fileName" **/
  String readFile(String fileName)
   {
     System.err.println("I am reading the file:"+fileName);
 
     File file = new File(fileName);
     char[] data = null;
     try{
       FileReader in = new  FileReader(file);
       //read file char by char
       int size = (int)file.length();
       data = new char[size];
       int chars_read = 0;
       while(chars_read < size)
         chars_read += in.read(data,chars_read,size-chars_read);
     }catch(IOException e){
       System.err.println("There is IOException during reading file:"+e);
     }
 
      return new String(data);
   }

 /** write data from "fileContent" into file with name "fileName" */
 public void  writeFile(String fileName,String fileContent)
   {
     System.err.println("I am writing the file: "+fileName);
 
     try{
       FileOutputStream fw = new FileOutputStream(fileName);
       DataOutputStream dos = new DataOutputStream(fw);
       //write fileContent to file at once
       dos.writeBytes(fileContent);
     }catch(IOException e){
       System.err.println("There is IOException during writing file:"+e);
     }   
     System.err.println("write file completed");
   }


}





