package LMS.backend;

import java.util.*;
import java.lang.*;
import webflow.backend.*;
import java.net.*;
import java.io.*;
import java.util.zip.*;
import webflow.modules.Templates.*;
import webflow.modules.LMS.WFurl;
import webflow.modules.QuantumSimulations.WFFileDescriptor;

public class Messenger extends Template {

  String inmessage;
  InputPort inport;
  OutputPort outport; 
  boolean flag;
  String Project;

  public MetaModule initialize() {
 
    System.err.println("initialize Messenger");
    MetaModule mm = new MetaModule("mm");

    outport = new OutputPort("WFFileDescriptor");
    ID outputID = outport.getPortID();
    mm.putPortID(outport.getPortID());

    inport = new InputPort("WFFileDescriptor");
    ID inputID = inport.getPortID();
    mm.putPortID(inport.getPortID());
 
    System.err.println("about to end init Messenger");
    return(mm);
    }




  public synchronized void run() {



    CreateServerSocket();

    socket.send("start");

    

    Project = "none";

    System.err.println("Messenger started");



    while(Project.equals("none")) {

       waitForProject();

    }

    System.err.println("start for project "+Project);

    flag=true;



    if(outport.isConnected()) {

       try {

            InetAddress local = InetAddress.getLocalHost();
            String myIP=local.getHostAddress(); 
            outport.send(myIP);
            System.err.println("sent "+myIP);
            outport.send(Project); 
       }
       catch (Exception e) {System.err.println("unknown host? "+e.toString());}
    }
    else {
       System.err.println("runEDYS: cannot send my IP"); 
    }

    while(flag) {

       if(inport.isConnected()) {

           System.err.println("Messenger waiting for a message...");

           inmessage=(String)inport.receive();

           System.err.println("Messenger received "+inmessage+"<eom>");

           if(socket != null) {

               socket.send(inmessage);}

           else {

               System.err.println("Messenger: Oops! socket is null");

           }

           if(inmessage.equals("done")) flag=false;

       }

       else {

         flag=false;

         System.err.println("Messenger input port is not connected!");

         socket.send("done");

       }

    }   

    System.err.println("Messenger quiting..."); 

  }

    public void destroy() {



    inport.destroyPort();

     //outport.destroyPort();

    socket.stop();

    }

    

    public void stop() {}






    public void update_value(String s) 

    {

      System.err.println("Messenger: I received message s="+s);

      if(s.startsWith("PROJ")) {

       Project = s.substring(4);

       System.err.println("project = "+Project);

      } 

    }

   

    public synchronized void waitForProject() {

	try{ wait(50);} catch(Exception e){System.err.println(e);}

    }

}

