package LMS.backend;

import java.util.*;
import java.lang.*;
import webflow.backend.*;
import java.net.*;
import java.io.*;
import java.util.zip.*;
import webflow.modules.Templates.*;
import webflow.modules.LMS.WFurl;
import webflow.modules.QuantumSimulations.WFFileDescriptor;

public class ReceiveFile extends Template {

  String command;
  InputPort inport;
  OutputPort outport;
  String inFile, outFile, newFileName;
  boolean flag;
  int bytes_read;
  String Project;
  final String cascHome = "C:\\WebFlow\\WEBSERVER\\htdocs\\Casc2dOutput\\";

  public MetaModule initialize() {
   
    System.err.println("initialize ReceiveFile");
    MetaModule mm = new MetaModule("mm");

    //outport = new OutputPort("WFFileDescriptor");
    //ID outputID = outport.getPortID();
    //mm.putPortID(outport.getPortID());

    inport = new InputPort("WFFileDescriptor");
    ID inputID = inport.getPortID();
    mm.putPortID(inport.getPortID());
 
    System.err.println("about to end init ReceiveFile");
    return(mm);
    }

  public synchronized void run() {

    CreateServerSocket();
    socket.send("start");
  
    Project = "none";
    while(Project.equals("none")) {
       waitForProject();
    }
    System.err.println("start for project "+Project);

    System.err.println("ReceiveFile started");
    flag=true;

    while(flag) {
       if(inport.isConnected()) {
           System.err.println("ReceiveFile: wait for input...");
           newFileName=(String)inport.receive();
           if(newFileName.equals("done")) {
               System.err.println("ReceiveFile: ready to send <done> sygnal");
               socket.send(newFileName);
               flag=false;
           }
           else {
             System.err.println("ReceiveFile: got filename: "+newFileName);
             socket.send("receiving "+newFileName);
             if(newFileName.startsWith("http")) {
                 int idxx = newFileName.lastIndexOf("/");
                 String shortFileName = newFileName.substring(idxx+1);
                 System.err.println("shortFileName: "+shortFileName);
                 getHTTPfile(cascHome+shortFileName,newFileName);
             }
             else {
                 newFileName=cascHome+newFileName; 
                 inFile = (String)inport.receive();
                 writeFile(newFileName,inFile);
	     }  
	   }
       }
       else {
           System.err.println("ReceiveFile input port not connected");
       }
    } 

  }
    public void destroy() {

    inport.destroyPort();
    //outport.destroyPort();
    socket.stop();
    }
    
    public void stop() {}

    public void update_value(String s) 
    {
      System.err.println("SendCascData: I received message s="+s);
      if(s.startsWith("PROJ")) {
       Project = s.substring(4);
       System.err.println("project = "+Project);
      } 
    }


  /** Reading file with name "fileName" **/
  String readFile(String fileName)
   {
     System.err.println("I am reading the file:"+fileName);
 
     File file = new File(fileName);
     char[] data = null;
     try{
       FileReader in = new  FileReader(file);
       //read file char by char
       int size = (int)file.length();
       data = new char[size];
       int chars_read = 0;
       while(chars_read < size)
         chars_read += in.read(data,chars_read,size-chars_read);
     }catch(IOException e){
       System.err.println("There is IOException during reading file:"+e);
     }
      return new String(data);
   }

 /** write data from "fileContent" into file with name "fileName" */
 public void  writeFile(String fileName,String fileContent)
   {
     System.err.println("I am writing the file: "+fileName);
 
     try{
       FileOutputStream fw = new FileOutputStream(fileName);
       DataOutputStream dos = new DataOutputStream(fw);
       //write fileContent to file at once
       dos.writeBytes(fileContent);
     }catch(IOException e){
       System.err.println("There is IOException during writing file:"+e);
     }  
     System.err.println("write file completed");
   }

  public void getHTTPfile(String fileName, String sourceURL) {
    
    InputStream in = null;
    OutputStream out = null;
    bytes_read = 0;
    int oneread = 0;
 
    try {    
      System.err.println("ReceiveFile: "+sourceURL);
      URL url = new URL(sourceURL);
      URLConnection urlcon = url.openConnection();
      int remoteFileLength = urlcon.getContentLength();    
      System.err.println("ReceiveFile: file lenghth: "+remoteFileLength);   
      in = urlcon.getInputStream(); 
      out = new FileOutputStream(fileName);
      byte[] buffer = new byte[4096];
       while(bytes_read < remoteFileLength) {
              oneread = in.read(buffer);
              out.write(buffer,0,oneread);
              setBytesRead(oneread);  
        } 
      }
      catch (Exception e) {System.err.println("ReceiveFile "+e);}       
      finally {
         try{in.close(); out.close();} catch (Exception e){;}
      }
  }

  public int setBytesRead(int bytes_read_) {
      bytes_read += bytes_read_;
      return bytes_read;
  }

    public synchronized void waitForProject() {
	try{ wait(50);} catch(Exception e){System.err.println(e);}
    }

}

