package LMS.backend;

import java.util.*;
import java.lang.*;
import webflow.backend.*;
import java.net.*;
import java.io.*;
import java.util.zip.*;
import webflow.modules.Templates.*;
import webflow.modules.LMS.WFurl;
import webflow.modules.QuantumSimulations.WFFileDescriptor;

public class SendCascData extends Template {

  String command;
  //  InputPort inport;
  OutputPort outport;
  String inFile, outFile;
  boolean flag;
  String Project;
  int i;
  String thisURL;

  public MetaModule initialize() {
    
    System.err.println("initialize SendCascData");
    MetaModule mm = new MetaModule("mm");

    outport = new OutputPort("WFFileDescriptor");
    ID outputID = outport.getPortID();
    mm.putPortID(outport.getPortID());

    //inport = new InputPort("WFFileDescriptor");
    //ID inputID = inport.getPortID();
    //mm.putPortID(inport.getPortID());
 
    System.err.println("about to end init SendCascData");
    return(mm);
    }



  public synchronized void run() {

    System.err.println("SendCascData started...");
    CreateServerSocket();
    socket.send("start");
  
    Project = "none";
    while(Project.equals("none")) {
       waitForProject();
    }
    System.err.println("start for project "+Project);
    try{
    thisURL = "http://"+(InetAddress.getLocalHost()).getHostAddress()+":2956"; 
    } catch (Exception e) {
    System.err.println("cannot determine URL "+e.toString());
    }  

        if(outport.isConnected()) {
          System.err.println("SendCascData: output port is connected");
          String fileDir = "C:\\WebFlow\\WEBSERVER\\htdocs\\CASC2D\\"+Project; 
             File cascDir = new File(fileDir);
             if(cascDir.exists()){
               String[] FileList=cascDir.list();
               for(i=0;i<FileList.length;i++) {
                 socket.send("sending "+FileList[i]); 
                 String fname= fileDir+"\\"+FileList[i];
	         if(((new File(fname)).length()) > 100) {
                   String fileURL = thisURL+"/CASC2D/"+Project+"/"+FileList[i];
                   outport.send(FileList[i]);
                   outport.send(fileURL);
                   //System.err.println("url="+fileURL);
	         }
                 else {  
                   outFile = readFile(fname);  
                   outport.send(FileList[i]);
                   outport.send(outFile);
	         }
	     }
             outport.send("done");
             socket.send("done");
	     }
             else {
              System.err.println("Oops: dir "+fileDir+" does not exist"); 
	     }

        }
	else {
              System.err.println("Oops!! SendCascData outport not connected");
              System.err.println("SendCascData sending sygnal <done>");
              socket.send("done");
              flag=false;
	}
  } 


    public void destroy() {

      //inport.destroyPort();
    outport.destroyPort();
    socket.stop();
    }
    
    public void stop() {}

    public void update_value(String s) 
    {
      System.err.println("SendCascData: I received message s="+s);
      if(s.startsWith("PROJ")) {
       Project = s.substring(4);
       System.err.println("project = "+Project);
      } 
    }

  /** Reading file with name "fileName" **/
  String readFile(String fileName)
   {
     System.err.println("I am reading the file:"+fileName);
 
     File file = new File(fileName);
     char[] data = null;
     try{
       FileReader in = new  FileReader(file);
       //read file char by char
       int size = (int)file.length();
       data = new char[size];
       int chars_read = 0;
       while(chars_read < size)
         chars_read += in.read(data,chars_read,size-chars_read);
     }catch(IOException e){
       System.err.println("There is IOException during reading file:"+e);
     }
 
      return new String(data);
   }

 /** write data from "fileContent" into file with name "fileName" */
 public void  writeFile(String fileName,String fileContent)
   {
     System.err.println("I am writing the file:"+fileName+
                        " content:"+fileContent);
 
     try{
       FileOutputStream fw = new FileOutputStream(fileName);
       DataOutputStream dos = new DataOutputStream(fw);
       //write fileContent to file at once
       dos.writeBytes(fileContent);
     }catch(IOException e){
       System.err.println("There is IOException during writing file:"+e);
     }
   }

    public synchronized void waitForProject() {
	try{ wait(50);} catch(Exception e){System.err.println(e);}
    }
 
}





