package LMS.backend;

import java.util.*;
import java.lang.*;
import webflow.backend.*;
import java.net.*;
import java.io.*;
import java.util.zip.*;
import webflow.modules.Templates.*;
import webflow.modules.LMS.WFurl;
import webflow.modules.QuantumSimulations.WFFileDescriptor;

public class getMap extends Template {

  OutputPort outport;
  
  boolean flag;
  WFurl inData;
  WFFileDescriptor outData;
  URL url;
  InputStream in = null;
  OutputStream out = null;
  String mapName;
  String USGSurl="ftp://edcftp.cr.usgs.gov/pub/data/DEM/250/";
  int S,E,W,N;
  Vector vMaps;
  mapXX mapNames;
  String thisSystem="NT";
  //String thisSystem="Unix";
  int bytes_read, oneread;

  public MetaModule initialize() {
    
    System.err.println("initialize getMap");
    //    CreateServerSocket();
    MetaModule mm = new MetaModule("mm");

    outport = new OutputPort("WFFileDescriptor");
    mm.putPortID(outport.getPortID());

    //    inport = new InputPort("WFMapIndices");
    //    mm.putPortID(inport.getPortID());

    mapNames = new mapXX();

    System.err.println("about to end init getMap");
    return(mm);
    }
  
  public synchronized void run() {
    
    CreateServerSocket();

    System.err.println("getMap started");
    flag=false;
    
    while(true) {
      if(flag) {

      /* received S,N,E,W */

      System.err.println("received SNEW");   
             
      /* translate NEWS into map name(s) */
     
       Vector vMaps = mapNames.getMapName(S,N,E,W);
       Enumeration eMaps=vMaps.elements();

       /* for each map */

       while(eMaps.hasMoreElements()) {

         /* get its name */

         mapName = (String)eMaps.nextElement();
         System.err.println("Download map "+mapName);
	 if(!mapName.equals("none")){  

         /* create URL */

      String cc = mapName.substring(0,1);
      cc = cc.toUpperCase();

      try {
      url = new URL(USGSurl+cc+"/"+mapName+".gz");
      if(thisSystem.equals("Unix")){
            outData = new WFFileDescriptor(mapName);
      }
      else if(thisSystem.equals("NT")) {
            outData = new WFFileDescriptor(mapName,"C:\\WMS\\usgsDEM\\");
           }
      else {
           System.err.println("getMap: Oops, unknown system "+thisSystem);
      }
      }
      catch(Exception e) {System.err.println("getMap (1) "+e.toString());}

  
        /* open connection */

      try{ 
        in =url.openStream();
        GZIPInputStream gzipin = new GZIPInputStream(in);
        out = new FileOutputStream(outData.getFileDirectory()+outData.getFileName());

        /* download it */
        bytes_read = 0;

        byte[] buffer = new byte[4096];
        while((bytes_read = gzipin.read(buffer)) != -1) {
        out.write(buffer,0,bytes_read);
        setBytesRead(oneread);
        } 
      }
      catch (Exception e) {System.err.println(e);}       
      finally {
        try{in.close(); out.close();} catch (Exception e){;}
      }

      if(outport.isConnected()) {
         outport.send(outData); 
      }
      else {
        System.err.println("Output Port is not connected!");
      }
         System.err.println("map downloaded");
       } // not "none"
       else {
        System.err.println("request S="+S+" N="+N+" E="+E+" W="+W+" ignored");
       } // "none" 
       }  // for each map   
       flag = false;
      } // if flag
      else {
	try {
              wait(100);
	} catch(Exception e) {
          System.err.println("interrupted? "+e.toString());
        }
      }
    } // while true
  }  //run

  
    public int setBytesRead(int bytes_read_){
      bytes_read += bytes_read_; 
      return bytes_read;
    } 
     
    public void destroy() {

    //inport.destroyPort();
    outport.destroyPort();
    //socket.stop();
    }
    
    public void stop() {}

   
    public void update_value(String s) 
    {
      
    if (s.startsWith("getMap")){
      System.err.println("I received message s="+s);
      String a=s.substring(6);
      System.err.println(a);
      int idS=a.indexOf("S");
      int idN=a.indexOf("N");
      int idE=a.indexOf("E");
      int idW=a.indexOf("W");
      try {
        S=Integer.parseInt(a.substring(idS+1,idN));     	   
        N=Integer.parseInt(a.substring(idN+1,idE));     	   
        E=Integer.parseInt(a.substring(idE+1,idW));     	   
        W=Integer.parseInt(a.substring(idW+1));
        flag=true;
      }
      catch(Exception e){
       System.err.println("problem with parseInt "+a.substring(idS,idN));
      }
     }
    else {
       System.err.println("oops, I got unexpected message: "+s);  
    }
    }
    

}	
    
    
    


















