package LMS.backend;

import java.util.*;
import java.lang.*;
import webflow.backend.*;
import java.net.*;
import java.io.*;
import java.util.zip.*;
import webflow.modules.Templates.*;
import webflow.modules.LMS.WFurl;
import webflow.modules.QuantumSimulations.WFFileDescriptor;

public class m0rCASC2D extends Template {

  String command;
  InputPort inport;
  OutputPort outport;
  String inFile, outFile;
  boolean flag;
  String Project;
 
  public MetaModule initialize() {
    
    System.err.println("initialize m0rCASC2D");
    MetaModule mm = new MetaModule("mm");

    outport = new OutputPort("WFFileDescriptor");
    ID outputID = outport.getPortID();
    mm.putPortID(outport.getPortID());

    inport = new InputPort("WFFileDescriptor");
    ID inputID = inport.getPortID();
    mm.putPortID(inport.getPortID());
 
    System.err.println("about to end init rCASC2D");
    return(mm);
    }



  public synchronized void run() {

    CreateServerSocket();
    socket.send("start");
    
    Project = "none";
    System.err.println("m0rCASC2D started");

    while(Project.equals("none")) {
       slowDown();
    }
    System.err.println("start for project "+Project);
 
    flag=true;

    // casc2 input data are prefetched
    // start casc2d as a separate thread
    // then take care of sending and receiving data from EDYS

    casc2dThread cT = new casc2dThread(Project);
    cT.start();


    while(cT.isAlive()) {
       
        slowDown();

    } //while 
       System.err.println("CASC2D sending sygnal <done>");
       socket.send("done");

  }
 
    public void destroy() {

    inport.destroyPort();
    outport.destroyPort();
    socket.stop();
    }
    
    public void stop() {}


    public void update_value(String s) 
    {
      System.err.println("m0rCASC2D: I received message s="+s);
      if(s.equals("done")) flag=false;
      if(s.startsWith("PROJ")) {
       Project = s.substring(4);
       System.err.println("project = "+Project);
      } 
    }

  /** Reading file with name "fileName" **/
  String readFile(String fileName)
   {
     System.err.println("I am reading the file:"+fileName);
 
     File file = new File(fileName);
     char[] data = null;
     try{
       FileReader in = new  FileReader(file);
       //read file char by char
       int size = (int)file.length();
       data = new char[size];
       int chars_read = 0;
       while(chars_read < size)
         chars_read += in.read(data,chars_read,size-chars_read);
     }catch(IOException e){
       System.err.println("There is IOException during reading file:"+e);
     }
 
      return new String(data);
   }

 /** write data from "fileContent" into file with name "fileName" */
 public void  writeFile(String fileName,String fileContent)
   {
     System.err.println("I am writing the file:"+fileName+
                        " content:"+fileContent);
 
     try{
       FileOutputStream fw = new FileOutputStream(fileName);
       DataOutputStream dos = new DataOutputStream(fw);
       //write fileContent to file at once
       dos.writeBytes(fileContent);
     }catch(IOException e){
       System.err.println("There is IOException during writing file:"+e);
     }
   }

  public synchronized void slowDown() {
   try {
     wait(100);
   } catch (Exception e) {System.err.println("m0rCUSC2D wait: "+e.toString());}
  } 

}


class casc2dThread extends Thread {

String Project;
final String casc2dHome = "C:\\CASC2D\\";
String executable, ProjFile; 

    public casc2dThread(String Project){
    super();
    this.Project = Project;
    executable = casc2dHome+"wincasc17.exe";
    ProjFile = casc2dHome+Project+"\\"+Project+".prj";
    } 

  public void run() {

    System.err.println("rCASC2D started");
    //String command="cmd /C C:\\WMS\\CowhoseCreek\\wincasc17.exe C:\\WMS\\CowhoseCreek\\cow-wf.prj";
    String command="cmd /C "+executable+" "+ProjFile;
    System.err.println("rCASC2D: "+command);

        try {
              Process p=Runtime.getRuntime().exec(command);
              p.waitFor();
        }
        catch (Exception e) {System.out.println("CASC2D Error: "+e.toString());
	}
   System.err.println("death of the casc2D thread");

  }

}
