package LMS.backend;

import java.util.*;
import java.lang.*;
import webflow.backend.*;
import java.net.*;
import java.io.*;
import java.util.zip.*;
import webflow.modules.Templates.*;
import webflow.modules.LMS.WFurl;
import webflow.modules.QuantumSimulations.WFFileDescriptor;

public class runEDYS extends Template {

  InputPort inport  ;
  OutputPort outport;
  String inFile, outFile, fileName;
  boolean flag;      //true if more events follows
  boolean first;     //true if end_of_event date is 1111; no *.edy files
  final String EdysHome = "C:\\edyswwes\\";
  final String htdocsDir = "C:\\WebFlow\\WEBSERVER\\htdocs\\edyswwes\\";
  String thisURL;
  String inputDataDir;
  String outputDataDir;
  String  command;
  int bytes_read; 
  String Project;

  Calendar endEvent, startEvent, dayOne;
  long dayOneTime;
  int StartDay; 
  int DayDiff;
  long edysend;
  int param3, param4;

  public MetaModule initialize() {
    
    System.err.println("initialize runEDYS");
    MetaModule mm = new MetaModule("mm");

    outport = new OutputPort("WFFileDescriptor");
    ID outputID = outport.getPortID();
    mm.putPortID(outport.getPortID());

    inport = new InputPort("WFFileDescriptor");
    ID inputID = inport.getPortID();
    mm.putPortID(inport.getPortID());
 
    System.err.println("about to end init runEDYS");
    return(mm);
    
  }


  public synchronized void run() {

    CreateServerSocket();
    socket.send("start");

    inputDataDir =  EdysHome+"e-input\\";
    outputDataDir = EdysHome+"e-output\\";
    String  command = EdysHome+"Edys2.exe";

  
    Project = "none";
    while(Project.equals("none")) {
       waitForProject();
    }
    System.err.println("start for project "+Project);

    System.err.println("runEDYS started");
    System.err.println("runEDYS: "+command);
    flag=true;
    if(outport.isConnected()) {
       try {
            InetAddress local = InetAddress.getLocalHost();
            String myIP=local.getHostAddress(); 
            outport.send(myIP);
            System.err.println("sent "+myIP);
            outport.send(Project); 
       }
       catch (Exception e) {System.err.println("unknown host? "+e.toString());}
    }
    else {
       System.err.println("runEDYS: cannot send my IP");
    }

    while(flag) {
       if(inport.isConnected()) {
         socket.send("Edys waiting for next CASC2D data");
         first = receiveStat(param3,param4,edysend);
         socket.send("receiving new data");
         receiveEDY();
         socket.send("data transfer from CASC2D completed");
       }
       else {
           System.err.println("EDYS input port not connected");
       }
         /* run EDYS */
       
        try {
              Process p=Runtime.getRuntime().exec(command);
              p.waitFor();
        }
        catch (Exception e) {System.out.println("EDYS Error: "+e.toString());}

     if(flag) {
         if(outport.isConnected()) {
             socket.send("Edys completed. Sending data");
             /* hood6.rgh <-> manning.edy
                50.ims <-> somoist.edy  
                hood6.ks <-> conduct.edy
                k.map <-> K.edy
                c.map <-> C.edy
                erosion.edy <-> erosion.edy */  

             socket.send("sending manning.edy");
          sendEDY("manning.edy","hood6.rgh");
             socket.send("sending somoist.edy");
          sendEDY("somoist.edy","50.ims");
             socket.send("sending conduct.edy");
          sendEDY("conduct.edy","hood6.ks");
             socket.send("sending K.edy");
          sendEDY("K.edy","k.map");
             socket.send("sending C.edy");
          sendEDY("C.edy","c.map");

             socket.send("data transfer to CASC2D completed");
             //outport.send("done");
             //System.err.println("sygnal done sent");
        }
	  else {
              System.err.println("EDYS outport not connected");
              System.err.println("EDYS sending sygnal <done>");
              socket.send("done");
              flag=false;
	}
     }
     System.err.println("loop completed: flag="+flag);
    } 
   socket.send("done"); 
   System.err.println("runEDYS quitting");
  }
    public void destroy() {

    inport.destroyPort();
    outport.destroyPort();
    socket.stop();
    }
    
    public void stop() {}

    public void update_value(String s) 
    {
      System.err.println("RunEDYS: I received message s="+s);
      try {
      if(s.startsWith("PROJ")) {
       Project = s.substring(4);
       System.err.println("project = "+Project);
      }
      if(s.startsWith("EDYS")) edysend =Long.parseLong(s.substring(4));
      if(s.startsWith("PRM3")) param3 = Integer.parseInt(s.substring(4));
      if(s.startsWith("PRM4")) param4 = Integer.parseInt(s.substring(4));
      } catch (Exception e) {System.err.println(e);}
    }
 
    public void sendEDY(String CascName, String EdysName) {
    FileInputStream source=null;
    FileOutputStream dest=null;
      try {
        String inputFile = EdysHome+"e-output\\"+EdysName;
        String outputFile = htdocsDir+CascName;
        source = new FileInputStream(new File(inputFile));
        dest = new FileOutputStream(new File(outputFile));
        byte[] buffer=new byte[1024];
        while(true) {
          bytes_read = source.read(buffer);
          if(bytes_read==-1) break;
          dest.write(buffer,0,bytes_read);
        }
      } catch (Exception e) {System.err.println(e);}
        finally {
	    try {source.close();} catch (Exception e){;}
	    try {dest.close();} catch (Exception e){;}
        }   
        
        try {        
        thisURL = (InetAddress.getLocalHost()).getHostAddress()+":2956";
        } catch (Exception e) {System.err.println(e);}
        String FileURL = "http://"+thisURL+"/edyswwes/"+CascName;
        System.err.println(FileURL);
        outport.send(FileURL);
    }

  /** Reading file with name "fileName" **/
  String readFile(String fileName)
   {
     System.err.println("I am reading the file:"+fileName);
 
     File file = new File(fileName);
     char[] data = null;
     try{
       FileReader in = new  FileReader(file);
       //read file char by char
       int size = (int)file.length();
       data = new char[size];
       int chars_read = 0;
       while(chars_read < size)
         chars_read += in.read(data,chars_read,size-chars_read);
     }catch(IOException e){
       System.err.println("There is IOException during reading file:"+e);
     }
 
      return new String(data);
   }

 /** write data from "fileContent" into file with name "fileName" */
 public void  writeFile(String fileName,String fileContent)
   {
     System.err.println("I am writing the file:"+fileName+
                        " content:"+fileContent);
 
     try{
       FileOutputStream fw = new FileOutputStream(fileName);
       DataOutputStream dos = new DataOutputStream(fw);
       //write fileContent to file at once
       dos.writeBytes(fileContent);
     }catch(IOException e){
       System.err.println("There is IOException during writing file:"+e);
     }
   }

  public void getHTTPfile(String fileName, String sourceURL) {
    
    InputStream in = null;
    OutputStream out = null;
    bytes_read = 0;
    int oneread = 0;
 
    try {    
      System.err.println("ReceiveFile: "+sourceURL);
      URL url = new URL(sourceURL);
      URLConnection urlcon = url.openConnection();
      int remoteFileLength = urlcon.getContentLength();    
      System.err.println("ReceiveFile: file lenghth: "+remoteFileLength);   
      in = urlcon.getInputStream(); 
      out = new FileOutputStream(fileName);
      System.err.println("http file is saved as "+fileName);
      byte[] buffer = new byte[4096];
       while(bytes_read < remoteFileLength) {
              oneread = in.read(buffer);
              out.write(buffer,0,oneread);
              setBytesRead(oneread);  
        } 
      }
      catch (Exception e) {System.err.println("ReceiveFile "+e);}       
      finally {
         try{in.close(); out.close();} catch (Exception e){;}
      }
  }
 public int setBytesRead(int bytes_read_) {
      bytes_read += bytes_read_;
      return bytes_read;
  }
    void receiveEDY() {       
      System.err.println("waiting for input from casc2d...");
      fileName="waiting";
      while(!fileName.equals("end")){ 
         fileName=(String)inport.receive();
         System.err.println("EDYS received "+fileName);
         socket.send("receiving "+fileName);
         if(fileName.equals("done")) {
           //socket.send(inFile);
           fileName="end";
           flag=false;
         }
         else if(fileName.equals("end")){
           System.err.println("All files received");
         }
         else {
          if(fileName.startsWith("http")) {
             int idxx=fileName.lastIndexOf("/");
             String shortFileName = fileName.substring(idxx+1);
             if(shortFileName.equals("manning.edy")) shortFileName="hood6.rgh";
             if(shortFileName.equals("somoist.edy")) shortFileName="50.ims";
             if(shortFileName.equals("conduct.edy")) shortFileName="hood6.ks";
             if(shortFileName.equals("K.edy")) shortFileName="k.map";
             if(shortFileName.equals("C.edy")) shortFileName="c.map";
  
             getHTTPfile(inputDataDir+shortFileName,fileName);
          }
          else {  
            inFile=(String)inport.receive();
            writeFile(inputDataDir+fileName,inFile);
	  }  
	 }
      }
    }

 boolean receiveStat(int param3, int param4, long edysend) {
    boolean start = false;
    boolean last  = false;

    String Stat=(String)inport.receive();
      System.err.println(Stat);

      int idx = Stat.indexOf("9999");
      if(idx>-1) last=true;

      StringTokenizer st = new StringTokenizer(Stat);
      if(st.countTokens()==10){
        endEvent = Calendar.getInstance();
        startEvent = Calendar.getInstance();
        dayOne = Calendar.getInstance(); 
        dayOne.set(1997,0,0);
        dayOneTime = (dayOne.getTime()).getTime();
        try{
        endEvent.set(
        Integer.parseInt((String)st.nextElement()),
        Integer.parseInt((String)st.nextElement())-1,
        Integer.parseInt((String)st.nextElement())+1,
        Integer.parseInt((String)st.nextElement()),
	Integer.parseInt((String)st.nextElement()));

        if(!last) {
           startEvent.set(
           Integer.parseInt((String)st.nextElement()),
           Integer.parseInt((String)st.nextElement())-1,
           Integer.parseInt((String)st.nextElement()),
           Integer.parseInt((String)st.nextElement()),
	   Integer.parseInt((String)st.nextElement()));
	}
	} catch (Exception e) {
           System.err.println("parse exception "+e.toString()); 
           System.err.println("Ooops: wrong contents of lms_stat.dat "+Stat);
	} 
        
        int y = endEvent.get(Calendar.YEAR);
        if(y==1111) {
         start=true;
         y = startEvent.get(Calendar.YEAR);
         endEvent.set(y,0,0);
         dayOne.set(y,0,0);
         dayOneTime = (dayOne.getTime()).getTime();
	}  
        long ebegin = (endEvent.getTime()).getTime();

        long eend = 1000000;
        if(last) {
           eend = edysend;
	}
        else { 
           eend   = (startEvent.getTime()).getTime();
	}
        System.err.println(dayOneTime+" "+ebegin+" "+edysend);

        StartDay = (int)((((ebegin-dayOneTime)/1000)/3600)/24)+1; 
        DayDiff = (int)((((eend-ebegin)/1000)/3600)/24)+1;
        System.err.println("Edys will start on day "+StartDay);
        System.err.println("Edys will be run for "+DayDiff+" days");

      } else {
        System.err.println("Ooops: wrong contents of lms_stat.dat "+Stat);
        System.err.println("wrong number of tokens");
      }
      String options = formatOptions(StartDay)+formatOptions(DayDiff);
      options = options+formatOptions(param3)+formatOptions(param4);       

      writeFile("C:\\edyswwes\\e-input\\options.txt",options);
      return start;
    }

	String formatOptions(int i) {
	  String x = Integer.toString(i);
          int len = x.length();
          int dif = 5 - len;
          if(dif > 0) {
	      switch (dif) {
              case 1 :
                       x = " "+x;
                       break;   
              case 2 :
                       x = "  "+x;
                       break;   
              case 3 :
                       x = "   "+x;
                       break;   
              case 4 :
                       x = "    "+x;
                       break;   
	      }
	  } 
          return x; 
	}   

    public synchronized void waitForProject() {
	try{ wait(50);} catch(Exception e){System.err.println(e);}
    }
 
}





