package LMS.frontend;

import java.util.*;
import java.net.*;
import java.io.*;


public class MapNames extends Object
{
   private final int maxX = 26;
   private final int maxY = 61;
   private final int minX = 24;
   private final int minY = 66;
   String[][] Maps = new String[maxX][maxY];
   int i,j;
   int iS, iE;

  
   public MapNames()
   {
     for(i=0;i<maxX;i++) {
     for(j=0;j<maxY;j++) {
       Maps[i][j]="";
     }
   }

   }

   public  boolean 
   parse( String url)
   {
  
      URL address = null;
      DataInputStream file = null;
    
      try
      {
         address = new URL(url);

      } catch( MalformedURLException e)
        {
          System.err.println(" Can't create URL from the given path ");
           e.printStackTrace();
           return false;
        }

      try
      {

         if( address != null )
         {
	        file = new DataInputStream( address.openStream() );

         } else   System.err.println("MapNames: address is null");
     
      } catch(IOException e)
        {
           e.printStackTrace();
           return false;
        }

      if( file != null )
      {
         
         try
         {
	        String  map = null;
	        while( ( map = file.readLine() ) != null )
            {
              
	           StringTokenizer st = new StringTokenizer( map );
	       // We are expecting 5 element on the line */

            // System.err.println("MapNames: #tokens="+st.countTokens());

               
                String name = st.nextToken();
                String N = st.nextToken();
                String S = st.nextToken();
                String W = st.nextToken();
                String E = st.nextToken();

             //System.err.println("I read next line:");
             System.err.println(name+" "+N+" "+S+" "+W+" "+E);
             try {
             iS = Integer.parseInt(S);
             iE = Integer.parseInt(E);
	       }
             catch (NumberFormatException e){System.err.println("format exception");}
             
             int jS=iS-minX;
             int jE=iE-minY;
             //System.err.println(iS+" "+jS+" "+iE+" "+jE);
             Maps[jS][jE] = name;
       
	        }// end of while
	
         } catch(IOException e)
           {
	          System.out.println(" Read error");
              e.printStackTrace();
	          return false;
           }
      }

      System.err.println(" I am out of parse() ");
      for(int ii=0;ii<maxX;ii++) {
        for(int jj=0;jj<maxY;jj++) {
           System.out.println("     Maps["+ii+"]["+jj+"]="+Maps[ii][jj]);
        }
      }    

      //say we have point 34,100
      int i1=34-minX;
      int j1=100-minY;
      System.err.println("point "+i1+" "+j1);
      System.err.println("point 34,100 is in "+Maps[i1][j1]);

      

      return true;

   }// end of parse()
 
 

 public static void main(String[] argv){
  MapNames list = new MapNames();
  list.parse("file:/home/B8D/haupt/LMS/DEM.txt");

   }



  
}
