package LMS.frontend;

import com.sun.java.swing.*;
import java.awt.*;
import java.awt.event.*;
import java.io.*;
import java.util.*;

public class MonitorProgress extends Thread{

      BorderPanel source;

      ClientSocket    conn;

      boolean completed;
      WordCounterTime wct;

	public MonitorProgress(BorderPanel source_)

      {
	   source = source_;

	   conn   = source.socket;

      }

      public void run(){
      JFrame f = new JFrame("Loading URL file to Applet Server");

	while(true)
	{

	   source.completed=false;	
 	   waitUntilSocketReady();

	   waitProgressMonitorStart(); 

	
         wct = new WordCounterTime(source,f);

     	   f.getContentPane().add(wct);

	    f.addWindowListener(new WindowAdapter() {

	  	public void windowClosing(WindowEvent evt) {

			System.exit(0);

		}

	   });

	   //f.pack();

	   //f.setVisible(true);
         waitCompleted ();
  	   
     }

  }


     public  synchronized void waitCompleted ()
     {
     while (!source.completed) {
           try {
		 wait(100);
	     }catch(InterruptedException e){
		 System.err.println("Intrrupted exc :"+e);
           }
	   }

     }
     public  synchronized void waitUntilSocketReady()

      {



        while (source.connected == false) {

          try {

		 wait(100);

	     }catch(InterruptedException e){

		 System.err.println("Intrrupted exc :"+e);

           }

           

	     System.err.println("Waiting socket ");

        }

	  System.err.println("Has Valid socket");

     }



	public  synchronized void waitProgressMonitorStart()

      {

	  try{        

	  while(source.socket.DIStream().available() <= 0){

	    try{

	   	wait(100);//super.wait(100);

	    }catch(InterruptedException e){

		 System.err.println("Intrrupted exc :"+e);

          }

	  }   

	  }catch(IOException e){

	    System.err.println("IOE during recv .."+e);

        } 

        System.err.println("I GOT INITIAL value !!!");      



     }



}



class WordCounterTime extends JPanel implements Runnable{

     	ClientSocket    conn;
	String name;
	JFrame myparent;
        BorderPanel source;
	protected JTextField fileName;

	protected JLabel wordsFound;

	protected static final String TIME_STRING = "Time remaining: ";

	protected static final long CHECK_INTERVAL = 1;//500;
      String message;

	
	public WordCounterTime(BorderPanel source_,JFrame myparent_) {

	   source = source_;

	   conn = source.socket;

         myparent = myparent_;



	   JLabel l = new JLabel("LOADING ...", JLabel.CENTER);

	   this.add(l);

	   new Thread(this).start();

	}



	public synchronized void run() { 
            message = "nothing yet"; 
            System.err.println("WordCounterTime started");

		//receive file name (MNA: map name)

		//name = conn.receive();
            name = waitForSygnal("MNA"); 

            System.err.println("Received filename :"+name);



 			      int words = 0;

				int bytesRead = 0;

				String str;

				DataInputStream is = null;

				ProgressMonitor p = null;

				long startTime;

				long currentTime;

				long lastCheckTime;
                        int fileSize=0;
                        int ttt=0;
                       

				

                 try{

                         	

				//receive file length

				// Total size of file
                        try{

          			fileSize = Integer.parseInt(waitForSygnal("RFL"));
                        } catch(Exception e) {
                           System.err.println("RLF parse problem");}

				System.err.println("i received :"+fileSize);

    

                 		p = new ProgressMonitor(WordCounterTime.this,

									"Loading file: " + name,

									TIME_STRING,

									0, (int)fileSize);

				p.setMillisToDecideToPopup(5);

	

				startTime = System.currentTimeMillis();

				lastCheckTime = startTime;

				while (bytesRead < fileSize) {

					//receive next length
                              //int ttt=conn.DIStream().readInt();
                              try { 
                              ttt = Integer.parseInt(waitForSygnal("ONE"));
                              } catch (Exception e) { 
                                System.err.println("ONE parse problem");}

					bytesRead += ttt;

				      //System.err.println("i received :"+ttt+" "+bytesRead);



					currentTime = System.currentTimeMillis();

					if (currentTime - lastCheckTime > CHECK_INTERVAL) {

						lastCheckTime = currentTime;

						float bytes = (float)bytesRead;

						float sizeLeft = fileSize - bytes;

						int guessTime = (int)((((currentTime - startTime)/bytes) * sizeLeft)/1000);

						p.setNote(TIME_STRING + guessTime + " seconds");							

					}

					p.setProgress(bytesRead);

				}

                        System.err.println("total received: "+bytesRead+" of "+fileSize);

  		}catch(Exception e){System.err.println("IOE 1:"+e);

             }

		

 		System.err.println("I finished monitoring ");

      	



		if (p != null) {

			p.close();			// Close the ProgressMonitor

		}

		if (myparent != null)

			myparent.dispose();

		
		//set completed flag
		source.completed = true;
	

	};


     public  synchronized String waitForSygnal (String prefix)
     {
     while (!message.startsWith(prefix)) {
           try {
		 wait(100);
	     }catch(InterruptedException e){
		 System.err.println("Intrrupted exc :"+e);
           }
	   }
       String sygnal=message.substring(3); 
       System.err.println(message+" --> "+sygnal);
       message = "consumed_message";
       return sygnal;
     }
	

    public void setMessage(String m) {
      message = m;   
    }
}
