import java.io.*;
import java.net.*;
import java.util.*;
import javax.servlet.*;
import java.lang.*;


  /* The big idea is as follows:
     module creates a server socket and sends its port number here (p)
     (message with format PUTX, where X is the port number)
     then the controls connect with message GET which is responded to by
     sending the value of p (converted to a a string).
     Now, it may happen that the controls connects before the module,
     therefore p is initialised to 0, and reset to 0 as soon as it is sent.
     This way p=0 unless the module deposited a new port number.
     Controls is supposed to keep trying till p != 0, therefore connection
     is implemented as a separate thread.
     This servr is implemented as a separate thread in order not to block
     WebEdit.
     */


public class PortServlet extends GenericServlet implements Runnable
{
  public final static int DEFAULT_PORT=5500;
  protected int port=0;
  protected ServerSocket listen_socket;
  public static Integer p = new Integer(0);
  Thread socketThread;
  String hostName;
  int    portNumber;
  int counter=0;
  SwingServlet swingservlet;
  public static String DocumentRoot=null;
  public static boolean PSGpending = false;
  Vector PSDsocketList = new Vector(10);

  public void init(ServletConfig Params) throws ServletException
  {
    System.err.println("before swingservlet init ");
    swingservlet = new SwingServlet();
    System.err.println("after  swingservlet init ");

    int port=0;

    System.err.println("Module Manager accessed");
    try {
          super.init(Params);
    } catch (ServletException e)
      {  System.err.println(" Exception in init() of MM ");
         e.printStackTrace();
      }

	System.err.println("super.init !!!");

    String portString = Params.getInitParameter("Port");
    if (portString != null)
       port = Integer.parseInt(portString);

    //-----
    if(port==0) port = DEFAULT_PORT;
    this.port=port;
    try { listen_socket = new ServerSocket(port);}
    catch (IOException e) {fail(e,"Exception creating server socket");}

    //Erol additions
    try{
      listen_socket.setSoTimeout(1);
    }catch(SocketException e){
      System.err.println("SocketException :"+e);
    }
    //Erol additions

    System.err.println("Server: listening on port " + port);
    //-----

    // finally, branch new thread, set it up as a deamon (to terminate
    // upon completion of master program), and start it up
    
    

    portNumber = port;
    try{
      // get local host name
	InetAddress local = java.net.InetAddress.getLocalHost();
	hostName = local.getHostName();
      System.err.println("WATCH THAT:  ======================"); 
      System.err.println("Port Servlet: hostName :"+hostName);
      System.err.println("==use getHostAddress() instead ============="); 
      hostName = local.getHostAddress();
      System.err.println("Host address = "+hostName);
      //hostName = "134.164.3.220";
      System.err.println("Host address = "+hostName);
     }catch(UnknownHostException e)
    {  hostName = "0";
       //System.err.println(" UnknownHostException in init() of MM ");
       e.printStackTrace();
    }

    socketThread = new Thread(this);
    socketThread.setDaemon(true);
    socketThread.start();
   
       
 }
  
public void testSomething(ServletRequest req)
  {
    System.err.println("This servlet has the following atts:");
    String docRoot = (String)
      req.getAttribute("org.apache.jserv.DOCUMENT_ROOT");
    String serverName = (String)
      req.getAttribute("org.apache.jserv.SERVER_NAME");
    String serverPort = (String)
      req.getAttribute("org.apache.jserv.SERVER_PORT");
    
    System.err.println("DocRoot:"+docRoot);
    System.err.println("Servername:"+serverName);
    System.err.println("ServerPort:"+serverPort);        
  }
  


  
  public static void fail(Exception e, String msg) {
    System.err.println(msg+":"+e);
    System.exit(1);
  }

  public void run() 
  {
    System.err.println("PortServlet is running....");
    while(true) {
      try{
	Socket client_socket = listen_socket.accept();
	Connection c = new Connection(client_socket,this);
      }catch(InterruptedIOException e){
	//System.err.println("InterruptedIOException  ");
      }catch(IOException e){
	System.err.println("IOException during accepting clinet ");
      }
      swingservlet.checkin();
    }
  }
  
    
  public void service(ServletRequest req, ServletResponse res)
       throws ServletException, IOException
  {

  
        counter++;
    
        res.setContentType("text/plain");
        OutputStream os = res.getOutputStream();
        PrintStream out = new PrintStream( os );
        out.println(hostName);
        out.println(portNumber);
        out.println("EROL:counter:"+counter);
        out.flush();

	String s = req.getParameter("filename");
        out.println("param :"+s);

        //this works fine with Apache servlets but not Jrun    
	//DocumentRoot = (String)req.getAttribute("org.apache.jserv.DOCUMENT_ROOT");
        DocumentRoot = "C:\\WebFlow\\WEBSERVER\\htdocs";
	
  }

  public void addSocket(PSDataSocket socket) {
    PSDsocketList.addElement(socket);
  }  
  public PSDataSocket getSocket() {
    return (PSDataSocket)PSDsocketList.lastElement();
  }  
  
}

class Connection extends Thread {
protected Socket client;
protected DataInputStream dis;
protected DataOutputStream dos;

ServerSocket ProxyServerSocket;  
Socket ProxySocket, rmSocket0; 
PSSocket localSocket, dataSocket, tmpSocket;
PSDataSocket rmSocket, dataSocket1;
PSSocket dummySocket=null;
String hostName;
PortServlet parent;

  /*

  applet                                 module    
    |                                      |
 <rmSocket>                           <localSocket>   
    |                                      | 
 PortServlet <-------dataSocket -----> PortServlet    

 */

  String m1,reply;
  int aport;
  Integer p;
  int iwait;

  public Connection(Socket client_socket, PortServlet parent) {
  client = client_socket;
  this.parent = parent;
  try {
        InetAddress who = client.getInetAddress();
        hostName = who.getHostName(); 
        dis = new DataInputStream(client.getInputStream());
        dos = new DataOutputStream(client.getOutputStream());
  }
  catch (IOException e) {
         try {client.close();}
         catch (IOException e2) {;}
         System.err.println("Exception while getting socket streams: " + e);
         return;
  }
  this.start();
  }
  
  public void run() 
  {
         String line;
         StringBuffer revline;
         int len;

           System.err.println("PortServlet: waiting for a message...");
	   String message = receive();
           System.err.println("received "+message); 
           if(message.startsWith("PUT")) {
              m1 = message.substring(3);
              System.err.println("register port "+m1); 
              PortServlet.p = new Integer(m1);
              aport = PortServlet.p.intValue();

	   //if this PUT follows RTG request
      	   //create a client socket and connect to the module

	   if(PortServlet.PSGpending) {
   System.err.println("create a client socket and connect to the module");
             if(aport >0) {
             try {
	      localSocket = 
              new PSSocket(hostName,PortServlet.p.intValue()); 
	     } catch (Exception e) {System.err.println(e);}
	       localSocket.send("Something");
               PortServlet.p = new Integer(0);                     
	       // now add automatic forwarding
             PSDataSocket psd = parent.getSocket();
             psd.addSocket(localSocket);
             }
             else {
             System.err.println("wrong PUT request? ...");
             }  
             PortServlet.PSGpending = false; 
	   }
 
	   }
	   else if(message.startsWith("GET")) {
             send(PortServlet.p.toString());
             PortServlet.p = new Integer(0);      
	   }
           else if(message.startsWith("RGT")) {  //Remote GeT
             System.err.println("connection to a remote host requested");

             //     RGT request (with remotehost specified) 
 
             // 1. send request for connection to the remote PortServlet    
             //    - create tmpSocket to remotehost:5500 
             //      (i.e.,  peer PostServlet)
             //    - send request PSG   (imitates GET request)
             //    - receive reply with port number to forward messages from
	     //      the applet    
	     //    - close tmpSocket
	     // 2. create dataSocket for forwarding the applet's messages
       	     //    - create a new PSSsocket: dataSocket 
             // 3. create a proxy server socket
             //    - send its port number back to the applet
             //      and let applet connect to it
             //    this is ProxySocket; 


             // send request for connection to the remote PortServlet    
          String rmHost = message.substring(3);
          System.err.println("connect to remote host "+rmHost);

          tmpSocket = new PSSocket(rmHost,5500);

          System.err.println("RGT: socket to 5500 - OK");    
	  String msg = "PSG"; // PortServer Get socket to connect with
          tmpSocket.send(msg);
          reply = tmpSocket.receive();
          tmpSocket.stop();

          System.err.println("RGT: Now open socket to the port you just received");
          Integer iport = new Integer(reply);
          int dataPort = iport.intValue();
          System.err.println("RGT host="+rmHost+" port="+dataPort);
          if(dataPort != 0) {
	    dataSocket = new PSSocket(rmHost,dataPort);
          }
          else {
          System.err.println("RGT request: Connection failed!");
          }              
          System.err.println("RGT: dataSocket seems to be OK");

             //   create a proxy server socket (PSDataSocket)
             //    - send its port number back to the applet
             //      and let applet connect to it


          try {ProxyServerSocket = new ServerSocket(0);}
          catch (Exception e) {System.err.println(e);}  
          
          System.err.println("RGT: ProxyServerSocket created");
          int nextport = ProxyServerSocket.getLocalPort();

          System.err.println("RGT: local port is "+nextport);
          send(Integer.toString(nextport));
          try {ProxySocket=ProxyServerSocket.accept();}
          catch (Exception e) {System.err.println(e);}

          System.err.println("RGT: port sent: "+nextport);
          rmSocket = new PSDataSocket(ProxySocket,dataSocket);
          System.err.println("RGT request completed");
	   }  // RGT request

	   //=============================================================

	   else if(message.startsWith("PSG")) { //remote PortServlet Get
	     //request from a peer PortServlet
             System.err.println("Got PSG request"); 
             PortServlet.PSGpending = true;

             //create a server socket
             try {ProxyServerSocket = new ServerSocket(0);}
             catch (Exception e) {System.err.println(e);}  
             int nextport = ProxyServerSocket.getLocalPort();            
      
             System.err.println("send back "+Integer.toString(nextport)); 
             // send back the port number and wait for connection
             send(Integer.toString(nextport));
           System.err.println("PSG: message sent"); 
	     try {rmSocket0=ProxyServerSocket.accept();}
	     catch(Exception e) { System.err.println(e);}
           System.err.println("PSG ProxyServerSocket is listening...");

             dataSocket1 = new PSDataSocket(rmSocket0,dummySocket); 
	     //there is no module ServerSocket yet
             parent.addSocket(dataSocket1);
             System.err.println("PSG: client connected");
             System.err.println("PSG request completed");

     } //  PSG request

	else{
	     System.err.println("unknown request to the PortServer");
	   }
	   
	   try {
	     client.close();
	   }  catch (IOException e2) {;}
  }
  

  public void send(String message){

     int sl = message.length();
     byte[] buf =new byte[sl];
     message.getBytes(0,sl,buf,0); 
     System.err.println("Trying to send... "+message);

       try{
           dos.writeInt(sl);
           dos.write(buf,0,sl);
           dos.flush();
          } catch(IOException e) {System.err.println(e);}
}

     public String receive(){
     String message = "";
     try{
        int ls=dis.readInt();
	System.err.println("strlen "+ls);
        byte buf[] = new byte[ls];
        dis.read(buf,0,ls);
        message = new String(buf,0,ls);
	       System.err.println("I have received from Applet: "+message);
        } catch(IOException e){
          System.err.println(e);
          stop();
        }
	return(message);
     }
  
}

class SwingServlet
{
public int WFEPort = 5505;
public ServerSocket WFESock;
public Socket []socket_list = new Socket [16];
public ObjectOutputStream []oos_list = new ObjectOutputStream[16];
public ObjectInputStream []ois_list  = new ObjectInputStream[16];  
public DataInputStream []dis_list  = new DataInputStream[16];  
  int socketCounter =0;
  
 public  SwingServlet() 
   {
 
      try{
	WFESock = new ServerSocket(WFEPort);
	WFESock.setSoTimeout(1);
      }catch(IOException e){
	System.err.println("SwinServlet could not open port:"+WFEPort+":"+e);
      }
      for(int k = 0;k<16;k++){
	socket_list[k]=null;
	oos_list[k] = null;
	ois_list[k] = null;
	dis_list[k] = null;
      }
   }
  

 public void checkin  () 
  {
    boolean flag = true;
    
    //    while(flag) {
      try{   
	Socket s = WFESock.accept();
	oos_list[socketCounter] = new ObjectOutputStream(s.getOutputStream());
	ois_list[socketCounter] = new ObjectInputStream(s.getInputStream());
	dis_list[socketCounter] = new DataInputStream(s.getInputStream());
	System.err.println("client connected !!"+oos_list[socketCounter]+
			   "&&"+ois_list[socketCounter]);

	socket_list[socketCounter++]  = s;
      }catch(InterruptedIOException e){
       //System.err.println("InterruptedIOException during accepting clinet ");
      }catch(IOException e){
	System.err.println("IOException during accepting clinet ");
      }
   
      for(int k=0;k < socketCounter; k++){
	try{
	  if ((dis_list[k] != null) && (dis_list[k].available() > 0))
	    {
	      processWFECommand(k);
	    }
	  }catch ( IOException e ) 
	    {
	      System.err.println( "IOException(run): " + e.toString() );
	    }
      }
      
      // } (while)
  }
  
public void  processWFECommand(int k)
  {
  
    System.err.println("processWFECommand :k:"+k);
    
      String message = receive(ois_list[k]);
      
      if (message.startsWith("GetGML")){
	//get the file with name "filename" and send it
	String filename = message.substring("GetGML".length());
	filename = PortServlet.DocumentRoot+"\\"+filename;
	String buf = readFile(filename);
	send(buf,oos_list[k]);
      }
      else if (message.startsWith("StoreGML")){
	//store the file in "buf" into the file with name "filename"
	String filename = message.substring("StoreGML".length());
	filename = PortServlet.DocumentRoot+"\\"+filename;
	String buf      = receive(ois_list[k]);
	writeFile(filename,buf);
      }
      else if (message.startsWith("SWING_REQ")){
	//give the directory list to applet
	String filename = message.substring("SWING_REQ".length());
	filename = PortServlet.DocumentRoot+"\\"+filename;
	System.err.println("I received DIR NAME:"+filename);
	String []dir_content=null;
	try{
	  dir_content = list(filename,"");
	}catch(InterruptedException e){	}
	send_directory_contents(dir_content,oos_list[k]);
      }
  }
  
public void send_directory_contents(String []list,ObjectOutputStream dos)
  {
    
    send(list[0],dos);
    int nfiles = list.length-1;
    send(Integer.toString(nfiles),dos);
    
    for(int i=1;i<list.length;i++)
      send(list[i],dos);

  }

public   String [] list(String dir,String opts)
         throws InterruptedException
  {
    String separator = File.separator;
    boolean isExist=false,isRead=false;
    Vector lines = new Vector();

    //insert first requested directory name
    lines.addElement(dir);

    //check that this directory exists first
    File file = new File(dir);
    try{
      if (file.exists())
	isExist = true;
      isRead = true;
    }catch(SecurityException e){
      System.out.println("Security Exception "+e);
    }
    
    if (!isRead){
      System.out.println(dir+" is not readable");
      lines.addElement("total xx");   
      lines.addElement("NotReadable");
    }
    else if (!isExist){
      System.out.println(dir+" Not Found");
      lines.addElement("total xx");
      lines.addElement("NotFound");
    }
    if ((!isRead)||(!isExist)){
      System.out.println("file "+dir+" not found or not readable");
      String[] retval = new String[lines.size()];
      lines.copyInto(retval);
      return retval;
    }

    try{
      
      String line;
      String  cmd=null,pwd=null;
      Process child;
      DataInputStream in;

      //start up the command
	if (separator.equals("/")) //UNIX
        cmd = "ls -al "+dir;
      else if (separator.equals("\\")) //WIN/NT
	  cmd = "cmd.exe /C "+" DIR "+dir;   //running dir on top of WIN/NT
        //cmd = "command.com /C "+" DIR "+dir; //running dir on top of DOS
        
	
      child = Runtime.getRuntime().exec(cmd);
	System.out.println("Before DIS ");
      in = new DataInputStream(child.getInputStream());
      
      //read the command's output
      while((line = in.readLine()) != null){
 	    lines.addElement(line);
          System.out.println("line: "+line);
      }

	//User gave wrong directory name
	if (lines.size() == 0){
         System.out.println(dir+" Not Found");
         lines.addElement("total xx");
         lines.addElement("Filename ,directory name or volume label syntax is incorrect");
         String[] retval = new String[lines.size()];
         lines.copyInto(retval);
         return retval; 
      }

	// If you want to see detail , give this command "cmd /C dir " or "command /C dir"
      //Delete first three lines of output from dir command
      //Volume in drive ..; volume serial; blank line and fifth line  which is blank
	//and last three lines
      if (separator.equals("\\")){    //WIN/NT 	
	   System.out.println("Delete these (first): "+lines.elementAt(1)+"-*- "+
	                                       lines.elementAt(2)+"-*- "+
 						         lines.elementAt(3)+"-*-"+
	  						   lines.elementAt(5)+"-*-");	
	   lines.removeElementAt(1);
         lines.removeElementAt(1);
	   lines.removeElementAt(1);
         lines.removeElementAt(2);
	   int l = lines.size()-1;
	   System.out.println("Delete these (last): "+lines.elementAt(l)+"-*- "+
	                                       lines.elementAt(l-1)+"-*-");
 						         
         lines.removeElementAt(l);
         lines.removeElementAt(l-1);
	}

      String[] retval = new String[lines.size()];
      lines.copyInto(retval);
      return retval;
    } catch (Exception e){
      throw new InterruptedException (e.toString());
    }
  }


 public void send(String message,ObjectOutputStream dos)
  {
    System.err.println("Outgoing String:"+message);
    try{
      dos.writeObject(message);
      dos.flush();
    }catch(OptionalDataException e){
      System.err.println("sendWFECommand "+e);
    }catch(IOException e){
      System.err.println("sendWFECommand "+e);
    }
  }

  public String receive(ObjectInputStream dis)
  {
    Object message = null;
    
    try{
      message = dis.readObject();
     }catch(OptionalDataException e){
      System.err.println("recvWFEMessage "+e);
    }catch(ClassNotFoundException e){
      System.err.println("recvWFEMessage "+e);
    }catch(IOException e){
      System.err.println("recvWFEMessage "+e);
    }
     System.err.println("I received :"+(String)message);
    return((String)message);
  }


 String readFile(String fileName)
   {
     System.err.println("I am reading the file:"+fileName);
     
     File file = new File(fileName);
     char[] data = null;
     try{
       FileReader in = new  FileReader(file);
       //read file char by char
       int size = (int)file.length();
       data = new char[size];
       int chars_read = 0;
       while(chars_read < size)
         chars_read += in.read(data,chars_read,size-chars_read);
     }catch(IOException e){
       System.err.println("There is IOException during reading file:"+e);
     }
     
      return new String(data);
   }
  
 public void  writeFile(String fileName,String fileContent)
   {
     System.err.println("I am writing the file:"+fileName+ 
			" content:"+fileContent);
     
     try{
       FileOutputStream fw = new FileOutputStream(fileName);
       DataOutputStream dos = new DataOutputStream(fw);
       //write fileContent to file at once
       dos.writeBytes(fileContent);
     }catch(IOException e){
       System.err.println("There is IOException during writing file:"+e);
     }
   }

}
  
class PSSocket {

Socket socket;  
DataOutputStream dos;
DataInputStream dis;

  public PSSocket(String Host, int Port) {

try{
  // client side socket
   socket=new Socket(Host,Port);
   dos= new DataOutputStream(socket.getOutputStream());
   dis= new DataInputStream(socket.getInputStream());
   }
   catch(IOException e) {System.err.println(e);}
  }
  // server side socket
  public PSSocket(Socket aSocket){
  socket = aSocket;
  try {
   dos= new DataOutputStream(socket.getOutputStream());
   dis= new DataInputStream(socket.getInputStream());
  }
  catch(IOException e) {System.err.println(e);}
  }


 public void send(String message){

     int sl = message.length();
     byte[] buf =new byte[sl];
     message.getBytes(0,sl,buf,0); 

       try{
           dos.writeInt(sl);
           dos.write(buf,0,sl);
          } catch(IOException e) {System.err.println(e);}
    }

     public String receive(){
     String message = "";
     try{
        int ls=dis.readInt();
        byte buf[] = new byte[ls];
        dis.read(buf,0,ls);
        message = new String(buf,0,ls);
        } catch(IOException e){System.err.println(e);}
    return(message);
}

  public void stop(){
     try{
          socket.close();
         }catch(IOException e) {System.err.println(e);}
    }
} 



class PSDataSocket implements Runnable {

private Thread runner;
Socket socket;
PSSocket fSocket;  
DataOutputStream dos;
DataInputStream dis;

  public PSDataSocket(String Host, int Port, PSSocket fSocket) {

  this.fSocket = fSocket;
  try{
  // client side socket
   socket=new Socket(Host,Port);
   dos= new DataOutputStream(socket.getOutputStream());
   dis= new DataInputStream(socket.getInputStream());
   }
  catch(IOException e) {System.err.println(e);}
  start();
  }
  // server side socket
  public PSDataSocket(Socket aSocket, PSSocket fSocket){
  socket = aSocket;
  this.fSocket = fSocket;
  if(fSocket == null) {System.err.println("oops! socket is null!");}
  try {
   dos= new DataOutputStream(socket.getOutputStream());
   dis= new DataInputStream(socket.getInputStream());
  }
  catch(IOException e) {System.err.println(e);}
  start();
  }

  public void start() {
    if(runner==null) {
      runner = new Thread(this);
      runner.start(); 
    }
  }

  public void run() {
    while(true) {
      String message = receive();
      //System.err.println("message to forward: "+message);
      fSocket.send(message);
    }
  }

 public void send(String message){

     int sl = message.length();
     byte[] buf =new byte[sl];
     message.getBytes(0,sl,buf,0); 

       try{
           dos.writeInt(sl);
           dos.write(buf,0,sl);
          } catch(IOException e) {System.err.println(e);}
    }

     public String receive(){

    //receive a message from an applet and forward it to a peer PortServlet

     String message = "";
     try{
        int ls=dis.readInt();
        byte buf[] = new byte[ls];
        dis.read(buf,0,ls);
        message = new String(buf,0,ls);
        } catch(IOException e){System.err.println(e);}
     return message;
}

  public void stop(){
    if(runner != null) {
      runner.stop();
      runner=null;
      try {socket.close();}
      catch(IOException e) {System.err.println(e);}
    }
  } 
 
  public void addSocket(PSSocket newSocket) {
   fSocket=newSocket;
  } 

}

  /*
class PSDataSocketFrom {

Socket socket;
?Socket fSocket;  
DataOutputStream dos;
DataInputStream dis;

  public PSDataSocketFrom(String Host, int Port, ?Socket fSocket) {

  this.fSocket = fSocket;
try{
  // client side socket
   socket=new Socket(Host,Port);
   dos= new DataOutputStream(socket.getOutputStream());
   dis= new DataInputStream(socket.getInputStream());
   }
catch(IOException e) {System.err.println(e);}
  }
  // server side socket
  public PSDataSocket(Socket aSocket, Socket fSocket){
  socket = aSocket;
  this.fSocket = fSocket;
  try {
   dos= new DataOutputStream(socket.getOutputStream());
   dis= new DataInputStream(socket.getInputStream());
  }
  catch(IOException e) {System.err.println(e);}
  }

 public void send(String message){

     int sl = message.length();
     byte[] buf =new byte[sl];
     message.getBytes(0,sl,buf,0); 

       try{
           dos.writeInt(sl);
           dos.write(buf,0,sl);
          } catch(IOException e) {System.err.println(e);}
    }

     public void receive(){

    //receive a message from a peer PortServlet and forward it to a module

     String message = "";
     try{
        int ls=dis.readInt();
        byte buf[] = new byte[ls];
        dis.read(buf,0,ls);
        message = new String(buf,0,ls);
        } catch(IOException e){System.err.println(e);}
    fSocket.send(message);
}

  public void stop(){
     try{
          socket.close();
         }catch(IOException e) {System.err.println(e);}
  } 

}

*/

class PSSocket1 implements Runnable {

private Thread runner;
Socket socket;  
DataOutputStream dos;
DataInputStream dis;

  public PSSocket1(String Host, int Port) {

try{
  // client side socket
   socket=new Socket(Host,Port);
   dos= new DataOutputStream(socket.getOutputStream());
   dis= new DataInputStream(socket.getInputStream());
   }
   catch(IOException e) {System.err.println(e);}
   start();
  }
  // server side socket
  public PSSocket1(Socket aSocket){
  socket = aSocket;
  try {
   dos= new DataOutputStream(socket.getOutputStream());
   dis= new DataInputStream(socket.getInputStream());
  }
  catch(IOException e) {System.err.println(e);}
  start();
  }


  public void start() {
    if(runner==null) {
      runner = new Thread(this);
      runner.start(); 
    }
  }

  public void run() {
    while(true) {
      String message = receive();
      //      do something with the received message! fSocket.send(message);
    }
  }

 public void send(String message){

     int sl = message.length();
     byte[] buf =new byte[sl];
     message.getBytes(0,sl,buf,0); 

       try{
           dos.writeInt(sl);
           dos.write(buf,0,sl);
          } catch(IOException e) {System.err.println(e);}
    }

     public String receive(){
     String message = "";
     try{
        int ls=dis.readInt();
        byte buf[] = new byte[ls];
        dis.read(buf,0,ls);
        message = new String(buf,0,ls);
        } catch(IOException e){System.err.println(e);}
    return(message);
}

  public void stop(){
    if(runner != null) {
      runner.stop();
      runner=null;
     try{
          socket.close();
         }catch(IOException e) {System.err.println(e);}
    }
  } 

}
