package webflow.modules.LMS;

import webflow.backend.*;
import java.net.*;
import java.io.*;
import webflow.modules.Templates.*;
import webflow.modules.QuantumSimulations.WFFileDescriptor;

public class Unzip extends Template {
  
  InputPort inport;
  OutputPort outport;
  String message,newmessage;
  String command,editor;
  String disp;
  WFFileDescriptor inFile,outFile;
  String FileName, ShortName, unzippedFileName;
  String thisSystem = "NT";
  
  public MetaModule initialize() {
    
    CreateServerSocket();
    MetaModule mm = new MetaModule("mm");

    outport = new OutputPort("WFFileDescriptor");
    System.err.println("got outport");
    ID outputID = outport.getPortID();
    System.err.println("output port ID :"+ outputID.getInt());
    mm.putPortID(outport.getPortID());

    inport = new InputPort("WFFileDescriptor");
    System.err.println("got inport");
    ID inputID = inport.getPortID();
    System.err.println("input port ID :"+ inputID.getInt());
    mm.putPortID(inport.getPortID());

    newmessage=null;
    return(mm);
    }
  
  public void run() {
    
    System.err.println("Unzip: wait till you know the ip address of the display");
    
    while(newmessage==null) {;}
    System.out.println("set display to: "+newmessage);
    disp=newmessage.substring(4);
    System.err.println("Unzip: disp="+disp);

    while(true)
      {
        outFile = new WFFileDescriptor();  
        inFile = (WFFileDescriptor)inport.receive();
        FileName = inFile.getFileDirectory()+inFile.getFileName(); 
        if(thisSystem.equals("UNIX")) {
           command = "gunzip "+FileName;
        }
        else if(thisSystem.equals("NT")) {
           ShortName = inFile.getFileName().substring(0,4);
           System.err.println("shortname="+ShortName+" "+FileName);
           command = "cmd /C "+"copy "+FileName+" "+inFile.getFileDirectory()+ShortName+".gz";
           System.err.println("command="+command);
           try {
              Process p=Runtime.getRuntime().exec(command);
              p.waitFor();
	     }
           catch (Exception e) {System.out.println("Unzip Error: "+e.toString());}

           command = "cmd /C c:\\Gzip\\gunzip "+inFile.getFileDirectory()+ShortName+".gz"; 
        }
        else {
           System.err.println("UNZIP - unknown system!");
        }
        
        System.err.println("command="+command);
        try {
              Process p=Runtime.getRuntime().exec(command);
              p.waitFor();
	}
        catch (Exception e) {System.out.println("Unzip Error: "+e.toString());}  

        unzippedFileName=inFile.getFileName();
        System.out.println("Unzip: "+unzippedFileName); 
        int idx=unzippedFileName.indexOf(".");
        unzippedFileName=unzippedFileName.substring(0,idx);
 

        if(thisSystem.equals("NT")) {
        command = "cmd /C "+"rename "+inFile.getFileDirectory()+ShortName+" "+unzippedFileName;
        System.err.println("command="+command);
           try {
              Process p=Runtime.getRuntime().exec(command);
              p.waitFor();
	     }
           catch (Exception e) {System.out.println("Unzip Error: "+e.toString());}

        }


        if(outport.isConnected()) {
           outFile.setFileName(unzippedFileName);
           outFile.setFileDirectory(inFile.getFileDirectory());
           outFile.setFileHost(inFile.getFileHost());
           outFile.setFileAttribute(inFile.getFileAttribute());
       	   outport.send(outFile);
	}
      }
  }
  
    
    public void destroy() {

    outport.destroyPort();
    inport.destroyPort();
    }
    
    public void stop() {}
    
  public void update_value(String s) {
  System.out.println("Unzip: new message: "+s);
  newmessage = s;
  }  
   

}	
    
    
    
