package webflow.modules.LMS;

import webflow.backend.*;
import java.net.*;
import java.io.*;
import webflow.modules.Templates.*;
import webflow.modules.QuantumSimulations.WFFileDescriptor;

public class WMS extends Template {
  
  InputPort inport;
  OutputPort outport;
  String message,newmessage;
  String command,editor;
  String disp;
  WFFileDescriptor inFile,outFile;
  String FileName;
  int WMSstarted;
  String WMSscript;
  String thisSystem="NT";
  
  public MetaModule initialize() {
    
    CreateServerSocket();
    MetaModule mm = new MetaModule("mm");

    outport = new OutputPort("WFFileDescriptor");
    System.err.println("got outport");
    ID outputID = outport.getPortID();
    System.err.println("output port ID :"+ outputID.getInt());
    mm.putPortID(outport.getPortID());
   

    inport = new InputPort("WFFileDescriptor");
    System.err.println("got inport");
    ID inputID = inport.getPortID();
    System.err.println("input port ID :"+ inputID.getInt());
    mm.putPortID(inport.getPortID());

    newmessage=null;
    return(mm);
    }
  
  public void run() {
    
    //wait till you know the ip address of the display
    WMSstarted = 0;
    while(newmessage==null) {;}
    System.out.println("set display to: "+newmessage);
    disp=newmessage.substring(4);

     
    if(thisSystem.equals("UNIX")) {
 
    //generate a perl script to run wms (with $DISPLAY set)

    command = "/home/B7D/globus/apache/htdocs/0.0.5/webflow/modules/LMS/genWMSscript.pl "+disp;

    //execute this script to generate script /tmp/wmsScript.pl

        try {
              Process p=Runtime.getRuntime().exec(command);
              p.waitFor();
	}
        catch (Exception e) {System.out.println("WMS Error: "+e.toString());}
        System.err.println("-->genWMSscript.pl executed");
        command = "/tmp/wmsScript.pl";
   }
   else if(thisSystem.equals("NT")){
       command = "cmd /C C:\\WMS\\wms";
   } 
   else {
       System.err.println("WMS: Oops! unknown system");
   }
 
    while(true)
      {
        System.err.println("WMS: wait for input");
        System.err.println("WMS command: "+command);
        if(inport.isConnected()){
        inFile = (WFFileDescriptor)inport.receive();
        }
        else {
        System.err.println("WMS: no input port");
        } 
        /* do not wait for WMS to complete; send dummy output now
        if(outport.isConnected()){
           System.err.println("WMS: send output"); 
	     outport.send(new WFFileDescriptor());
           System.err.println("WMS: sent!"); 
        }
        */  
        if(WMSstarted == 0) {
        try {
              Process p=Runtime.getRuntime().exec(command);
              //p.waitFor();
	}
        catch (Exception e) {System.out.println("WMS Error: "+e.toString());}
     System.err.println("WMS started");
        WMSstarted=1;
	}
      
      }
  }
  
    
    public void destroy() {

    outport.destroyPort();
    inport.destroyPort();
    }
    
    public void stop() {}
    
  public void update_value(String s) {
  System.err.println("WMS: new message: "+s);
  newmessage = s;
  }  
   

}	
    
    
    
