package webflow.modules.QuantumSimulations;


// $Id: SaveAs.java,v 1.2 1998/04/19 06:48:52 haupt Exp haupt $

import java.util.*;
import java.lang.*;
import webflow.backend.*;
import java.net.*;
import java.io.*;
import webflow.modules.Templates.*;

public class SaveAs extends Template {
  InputPort inport;
  
  OutputPort outport;
  String targetFileName="C:\\Tomasz\\temp.txt";
  boolean flag,dirflag;
  WFFileDescriptor outFile;// = new WFFileDescriptor();
  int idx;

  public MetaModule initialize() {
    
    System.err.println("Initialize SaveAs");
    CreateServerSocket();
    System.err.println("Socket done SaveAs");
    MetaModule mm = new MetaModule("mm");
    //    outport = new OutputPort("WFFileDescriptor");
    //    mm.putPortID(outport.getPortID());
    inport = new InputPort("String");
    mm.putPortID(inport.getPortID());
    System.err.println("about to end init SaveAs");
    return(mm);
    }
  
  public synchronized void run() {
    
    targetFileName="whatever";
    flag=false;
    dirflag=false;

    while(true) {
	while(!flag) {
          try {
             wait(1000);
          } catch (InterruptedException e){;}
	}  
      /* receive outFile object from input port */
      System.err.println("SAVEAS: waiting for input port data");
      outFile = (WFFileDescriptor)inport.receive();
      System.err.println("SAVEAS: received!");
    
      /* new complete filename for this file received from applet and stored
	 into targetFileName */
      String sourceFileName = outFile.getFileDirectory()+outFile.getFileName();
      /* read file from source */
      String content = readFile(sourceFileName);
      /* write to destination */
      writeFile(targetFileName,content);
    }
  }
  
  
    
    public void destroy() {

    outport.destroyPort();
    socket.stop();
    }
    
    public void stop() {}

    public void update_value(String s) 
    {
      
      String[] directory_contents=null;
      System.out.println("SaveAs:update_value is CALLED with "+s);
      
      if(s.equals("_make_connection")) {
       System.err.println("SaveAs:CONTROLS1 CONNECTED !!!");
      }
       else if (s.startsWith("SWING_REQ")){
	   System.err.println("I received DIR NAME:"+s);
	   
	   //received directory name for file browser
	   String dir = s.substring("SWING_REQ".length());
	   try{
	     directory_contents = list(dir,"");
	   }catch(InterruptedException e){
	   }
	   send_directory_contents(directory_contents);
	   dirflag = true;
	 }  
	 else if (s.startsWith("SWING_REPLY")){
	   targetFileName=s.substring("SWING_REPLY".length()); 
	   System.out.println("SaveAs:new message arrived: new File NAME"+targetFileName);
	   flag=true;
	 }
      
    }
    
public void send_directory_contents(String []list)
  {
    
    socket.send(list[0]);
    int nfiles = list.length-1;
    socket.send(Integer.toString(nfiles));
    
    for(int i=1;i<list.length;i++){
//      System.err.println("sent SaveAs ="+list[i]);
      socket.send(list[i]);
    }
  }
  

public   String [] list(String dir,String opts)

         throws InterruptedException

  {

    String separator = File.separator;

    boolean isExist=false,isRead=false;

    Vector lines = new Vector();



    //insert first requested directory name

    lines.addElement(dir);



    //check that this directory exists first

    File file = new File(dir);

    try{

      if (file.exists())

	isExist = true;

      isRead = true;

    }catch(SecurityException e){

      System.out.println("Security Exception "+e);

    }

    

    if (!isRead){

      System.out.println(dir+" is not readable");

      lines.addElement("total xx");   

      lines.addElement("NotReadable");

    }

    else if (!isExist){

      System.out.println(dir+" Not Found");

      lines.addElement("total xx");

      lines.addElement("NotFound");

    }

    if ((!isRead)||(!isExist)){

      System.out.println("file "+dir+" not found or not readable");

      String[] retval = new String[lines.size()];

      lines.copyInto(retval);

      return retval;

    }



    try{

      

      String line;

      String  cmd=null,pwd=null;

      Process child;

      DataInputStream in;



      //start up the command

	if (separator.equals("/")) //UNIX

        cmd = "ls -al "+dir;

      else if (separator.equals("\\")) //WIN/NT

	  cmd = "cmd.exe /C "+" DIR "+dir;   //running dir on top of WIN/NT

        //cmd = "command.com /C "+" DIR "+dir; //running dir on top of DOS

        

	

      child = Runtime.getRuntime().exec(cmd);

	System.out.println("Before DIS ");

      in = new DataInputStream(child.getInputStream());

      

      //read the command's output

      while((line = in.readLine()) != null){

 	    lines.addElement(line);

          System.out.println("line: "+line);

      }



	//User gave wrong directory name

	if (lines.size() == 0){

         System.out.println(dir+" Not Found");

         lines.addElement("total xx");

         lines.addElement("Filename ,directory name or volume label syntax is incorrect");

         String[] retval = new String[lines.size()];

         lines.copyInto(retval);

         return retval; 

      }



	// If you want to see detail , give this command "cmd /C dir " or "command /C dir"

      //Delete first three lines of output from dir command

      //Volume in drive ..; volume serial; blank line and fifth line  which is blank

	//and last three lines

      if (separator.equals("\\")){    //WIN/NT 	

	   System.out.println("Delete these (first): "+lines.elementAt(1)+"-*- "+

	                                       lines.elementAt(2)+"-*- "+

 						         lines.elementAt(3)+"-*-"+

	  						   lines.elementAt(5)+"-*-");	

	   lines.removeElementAt(1);

         lines.removeElementAt(1);

	   lines.removeElementAt(1);

         lines.removeElementAt(2);

	   int l = lines.size()-1;

	   System.out.println("Delete these (last): "+lines.elementAt(l)+"-*- "+

	                                       lines.elementAt(l-1)+"-*-");

 						         

         lines.removeElementAt(l);

         lines.removeElementAt(l-1);

	}



      String[] retval = new String[lines.size()];

      lines.copyInto(retval);

      return retval;

    } catch (Exception e){

      throw new InterruptedException (e.toString());

    }

  }



  /** Reading file with name "fileName" **/
  String readFile(String fileName)
   {
     System.out.println("I am reading the file:"+fileName);
 
     File file = new File(fileName);
     char[] data = null;
     try{
       FileReader in = new  FileReader(file);
       //read file char by char
       int size = (int)file.length();
       data = new char[size];
       int chars_read = 0;
       while(chars_read < size)
         chars_read += in.read(data,chars_read,size-chars_read);
     }catch(IOException e){
       System.out.println("There is IOException during reading file:"+e);
     }
 
      return new String(data);
   }

 /** write data from "fileContent" into file with name "fileName" */
 public void  writeFile(String fileName,String fileContent)
   {
     System.out.println("I am writing the file:"+fileName+
                        " content:"+fileContent);
 
     try{
       FileOutputStream fw = new FileOutputStream(fileName);
       DataOutputStream dos = new DataOutputStream(fw);
       //write fileContent to file at once
       dos.writeBytes(fileContent);
     }catch(IOException e){
       System.out.println("There is IOException during writing file:"+e);
     }
   }

}	
    
    
    


   
