
import java.util.* ;
import java.io.* ;
import java.awt.* ;
import java.awt.event.* ;
import javax.swing.* ;
import javax.swing.event.* ;

class StudentPanel extends JPanel implements ListSelectionListener,
                                             ActionListener,
                                             DocumentListener {

    public StudentPanel(DefaultListModel keys, HashMap names) {

        this.keys  = keys ;
        this.names = names ;

        list = new JList(keys) ;
        list.setSelectionMode(ListSelectionModel.SINGLE_SELECTION) ;

        list.addListSelectionListener(this) ;

        JScrollPane scrollPane = new JScrollPane(list) ;
        add(scrollPane) ;

        field = new JTextField(20) ;
        field.setEditable(false) ;
        field.getDocument().addDocumentListener(this) ;
        add(field) ;

        deleteButton = new JButton("delete") ;
        deleteButton.addActionListener(this) ;
        add(deleteButton) ;

        addButton = new JButton("add") ;
        addButton.addActionListener(this) ;
        add(addButton) ;
    }

    public void valueChanged(ListSelectionEvent evt) {
        if(list.isSelectionEmpty()) {
            if(field.isEditable()) {
                field.setText("") ;

                field.setEditable(false) ;
            }
        } else {
            if(!field.isEditable())
                field.setEditable(true) ;

            String key = (String) list.getSelectedValue() ;

            String name = (String) names.get(key) ;

            field.setText(name) ;
        }
    }

    public void actionPerformed(ActionEvent evt) {
        if(evt.getSource() == deleteButton) {
           int index = list.getSelectedIndex() ;
           if(index >= 0) {
               String key = (String) keys.remove(index) ; 
               names.remove(key) ;

               // Feel the following ought to be handled by reactive
               // `valueChanged' invocation, but apparently it isn't...

               field.setText("") ;

               if(field.isEditable())
                   field.setEditable(false) ;
           } else {
               Toolkit.getDefaultToolkit().beep() ;
           }
        }
        if(evt.getSource() == addButton) {
            String uid ;
            do
                uid = JOptionPane.showInputDialog(this,
                              "Input user ID",
                              "New Student", 
                              JOptionPane.QUESTION_MESSAGE) ;
            while(uid != null && uid.equals("")) ;  
                                     // Reprompt if empty string inputted.

            if(uid != null) {        // If input not cancelled.
                if(keys.contains(uid)) 
                    JOptionPane.showMessageDialog(this,
                              "Student " + uid + " already known!", 
                              "New Student",
                              JOptionPane.INFORMATION_MESSAGE) ;
                else {
                    keys.addElement(uid) ;
                    names.put(uid, "") ;
                }

                list.setSelectedValue(uid, true) ;
            }
        }
    }

    public void changedUpdate(DocumentEvent evt) {
        String key = (String) list.getSelectedValue() ;
        if(key != null) {
            names.put(key, field.getText()) ;
        }
    }

    public void insertUpdate(DocumentEvent evt) {
        changedUpdate(evt) ;
    }

    public void removeUpdate(DocumentEvent evt) {
        changedUpdate(evt) ;
    }

    private JButton deleteButton ;
    private JButton addButton ;

    private DefaultListModel keys ;
    private HashMap names ;

    private JList list ;
    private JTextField field ;
}

public class StudentListApplet extends JApplet {

    static DefaultListModel keys = new DefaultListModel() ;
    static HashMap names = new HashMap() ;

    public void init() {

        //JFrame frame = new JFrame() ;

        //setTitle("Student List") ;
        //frame.setSize(450, 300) ;

        getContentPane().add(new StudentPanel(keys, names)) ;

        //frame.setVisible(true) ;
    }

}

//public class StudentList implements WindowListener {
//
//    static DefaultListModel keys = new DefaultListModel() ;
//    static HashMap names = new HashMap() ;
//
//    public static void main(String [] args) {
//
//	try {
//	    BufferedReader in = new BufferedReader(new FileReader("students")) ;
//
//            while(true) {
//                String uid = in.readLine() ;
//                if(uid == null) break ;              // Normal end of file.
//
//                uid = uid.trim() ;     // trim off whitespace before using as key
//                keys.addElement(uid) ;
//
//                String name = in.readLine() ;
//                if(name == null) throw new IOException("Premature end of file") ;
//
//                names.put(uid, name) ;
//            }
//        } catch (FileNotFoundException e) {
//            ;  // OK.  Treated as an empty file.
// 	} catch (IOException e) {
//            System.out.println("Error loading students file: " + e.getMessage()) ;
//            System.exit(1) ;
//	}
//
//        JFrame frame = new JFrame() ;
//
//        frame.setTitle("Student List") ;
//        frame.setSize(450, 300) ;
//
//        frame.addWindowListener(new StudentList()) ;
//
//        frame.getContentPane().add(new StudentPanel(keys, names)) ;
//
//        frame.setVisible(true) ;
//    }
//
//    public void windowActivated(WindowEvent evt) {}
//    public void windowClosed(WindowEvent evt) {}
//    public void windowClosing(WindowEvent evt) {
//         
//
//	try {
//	    PrintWriter out = new PrintWriter(new FileWriter("students")) ;
//
//            for(int i = 0 ; i < keys.size() ; i++) {
//                String uid = (String) keys.getElementAt(i) ;
//
//                out.println(uid) ;
//
//                out.println((String) names.get(uid)) ;
//            }
//
//            out.close() ;
// 	} catch (IOException e) {
//            System.out.println("Error writing students file: " + e.getMessage()) ;
//            System.exit(1) ;
//	}
//
//        System.exit(0) ;
//    }
//    public void windowDeactivated(WindowEvent evt) {}
//    public void windowDeiconified(WindowEvent evt) {}
//    public void windowIconified(WindowEvent evt) {}
//    public void windowOpened(WindowEvent evt) {}
//}

