import javax.naming.*;
import java.util.Properties;
import java.io.*;
import org.gxos.debug.Log;
import org.gxos.*;

/**
 * Example for creating a root context.
 * @author Ozgur Balsoy
 * @version 1.0
 */

public class CreateRoot {

  public CreateRoot(String url, Properties env) {

	try {
            // This example creates a GXOS root under a given name or URL.
            // First the root context is created, and then other sub contexts
            // are added i.e. Admin, Devices, Documents, Users, etc.

	    ContextManager.initialize(env);
            RootContext ctx = ContextManager.createRootContext(url);

	} catch (Exception e) {
	    e.printStackTrace();
	}
    }

  public static void main(String[] args) {

    String url = "";
    boolean msg = false;
    try {
        if(args.length<1)
            msg = true;
        else {
            for(int i=0; i<args.length; i++) {
                if(args[i].equals("-d"))
                    Log.debug(true);
                else
                    url = args[i];
            }
        }
    } catch(java.lang.ArrayIndexOutOfBoundsException e) {
        msg = true;
    }
    if (msg) {
	    System.err.println("usage: java -Dgxos.config=filepath CreateRoot [-d] <gxos_url>\n-d for debug.");
            System.err.println("\nExamples:\nCreateRoot //Education\nCreateRoot University");
	    System.exit(-1);
    }

    try {
        String configFile = (String)System.getProperties().get(Defaults.GXOS_CONFIG);
        Properties env;
        if(configFile == null)
            throw new Exception("Config file needs to be given. Run this without parameters.");
        else {
            env = new Properties();
            env.load(new FileInputStream(new File(configFile)));
        }
        CreateRoot cr = new CreateRoot(url, env);
    } catch(Exception e) {
        e.printStackTrace();
    }
  }
}