import javax.naming.*;
import java.util.Properties;
import java.io.*;
import org.gxos.debug.Log;
import org.gxos.*;

/**
 * Example for creating a root context.
 * @author Ozgur Balsoy
 * @version 1.0
 */

public class CreateUser {

  public CreateUser(String url, String fullname, String login,
                String password, String email, Properties env) {

	try {
            // This examples adds users to the Users repository under the given
            // root. This repository should be created by
            // ContextManager.createRoot(rootName) method. See CreateRoot example
            // for this.

            ContextManager.initialize(env);
            RootContext root = ContextManager.getRootContext(url);
            root.createUser(fullname, ""/*pre*/, ""/*suf*/, login, password, email);

	} catch (Exception e) {
	    e.printStackTrace();
	}
    }

  public static void main(String[] args) {

    String url = "";
    String fullname = "";
    String login = "";
    String password = "";
    String email = "";
    boolean msg = false;
    int i = 0;

    try {
        if(args.length<4)
            msg = true;
        else {
            url = args[i++];
            if(url.equals("-d")) {
                Log.debug(true);
                url = args[i++];
            }
            fullname = args[i++];
            login = args[i++];
            password = args[i++];
            email = args[i++];
        }
    } catch(java.lang.ArrayIndexOutOfBoundsException e) {
        msg = true;
    }

    if (msg) {
        System.err.println("usage: java [-Dgxos.config=filepath] CreateUser [-d] <gxos_root> <full_name> <login> <password> <email>");
        System.err.println("\n-d for debug.");
        System.err.println("\nExamples:\nCreateUser //Education \"John Doe\" jdoe mypasswd email");
	System.exit(-1);
    }

    try {
        String configFile = (String)System.getProperties().get(Defaults.GXOS_CONFIG);
        Properties env = Defaults.getConfiguration(configFile);

        CreateUser cr = new CreateUser(url, fullname, login, password, email, env);
    } catch(Exception e) {
        e.printStackTrace();
    }

  }
}