import VTKModel;
import vtk.*;
import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import java.io.FileInputStream;
import java.net.URL;


public class App2 { //extends Applet {
    VTKModel md;
    String mdname = null;
    String message = null;
    vtkPolyDataReader pr = null;
    vtkWarpVector warp = null;
    vtkGeometryFilter ds2poly = null;
    vtkCleanPolyData clean = null;
    vtkPolyDataNormals normals = null;
    vtkVectorDot color = null;
    vtkDataSetMapper plateMapper = null;
    vtkPanel panel = null;
    vtkActor a = null;
  vtkCamera cam = null;

  /*
    public static void main(String args[]) {
      Frame tempframe = new Frame("VTK Java Demo");     
	  App2 applet = new  App2();
      tempframe.addWindowListener(new WindowAdapter() {
                public void windowClosing(WindowEvent e) {
                        System.exit(0);
                }
      });
      tempframe.add(applet,BorderLayout.CENTER);
      tempframe.setSize(420,500);
      applet.init();
      applet.start();
      tempframe.setVisible(true);
    }
    */

    public void testme ()
      {
      //System.out.println("Starting Render");
      }

  public App2() //void init()
      {
        //GridBagLayout grid = new GridBagLayout();
      
        //this.setLayout(grid);

      panel = new vtkPanel();
      panel.resize(400,400);
      //constrain(this,panel,0,0,8,8);

      FileInputStream is = null;
      try 
	{
	
	mdname = "plate.vtk";
	is = new FileInputStream(mdname);
	md = new VTKModel(is);

	// create the model
	pr = new vtkPolyDataReader();
	pr.ReadFromInputStringOn();
	pr.SetInputString(md.GetData());
	
        //pr.SetFileName("plate.vtk");


	//pr.SetVectorsName("mode1");
        pr.SetVectorsName("mode4");
	warp = new vtkWarpVector();
	warp.SetInput(pr.GetOutput());
	warp.SetScaleFactor(0.5);
	ds2poly = new vtkGeometryFilter();
	ds2poly.SetInput(warp.GetOutput());
	clean = new vtkCleanPolyData();
	clean.SetInput(ds2poly.GetOutput());
	normals = new vtkPolyDataNormals();
	normals.SetInput(clean.GetOutput());
	color = new vtkVectorDot();
	color.SetInput(normals.GetOutput());
	plateMapper = new vtkDataSetMapper();
	//plateMapper.ScalarVisibilityOff();
        plateMapper.ScalarVisibilityOn();
	plateMapper.SetInput(color.GetOutput());
	plateMapper.SetScalarRange(-1,1);
	a = new vtkActor();
	a.SetMapper(plateMapper);

	panel.getRenderer().AddActor(a);
	panel.getRenderer().SetStartRenderMethod(this,"testme");
        cam =  panel.getCamera();

        vtkRotate(100.0, 50.0);
        vtkScale(-10.0);
	}
      catch(Exception e) 
	{
	e.printStackTrace();
	md = null;
	message = e.toString();
	}
      try 
	{
	if (is != null) is.close();
	} 
      catch(Exception e) 
	{
	}

      //layout();
      //this.setBackground(new Color(120, 140, 160));
      //show();
      }

  /*
    public void constrain(Container cont, Component comp,
                          int grid_x, int grid_y, 
                          int grid_width, int grid_height)
      {
      GridBagConstraints c = new GridBagConstraints();
      c.gridx = grid_x;
      c.gridy = grid_y;
      c.gridwidth = grid_width;
      c.gridheight = grid_height;        panel.Render();

      c.anchor = GridBagConstraints.NORTH;

      ((GridBagLayout)cont.getLayout()).setConstraints(comp,c);
      cont.add(comp);
      }
      */

  public void vtkRotate(double azimuth, double elevation) {
    cam = panel.getRenderer().GetActiveCamera();
    panel.getRenderWindow().SetDesiredUpdateRate(5.0);
    cam.Azimuth(azimuth); //100.0
    cam.Elevation(elevation); //50.0
    cam.OrthogonalizeViewUp();
    panel.getRenderer().ResetCameraClippingRange();
    panel.getLight().SetPosition(cam.GetPosition());
    panel.getLight().SetFocalPoint(cam.GetFocalPoint());
  }

  public void vtkScale(double scalefactor) {
    double zoomFactor;
    double clippingRange[];

    zoomFactor = Math.pow(1.02,scalefactor);
    System.out.println("Zoom Factor: "+zoomFactor);
    cam = panel.getRenderer().GetActiveCamera();
    
    if (cam.GetParallelProjection() == 1)
    {
      cam.SetParallelScale(cam.GetParallelScale()/zoomFactor);
    }
    else
    {
      cam.Dolly(zoomFactor);
      panel.getRenderer().ResetCameraClippingRange();
    }
  }



  public void getCaptureImg(String filename) {
 
    //pr.Update();
    //panel.Render();
    panel.getRenderWindow().Render();

    vtkRendererSource vtkrs = new vtkRendererSource();
    vtkrs.SetInput(panel.getRenderer());
    vtkrs.WholeWindowOn();

    vtkPostScriptWriter vtkps = new vtkPostScriptWriter();
    vtkps.SetInput(vtkrs.GetOutput());
    vtkps.SetFileName(filename);
    vtkps.Write();

  }


}
