import com.sun.image.codec.jpeg.*;
...

public boolean saveJPEG(Image saveImage, String saveName, float quality) {
	BufferedImage buffImage;
	FileOutputStream foStream;
	int width = saveImage.getWidth(null);
	int height = saveImage.getHeight(null);
	
	buffImage = new BufferedImage(width,height,BufferedImage.TYPE_INT_BGR);
	Graphics g = buffImage.getGraphics();
	
	try {
		g.drawImage(saveImage,0,0,null);
	} catch (NullPointerException e) {
		e.printStackTrace();
		return false;
	}
	try {
		foStream = new FileOutputStream(saveName);
	} catch (FileNotFoundException e) {
		e.printStackTrace();
		return false;
	} catch (SecurityException e) {
		e.printStackTrace();
		return false;
	}
	JPEGEncodeParam param =	 JPEGCodec.getDefaultJPEGEncodeParam(buffImage);
	param.setQuality(quality,false);
	
	JPEGImageEncoder encoder = JPEGCodec.createJPEGEncoder(foStream,param);
	
	try {
		encoder.encode(buffImage);
		foStream.close();
	} catch(IOException e) {
		e.printStackTrace();
		return false;
	} catch(ImageFormatException e) {
		e.printStackTrace();
		return false;
	}
	System.out.println("Saved "+ saveName);
	return true;
}

