import javax.servlet.*;
import javax.servlet.http.*;
import java.io.*;
import java.util.*;

import java.awt.image.*;
import java.awt.*;

public class ClockServlet extends HttpServlet {
  private double hourToRadian(int h, int m) {
    return Math.PI * (90.0 - ((h % 12) + m/60.0)*30.0)/180.0;
  }

  private double minuteToRadian(int m, int s) {
    return Math.PI * (90.0 - (m + s/60.0)*6.0)/180.0;
  }

  public void doGet(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
    ServletOutputStream out = response.getOutputStream();

    BufferedImage image = new BufferedImage(200, 200, BufferedImage.TYPE_INT_RGB);
    Graphics g = image.getGraphics();

    g.setColor(Color.white);
    g.fillRect(0, 0, 200, 200);

    GregorianCalendar calendar = new GregorianCalendar();
    int cHour   = calendar.get(Calendar.HOUR);
    int cMinute = calendar.get(Calendar.MINUTE);
    int cSecond = calendar.get(Calendar.SECOND);

    g.setColor(Color.black);
    g.drawArc(0, 0, 199, 199, 0, 360);
    g.drawLine(
      100,
      100,
      100+(int)(Math.cos(hourToRadian(cHour, cMinute))*40),
      100-(int)(Math.sin(hourToRadian(cHour, cMinute))*40));
    g.drawLine(
      100,
      100,
      100+(int)(Math.cos(minuteToRadian(cMinute, cSecond))*70),
      100-(int)(Math.sin(minuteToRadian(cMinute, cSecond))*70));
    g.drawLine(
      100,
      100,
      100+(int)(Math.cos(minuteToRadian(cSecond, 0))*90),
      100-(int)(Math.sin(minuteToRadian(cSecond, 0))*90));

    response.setContentType("image/jpeg");
    com.sun.image.codec.jpeg.JPEGCodec.createJPEGEncoder(out).encode(image);

    out.close();
    g.dispose();
  }
