# A simple perl script modified vtk files for std::ostream usage
# (i.e., preparation for ANSI C++).
# Run the file in a directory against */h *.cxx
#
# Changes "ostream" to "vtkOstream" and "endl" to "vtkEndl". These
# are typedef'd and defined in vtkOstream.h.
#

# The input record separator is defined by Perl global 
# variable $/.  It can be anything, including multiple 
# characters.  Normally it is "\n", newline.  Here, we
# say there is no record separator, so the whole file
# is read as one long record, newlines included.    
undef $/;

# Process each file, making necessary substitutions
    foreach $file (@ARGV) {
        if (! open(INPUT,"<$file") ) {
            print STDERR "Can't open input file $bakfile\n";
            next;
        }
        # Read input file as one long record.        
        $data=<INPUT>;
        close INPUT;

        $data =~ s$:pserver:anonymous\@www.visualizationtoolkit.org:/vtk/cvsroot$:pserver:will\@www.visualizationtoolkit.org:/vtk/cvsroot$g;
        if (! open(OUTPUT,">$file") ) {
            die "Can't open output file $file\n";            
        }
        print OUTPUT $data;            
        close OUTPUT;

    }
    exit(0); 

