/**
 * Program: SVGText.java
 * Writes text onto a screen.
 */

import java.awt.*;
import java.awt.geom.*;
import java.util.*;
import java.awt.event.*;
import java.io.*;
import houseblend.*;
//import org.apache.batik.dom;

//import org.apache.batik.apps.svgviewer.Application;
//import org.apache.batik.apps.svgviewer.ViewerFrame;
import org.apache.batik.dom.svg.SVGDocumentFactory;
import org.xml.sax.InputSource;
import org.apache.batik.util.awt.svg.SVGGraphics2D;
import org.apache.batik.dom.svg.SVGOMDocument;
import org.w3c.dom.*;
import org.apache.batik.util.SVGConstants;

public class SVGWBText extends WhiteBoardComp {    
    protected Main main;
    protected ViewerFrame vf;
    protected GraphicsManager gm;
    protected SVGOMDocument textdoc,newfrag;
    protected DocumentFragment frag;
    
    protected int xpart=1,ypart=1;
    protected String textToWrite=null;
    protected HersheyFont mathlow;
    protected Font f;
    static int yposition;

    public SVGWBText(Main main){
	super();
	this.main=main;
	vf=main.getViewerFrame();
	mathlow=new HersheyFont("HersheyFont/mathupp.jhf");
	f=main.getFont(); //new Font("SansSerif",Font.PLAIN,18);
  	setYPosition(10);
    }

    public WhiteBoardComp getShape(){
	return this; 
    }
    
    public void test() {
	System.out.println("SVGWBText is available");
    }
    
    /**
     * Loads the text captured from the screen.
     */
    public void loadDataFile(String screenText) {
	textToWrite=screenText;
    }

    public void drawShape(SVGGraphics2D g2d,int i,int j) {
 	int xposition=i;  //,yposition=0;
	setYPosition(j);
  	int iword,istep,istart,ifinish,wordsize;
	int height=0,width;
	int ystart=15;

	StringBuffer theBuffer=new StringBuffer(textToWrite);
	if(theBuffer.charAt(theBuffer.length()-1)!=' ')
	    theBuffer.append(' ');
	istart=0;
	istep=0;
	ifinish=0;
	
	while(ifinish<theBuffer.length()-1) {
	    istep=0;
	    while(theBuffer.charAt(istart+istep)!=' ') {
		istep++;
	    }
	    istep++;  //Get past blank character.
	    if(istart+istep<theBuffer.length()) {
		ifinish=istart+istep;
	    }
	    else {
		ifinish=istart+istep-1;
	    }
	    
	    String word=theBuffer.substring(istart,ifinish);

	    //This whole crappy if-else block should be improved.
	    //Integral symbol is "p" in the mathupp font.
	    if(word.trim().equals("<int>")) {
		height=18;  //A hack that will work only with the test font.
		String line="  p  ";
		g2d.setColor(Color.black);
		mathlow.setHeight(.4f);
		mathlow.setWidth(.5f);
		mathlow.setVerticalAlignment(HersheyFont.VERTICAL_TOP);
		mathlow.setHorizontalAlignment(HersheyFont.HORIZONTAL_CENTER);
		mathlow.drawString(line,xposition+3,getYPosition()-5,(Graphics)g2d);
		wordsize=10;
	    }
	    //Sqrt symbol is "b" in the mathupp font.
	    else if(word.trim().equals("<sqr>")){
		height=18; //A hack using the normal word size for this font.
		String line="  b  ";
		g2d.setColor(Color.black);
		mathlow.setHeight(.4f);
		mathlow.setWidth(.5f);
		mathlow.setVerticalAlignment(HersheyFont.VERTICAL_TOP);
		mathlow.setHorizontalAlignment(HersheyFont.HORIZONTAL_CENTER);
//  		mathlow.drawString(line,xposition+3,height*yposition+10,(Graphics)g2d);
  		mathlow.drawString(line,xposition+3,getYPosition()-5,(Graphics)g2d);
		wordsize=10;
		
	    }
	    //Partial symbol is "m" in the mathupp font.
	    else if(word.trim().equals("<par>")){
		height=18; //A hack using the normal word size for this font.
		String line="  m  ";
		g2d.setColor(Color.black);
		mathlow.setHeight(.4f);
		mathlow.setWidth(.5f);
		mathlow.setVerticalAlignment(HersheyFont.VERTICAL_TOP);
		mathlow.setHorizontalAlignment(HersheyFont.HORIZONTAL_CENTER);
//  		mathlow.drawString(line,xposition+3,height*yposition+10,(Graphics)g2d);
  		mathlow.drawString(line,xposition+3,getYPosition()-5,(Graphics)g2d);
		wordsize=10;
		
	    }
	    //Delta symbol is "n" in the mathupp font.
	    else if(word.trim().equals("<del>")){
		height=18; //A hack using the normal word size for this font.
		String line="  n  ";
		g2d.setColor(Color.black);
		mathlow.setHeight(.4f);
		mathlow.setWidth(.5f);
		mathlow.setVerticalAlignment(HersheyFont.VERTICAL_TOP);
		mathlow.setHorizontalAlignment(HersheyFont.HORIZONTAL_CENTER);
//  		mathlow.drawString(line,xposition+3,height*yposition+10,(Graphics)g2d);
  		mathlow.drawString(line,xposition+3,getYPosition()-5,(Graphics)g2d);
		wordsize=10;
		
	    }
	    else {
		g2d.setFont(f);
		g2d.setColor(new Color(0,0,0));
		FontMetrics fm=g2d.getFontMetrics(f);
		Rectangle2D rect=fm.getStringBounds(word,g2d);
		width=(int)rect.getWidth();
		height=(int)rect.getHeight()+1;
		g2d.drawString(word,xposition,ystart+getYPosition());
		wordsize=width;
	    }

	    istart=ifinish;
	    xposition+=wordsize;
	    //Should get dimensions from the frame size.
	    if(xposition>main.getSize().getWidth()) {
		xposition=0;
		setYPosition(getYPosition()+height);
	    }
	}
	setYPosition(getYPosition()+height);
	System.out.println("Line position:"+getYPosition());
	writeSVG(g2d);
    }
    
    /**
     * Move the SVG document to memory and then fill out the 
     * local SVGOMDocument.
     */
    public void writeSVG(SVGGraphics2D g2d){
	textdoc=writeSVGDocToMemory(g2d);
	//SVGOMDocument textdoc1=updateBaseDoc(textdoc,vf.getTheDoc());
	//  	vf.appendFragToDoc(vf.textcanvas,textdoc1);
	SVGOMDocument textdoc1=updateBaseDoc(textdoc,vf.getTheDoc());
  	vf.appendFragToDoc(vf.thecanvas,textdoc1);
    }
    
    /**
     * This method initializes various objects.
     */
    public void init(){
	//gm=main.getGraphicsManager();
    }

    public int getXPart() { return xpart; }
    public int getYPart() { return ypart; } 

}

