/**
 * This class loads an existing SVG image and displays it.
 */ 

import org.apache.batik.dom.svg.*;
import org.apache.batik.util.*;
import org.apache.batik.util.awt.svg.SVGGraphics2D;
import org.xml.sax.*;
import java.io.*;

public class SVGImage extends WhiteBoardComp {
    protected Main main;
    protected ViewerFrame vf;
    protected SVGGraphics2D g2d;
    protected SVGDocumentFactory df;
    protected SVGOMDocument imagedoc;

    public SVGImage(Main main) {
	super();
	this.main=main;
    }

    public void init() {
	vf=main.getViewerFrame();
	
	df=new SVGDocumentFactory(main.getXMLParserClassName());
    }

    public WhiteBoardComp getShape() {
	return this;
    }

    public void loadDataFile(String filename) {
	System.out.println("Loading SVG image from "+filename+"...");

	//Treat the file as a URL
	String docURI="file:"+filename;
	Thread t=DocumentLoadRunnable.createLoaderThread(docURI,vf,df);
	t.start();
    }

    /**
     * Because we are loading in an already created SVG document, this
     * method does not actaully need to transform the SVGGraphics into an
     * SVG doc.
     */
    public void drawShape(SVGGraphics2D g2d,int ipart,int jpart) {
	imagedoc=updateBaseDoc(imagedoc,vf.getTheDoc());
	vf.appendFragToDoc(vf.thecanvas,imagedoc);
    }

    public int getXPart() { return 0; }
    public int getYPart() { return 0; }
}
