package WebFlow.Collaborator; 

import WebFlow.event.*; 
import WebFlow.*; 
import java.util.*; 
import java.io.*;
import java.lang.reflect.*;
import java.net.*;


public class CollaboratorImpl extends WebFlow.BeanContextChildSupport
                  implements CollaboratorOperations
{
    String msg_; 
    org.omg.CORBA.Object peer; 
    String filepath = "/a/birch.csit.fsu.edu/shared/home/cyoun/GATEWAY/apache1.3.12/WWW/GOW/WEB-INF/src/Servlets/download.bin";
    FileInputStream fis;
    int blksize;
    boolean eventCaptureFlag;
    String UserId;
    int collab_mode;
    boolean isMaster;
   
    public CollaboratorImpl(org.omg.CORBA.Object peer , String msg) 
	throws WebFlow.NullPointerException
    {
	super(peer); 
	this.peer = peer ; 
	msg_ = msg ;
	blksize= 4 * 1024; 
	eventCaptureFlag = false;
	UserId = null;
	collab_mode = 0;
	isMaster = false;
    }   

    public String test() {
	return "Collaborator module is up!!!!!!!";
    }

    public void getEvent(org.omg.CORBA.Object to)
    {
	System.out.println("getEvent is called: CollaboratorImpl"); 
	
	collEvent gevt = collEventHelper.narrow(to); 	
	String eType = gevt.eventType();
	System.out.println("getEvent:Event Type: "+eType);
	setEventFlag(true);
	System.out.println("getEvent:UserID: "+getUserId());	
    }    

    public void writeFile(String urlname){

	try {
	    URL url = new URL(urlname);
	    try {
		FileOutputStream fout = new FileOutputStream(filepath);

		try {
		    InputStream in = url.openStream();
		    byte[] buf = new byte[blksize];  // 4K buffer
		    int bytesRead;
		    while ((bytesRead = in.read(buf)) != -1) {
			fout.write(buf, 0, bytesRead);
		    }
		} catch (Exception e) {
		    System.out.println("writeFile:"+e);
		}
		fout.flush();
		fout.close();
	    } catch (Exception e) {
		System.out.println("writeFile:"+e);
	    }
	}catch (MalformedURLException e) {
	    System.out.println("writeFile:"+urlname);
	    System.out.println("writeFile:"+e);
	}
    }

    public boolean readFile(String filename) {
	// A FileInputStream is for bytes
	fis = null;
	try {
	    fis = new FileInputStream(filepath);
	}catch(Exception e) {
	    System.out.println("File Open Exception");
	    System.out.println(e);
	    return false;
	}
	return true;
    }

    public byte[] getBinaryBlock() {
	
	byte[] a = null; 
	byte[] buf = new byte[blksize];

	try {
	    System.out.println("getBinaryBlock ....."+getUserId());
	    if(fis==null) System.out.println("fis is null");
	    int icount = fis.read(buf);
	    System.out.println("icount="+icount);
	    if(icount == -1) {
		a = new byte[0];
		if(fis != null) fis.close();
	    }
	    else { 
		if(icount == blksize) a=buf;  //buffer filled
		else {
		    a = new byte[icount];
		    for(int i =0; i < icount; i++) a[i]=buf[i];
		}
	    }
	}
	catch(Exception e) {
	    System.out.println("IO Exception in getBlock");
	    System.out.println(e);
	}
	return a;    
    }

    public void runfireEvent(String eventID, String eventType) {
	collEvent cevt = new collEventImpl(getBeanContextChildPeer(),
					       eventType);
	fireEvent( eventID , cevt); 
	System.out.println("Event Generated.....");
    }

    public void setEventFlag(boolean flag) {
	eventCaptureFlag = flag;
    }

    public void setUserId(String username) {
	System.out.println("UserID: "+username);
	UserId = username;
    }

    public void setIsMaster(boolean flag) {
	System.out.println("Master/Slave setting: "+flag);
	isMaster = flag;
    }

    public void setCollabMode(int mode) {
	System.out.println("Collaborative Mode: "+mode);
	collab_mode = mode;
    }

    public boolean getEventFlag() {
	return eventCaptureFlag;
    }

    public String getUserId() {
	return UserId;
    }

    public boolean getIsMaster() {
	return isMaster;
    }

    public int getCollabMode() {
	return collab_mode;
    }

}

